c Inits matrix of i-th 1mode VSCF hamiltonian in the basis of LHOs.
c For calculating the 1mode averaged VSCF potential Vi=<j.neq.i|V|j.neq.i>, 
c the overlaps <a|q^x|a> are already precomputed (mean_q1234).
c
c
      subroutine init_1mode_vscf_hamiltonian(i,vscf_nbase,nnmodes,
     1qff2,qff3,qff4,mean_q1234,hamiltonian)
      include 'common.h'
c In:
      integer i,nnmodes,vscf_nbase
      real*8 qff2(nnmodes), qff3(nnmodes,nnmodes,nnmodes)
      real*8 qff4(nnmodes,nnmodes,nnmodes),mean_q1234(nnmodes,4)
c Out:
      real*8 hamiltonian(vscf_nbase,vscf_nbase)
      
      real*8 v(5)	      ! The one-mode potential expanded as polynom: 
			      !	    V_i(q)=v(5)*q**4 + v(4)*q**3 + v(3)*q**2 + v(2)*q + v(1)
      real*8 q2,q3,q4,q5
      integer imu,inu,mu,nu   ! Indexes over the VSCF base LHO functions 


      call init_1mode_vscf_potential(i,nnmodes,qff2,qff3,
     1qff4,mean_q1234,v)


      ! DEBUG: will we get the same result with numerov or fgh methods?
      ! Not EXACTLY: 
      !	    diagonalization: 1.02202243  0.342618242
      !	    fgh            : 1.02334969  0.342599214
      !	    numerov        : 1.02476349  0.342737126
      ! Can this be the cause why we do not get the model potentials right?
      ! (Tested on christoffel potential: ../docvib/model-potentials.html)
      !
      !	     v(1) = 0
      !	     write(log_fd,20)i,(v(imu)*(qff2(i)**((imu-1)/2d0)),imu=1,5)
      !20    format('potential ',I3,': ',D25.15,'+',D25.15,'*$x +',D25.15,'*$x**2 +',D25.15,
      !     &	    '*$x**3 +',D25.15,'*$x**4')


c      write(*,*)i,v

      do 10 imu=1,vscf_nbase
      do 10 inu=1,imu
	    mu = imu-1
	    nu = inu-1

	    hamiltonian(imu,inu) = 0d0

	    if (mu.eq.nu) then
		  ! Kinetic part
		  hamiltonian(imu,imu) = hamiltonian(imu,imu) +
     1             (dble(mu)+0.5d0)*0.5d0 *qff2(i)

		  q3 = (dble(mu)+0.5d0)
		  q5 = 0.75d0 * dble(2*mu*mu + 2*mu + 1)

		  hamiltonian(imu,imu)=hamiltonian(imu,imu)+q5*v(5)+
     1            q3*v(3) + v(1)
    
	    else if (mu.eq.nu+1) then

		  q2 = sqrt(dble(mu)*0.5d0)
		  q4 = dble(3*mu)*sqrt(dble(mu)/8.0d0)

		  hamiltonian(imu,inu)=hamiltonian(imu,inu) + q4*v(4)
     1            + q2*v(2)
		  
	    else if (mu.eq.nu+2) then
	    
		  ! Kinetic part
		  hamiltonian(imu,inu) = hamiltonian(imu,inu) -
     1           sqrt(dble(mu*(mu-1)))*0.25d0 *qff2(i)

		  q3 = 0.5d0*sqrt(dble((nu+1)*(nu+2)))
		  q5 = dble(2*nu+3) * q3

		  hamiltonian(imu,inu)=hamiltonian(imu,inu) + q5*v(5) 
     1             + q3*v(3)
		  
	    else if (mu.eq.nu+3) then
	    
		  q4 = sqrt(dble(mu*(mu-1)*(mu-2))/8.0d0)

		  hamiltonian(imu,inu) = hamiltonian(imu,inu) + q4*v(4)
		  
	    else if (mu.eq.nu+4) then

		  q5 = 0.25d0 * sqrt(dble(mu*(mu-1)*(mu-2)*(mu-3)))

		  hamiltonian(imu,inu) = hamiltonian(imu,inu) + q5*v(5)
	    end if

	    hamiltonian(inu,imu) = hamiltonian(imu,inu)
10    continue
     
      end 

