c Calculates the i-th averaged 1mode VSCF potential Vi=<j.neq.i|V|j.neq.i>.
c
      subroutine init_1mode_vscf_potential(i,nnmodes,qff2,
     1qff3,qff4,mean_q1234,v)
      include 'common.h'
c In:
      integer i, nnmodes
      real*8 qff2(nnmodes), qff3(nnmodes,nnmodes,nnmodes)
      real*8 qff4(nnmodes,nnmodes,nnmodes)
      real*8 mean_q1234(nnmodes,4)
c Out:
      real*8 v(5)	      ! The one-mode potential expanded as polynom: 
			      !	    V_i(q)=v(5)*q**4 + v(4)*q**3 + v(3)*q**2 + v(2)*q + v(1)

      integer k,j,l
      real*8 vjj,vijk,vijj,viij,vjjj,vjjk,vjkl
      real*8 viiij,viijk,viijj,vijjk,vijjj,vjjkl,vjjjk,vjjjj,vjjkk

      vjj   = 0d0	      ! sum V_jj <q_j^2>
      
      vijk  = 0d0	      ! sum V_ijk <q_j> <q_k>
      vijj  = 0d0	      ! sum V_ijj <q_j^2>
      viij  = 0d0	      ! sum V_iij <q_j>
      vjjj  = 0d0	      ! sum V_jjj <q_j^3>
      vjjk  = 0d0	      ! sum V_jjk <q_j^2> <q_k>
      vjkl  = 0d0	      ! sum V_jkl <q_j> <q_k> <q_l>

      viiij = 0d0	      ! sum V_iiij <q_j>
      viijk = 0d0	      ! sum V_iijk <q_j> <q_k>
      viijj = 0d0	      ! sum V_iijj <q_j^2>
      vijjk = 0d0	      ! sum V_ijjk <q_j^2> <q_k>
      vijjj = 0d0	      ! sum V_ijjj <q_j^3>
      vjjkl = 0d0	      ! sum V_jjkl <q_j^2> <q_k> <q_l>
      vjjjk = 0d0	      ! sum V_jjjk <q_j^3> <q_k>
      vjjjj = 0d0	      ! sum V_jjjj <q_j^4>
      vjjkk = 0d0	      ! sum V_jjkk <q_j^2> <q_k^2>


      
      do 10 j=1,nnmodes
	    if (j.eq.i) goto 10

	    vjj = vjj + qff2(j)*mean_q1234(j,2)

	    viij = viij + qff3(j,i,i)*mean_q1234(j,1)
	    vijj = vijj + qff3(j,j,i)*mean_q1234(j,2)
	    vjjj = vjjj + qff3(j,j,j)*mean_q1234(j,3)

	    viiij = viiij + qff4(j,i,i)*mean_q1234(j,1)
	    viijj = viijj + qff4(i,i,j)*mean_q1234(j,2)
	    vijjj = vijjj + qff4(i,j,j)*mean_q1234(j,3)
	    vjjjj = vjjjj + qff4(j,j,j)*mean_q1234(j,4)
	    
c	    write(*,*)j,i,i,i,' .. ',qff4(j,i,i)*mean_q1234(j,1)*(4d0/24d0)
c	    write(*,*)i,i,j,j,' .. ',qff4(i,i,j)*mean_q1234(j,2)*(6d0/24d0)
c	    write(*,*)qff4(i,i,j),mean_q1234(j,2)
c	    write(*,*)i,j,j,j,' .. ',qff4(i,j,j)*mean_q1234(j,3)*(4d0/24d0)
c	    write(*,*)j,j,j,j,' .. ',qff4(j,j,j)*mean_q1234(j,4)*(1d0/24d0)

	    do 20 k=1,nnmodes
	  if (k.eq.j) goto 20
	  if (k.eq.i) goto 20

	  vijk = vijk + qff3(k,j,i)*mean_q1234(j,1)*mean_q1234(k,1)
	  vjjk = vjjk + qff3(k,j,j)*mean_q1234(j,2)*mean_q1234(k,1)

	  viijk = viijk + qff4(j,k,i)*mean_q1234(j,1)*mean_q1234(k,1)
          vijjk = vijjk + qff4(i,k,j)*mean_q1234(j,2)*mean_q1234(k,1)
          vjjjk = vjjjk + qff4(k,j,j)*mean_q1234(j,3)*mean_q1234(k,1)
          vjjkk = vjjkk + qff4(j,j,k)*mean_q1234(j,2)*mean_q1234(k,2)

c		  write(*,*)j,k,i,i,' .. ',(6d0/24d0)*qff4(j,k,i)*mean_q1234(j,1)*mean_q1234(k,1)
c		  write(*,*)i,k,j,j,' .. ',(4d0/24d0)*qff4(i,k,j)*mean_q1234(j,2)*mean_q1234(k,1)
c		  write(*,*)k,j,j,j,' .. ',(4d0/24d0)*qff4(k,j,j)*mean_q1234(j,3)*mean_q1234(k,1)
c		  write(*,*)j,j,k,k,' .. ',(3d0/24d0)*qff4(j,j,k)*mean_q1234(j,2)*mean_q1234(k,2)

		  do 30 l=1,nnmodes
			if (l.eq.i) goto 30
			if (l.eq.j) goto 30
			if (l.eq.k) goto 30

		vjkl = vjkl + qff3(l,k,j)*mean_q1234(j,1)*
     1          mean_q1234(k,1)*mean_q1234(l,1)
		vjjkl = vjjkl + qff4(k,l,j)*mean_q1234(j,2)*
     1          mean_q1234(k,1)*mean_q1234(l,1)

c			write(*,*)k,l,j,j,' .. ',(6d0/24d0)*qff4(k,l,j)*mean_q1234(j,2)*mean_q1234(k,1)*mean_q1234(l,1)

30    continue
20    continue
10    continue

    

      v(1) = 0.5d0*vjj
      v(2) = 0d0
      v(3) = 0.5d0*qff2(i)
      v(4) = 0d0
      v(5) = 0d0

      v(1) = v(1) + (1d0/6d0)*(vjjj + 3d0*vjjk + vjkl)
      v(2) = v(2) + (3d0/6d0)*(vijk + vijj)
      v(3) = v(3) + (3d0/6d0)*viij
      v(4) = v(4) + (1d0/6d0)*qff3(i,i,i)

      v(1) = v(1)+(1d0/24d0)*(6d0*vjjkl + 4d0*vjjjk + 3d0*vjjkk + vjjjj)
      v(2) = v(2) + (4d0/24d0)*(3d0*vijjk + vijjj)
      v(3) = v(3) + (6d0/24d0)*(viijk + viijj)
      v(4) = v(4) + (4d0/24d0)*viiij
      v(5) = v(5) + (1d0/24d0)*qff4(i,i,i)

c      write(*,*)(6d0/24d0)*(viijk + viijj)
c      call exit_nicely()
      

c      write(*,*)'ignoring constant term: ',v(0)
      !v(1) = 0	  ! Neglect the constant term of the potential.
		  !	The VSCF+PT1 result will be the same, only the
		  !	equation for E(VSCF)
		  !	      \sum\eps_i + (1-n)*<0|V|0> =<0|T+V|0>
		  !	will not be valid, because \eps_i will be smaller.

      end


