      FUNCTION AME(S1,IR,IM,S2)
C     <S1|q^ir p^im|S2>, real or imaginary parts given, without 1/sqrt(2)
C     with each power of q or p
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      AME=0.0d0
      IF(IR.EQ.0)THEN
       IF(IM.EQ.0)THEN
C       <S1|S2>
        IF(S1.EQ.S2)AME=1.0d0
        RETURN
       ENDIF
       IF(IM.EQ.1)THEN
C       <S1|p|S2>
        IF(S2.EQ.S1+1)AME=-DSQRT(DBLE(S2))
        IF(S1.EQ.S2+1)AME= DSQRT(DBLE(S1))
        RETURN
       ENDIF
       IF(IM.EQ.2)THEN
C       <S1|p^2|S2>
        IF(S2.EQ.S1+2)AME=-DSQRT(DBLE((S1+1)*(S1+2)))
        IF(S1.EQ.S2+2)AME=-DSQRT(DBLE((S2+1)*(S2+2)))
        IF(S1.EQ.S2)AME=DBLE(2*S1+1)
        RETURN
       ENDIF
      ENDIF
      IF(IR.EQ.1)THEN
       IF(IM.EQ.0)THEN
C       <S1|q|S2>
        IF(S2.EQ.S1+1)AME=DSQRT(DBLE(S2))
        IF(S1.EQ.S2+1)AME=DSQRT(DBLE(S1))
        RETURN
       ENDIF
       IF(IM.EQ.1)THEN
C       <S1|qp|S2>
        IF(S2.EQ.S1+2)AME=-DSQRT(DBLE((S1+1)*(S1+2)))
        IF(S1.EQ.S2+2)AME= DSQRT(DBLE((S2+1)*(S2+2)))
        IF(S1.EQ.S2)  AME=1.0d0
        RETURN
       ENDIF
       IF(IM.EQ.2)THEN
C       <S1|qp^2|S2>
        IF(S2.EQ.S1+3)AME=-DSQRT(DBLE((S1+1)*(S1+2)*(S1+3)))
        IF(S1.EQ.S2+3)AME=-DSQRT(DBLE((S2+1)*(S2+2)*(S2+3)))
        IF(S2.EQ.S1+1)AME= DSQRT(DBLE(S1+1))*(S1+3)
        IF(S1.EQ.S2+1)AME= DSQRT(DBLE(S2+1))*(S2-1)
        RETURN
       ENDIF
      ENDIF
      IF(IR.EQ.2)THEN
       IF(IM.EQ.0)THEN
C       <S1|q^2|S2>
        IF(S2.EQ.S1+2)AME=DSQRT(DBLE((S1+1)*(S1+2)))
        IF(S1.EQ.S2+2)AME=DSQRT(DBLE((S2+1)*(S2+2)))
        IF(S1.EQ.S2)  AME=DBLE(2*S2+1)
        RETURN
       ENDIF
       IF(IM.EQ.1)THEN
C       <S1|q^2p|S2>
        IF(S2.EQ.S1+3)AME=-DSQRT(DBLE(S2*(S2-1)*(S2-2)))
        IF(S1.EQ.S2+3)AME= DSQRT(DBLE(S1*(S1-1)*(S2-2)))
        IF(S2.EQ.S1+1)AME=-DBLE(S1-1)*DSQRT(dble(S1+1))
        IF(S1.EQ.S2+1)AME= DBLE(S2+3)*DSQRT(dble(S2+1))
        RETURN
       ENDIF
       IF(IM.EQ.2)THEN
C       <S1|q^2 p^2|S2>
        IF(S2.EQ.S1-4)AME=-DSQRT(DBLE(S1*(S1-1)*(S1-2)*(S1-3)))
        IF(S1.EQ.S2-4)AME=-DSQRT(DBLE(S2*(S2-1)*(S2-2)*(S2-3)))
        IF(S2.EQ.S1+2)AME= 4.0d0*DSQRT(DBLE(S2*(S2-1)))
        IF(S1.EQ.S2+2)AME=-4.0d0*DSQRT(DBLE(S1*(S1-1)))
        IF(S2.EQ.S1)  AME= DBLE(2*S1*(S1+1)-1)
        RETURN
       ENDIF
      ENDIF
      CALL REPORT('Matrix element of unknown kind in AME')
      RETURN
      END
