      subroutine calc_vscfpt1_energy(nnmodes,vscf_nbase,func,qff2,
     1qff3,qff4,energy)
c The VSCF+PT1 energy is calculated simply as <a|T+V|a>.
c     (It should be equal to \sum\eps_i + (1-n)*<a|V|a> as long
c     as the constant term v(1) in 1mode potential is included.)
c     Note: The relation is valid only after selfconsistency is 
c     reached.
c
      include 'common.h'
c In:
      integer nnmodes,vscf_nbase
      real*8 func(vscf_nbase,nnmodes),qff2(nnmodes), 
     1qff3(nnmodes,nnmodes,nnmodes)
      real*8 qff4(nnmodes,nnmodes,nnmodes)
c Out:
      real*8 energy

      real*8 eT,eV,mean_q1234(nnmodes,4)


      call calc_vscf_Tenergy(nnmodes,vscf_nbase,func,qff2,eT)

      call calc_vscf_mean_q1234(vscf_nbase,nnmodes,func,mean_q1234)
      call calc_vscfpt1_potential(nnmodes,mean_q1234,qff2,qff3,qff4,eV)

c      write(log_fd,*)'vscfpt1_e mean_q:'
c      do i=1,nnmodes
c	    write(log_fd,*)i,(mean_q1234(i,j),j=1,4)
c      end do

      energy = eT + eV
 

c See the above comment, if  eT+n*eV != \sum\eps_i
c
c      write(log_fd,*)'eT=',eT, ' eV=',eV, '  eT+n*eV=',eT+nnmodes*eV,'  eT+eV=',eT+eV
c      write(*,*)'eT=',eT, ' eV=',eV, '  eT+n*eV=',eT+nnmodes*eV,'  eT+eV=',eT+eV

      end 



