      subroutine calc_vscfpt1_potential(nnmodes,mean_q1234,qff2,qff3,
     1qff4,energy)
c Calculate VSCF potential energy <a|V|a>. The potential is expanded
c in Taylor series, harmonic,cubic and semidiagonal quartic part is given
c in the arrays qff2,3,4. The array mean_q1234 contains the overlaps
c <a|q^x|a>, x=1..4. 
c The one-mode functions of |a> = prod_i a_i(q_i) are assumed to be normalized.
c
c
      include 'common.h'
c In:
      integer nnmodes
      real*8 qff2(nnmodes), qff3(nnmodes,nnmodes,nnmodes)
      real*8 qff4(nnmodes,nnmodes,nnmodes),mean_q1234(nnmodes,4)
c Out:
      real*8 energy

      integer i,j,k


      energy = 0d0

      do i=1,nnmodes
	    energy = energy + 0.5d0 *qff2(i)    *mean_q1234(i,2)
	    energy = energy + (1d0/6d0) *qff3(i,i,i)*mean_q1234(i,3)
	    energy = energy + (1d0/24d0)*qff4(i,i,i)*mean_q1234(i,4)

	    do 20 j=1,nnmodes
		  if (j.eq.i) goto 20

          energy = energy +
     1 (3d0/6d0) *qff3(i,j,j)*mean_q1234(i,1)*mean_q1234(j,2)
	  energy = energy +
     1  (3d0/24d0)*qff4(i,i,j)*mean_q1234(i,2)*mean_q1234(j,2)
	  energy = energy +
     1 (4d0/24d0)*qff4(i,j,j)*mean_q1234(i,1)*mean_q1234(j,3)

		  do 30 k=1,nnmodes
			if (k.eq.j) goto 30
			if (k.eq.i) goto 30
			
			      energy = energy + (1d0/6d0)*qff3(i,j,k)
     &		    *mean_q1234(i,1)*mean_q1234(j,1)*mean_q1234(k,1)
			      energy = energy + (6d0/24d0)*qff4(i,j,k)
     &		    *mean_q1234(i,1)*mean_q1234(j,1)*mean_q1234(k,2)
30		  continue
20	    continue
      end do

      end 



