      IMPLICIT NONE
      
      common  log_fd,verbose,fdpool
      integer maxfd,get_fd
      parameter (maxfd=20)
      integer log_fd,fdpool(maxfd)
      logical verbose
      logical binary_files
      parameter (binary_files=.true.)

      real*8 pi
      parameter (pi=3.14159265358979323846d0)
      
      real*8 angstrom_to_bohr
      parameter (angstrom_to_bohr=1.8897261339d0)

      ! V2 in units [Hartree/Bohr**2/elmass]
      !	    --> sqrt(Hartree_to_Joul/elmass_to_kg)/Bohr_to_meter/2/pi/c
      real*8 V2sqrt_to_cminv
      parameter (V2sqrt_to_cminv=219474.6540729903d0)
      !parameter (V2sqrt_to_cminv=1d0) ! for debugging purposes

      real*8 cminv_to_JouleMol
      parameter (cminv_to_JouleMol=11.962656498d0)

      ! PLANCK*LIGHT_SPEED*MOL*1e-7
      real*8 cminv_to_MegaJoule
      parameter (cminv_to_MegaJoule=1.1962656498d-5)
      !parameter (cminv_to_MegaJoule=1d0)  ! for debugging purposes


      ! 1 Bohr-electron = 2.541746 Debye
      real*8 BohrElectron_to_Debye
      parameter (BohrElectron_to_Debye=2.541746d0)

      integer*4 GVIB_VSCF_NBASE,GVIB_VSCF_MAXITER,iopt
      common/iop/iopt(300)
      equivalence 
     1(GVIB_VSCF_NBASE,iopt(6)),(GVIB_VSCF_MAXITER,iopt(7))
      real*8 ropt,GVIB_VSCF_CLIMIT
      common/opt/ropt(100)
      equivalence (GVIB_VSCF_CLIMIT,ropt(2))
