      SUBROUTINE DOCQI(S,N,LP3,HW,N7,tol3,NCAN,ICAN)
c
c     docq in core
c
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      LOGICAL LP3,HW,lex
      include 'dimensions.h'
      DIMENSION S(NT3,N),A(NT3,NT3),ICAN(*)
      real*8,allocatable:: CX(:),CQ(:)
c     cx(3*NT0*3*NT0*3*NT0),cq(3*NT0*3*NT0*3*NT0)

      COMMON/CEM/e(NT3)
c
      call w36(' ')
      call w36('Docqi')
      call w36('^^^^^')

      write(6,6001)HW,N7,N
      write(3,6001)HW,N7,N
6001  format(' HW :',l9,/,
     1       ' N7 :',i9,/,
     1       '  N :',i9,/)

      inquire(file='CQQ.SCR.TXT',exist=lex)
      if(lex)then
       call w36(' CQQ.SCR.TXT found on disk, no transformation now')
       return
      endif
c
c     initialize CX:
      allocate(CX(1:n**3),stat=is)
      if(is.ne.0)call report('cannot allocate cx in docqi')
      write(6,*)'cx allocated'
      allocate(CQ(1:n**3),stat=is)
      if(is.ne.0)call report('cannot allocate cq in docqi')
      write(6,*)'cq allocated'
      N2=N*N
      call vz(cx,0.0d0,N2*N)
c
c     read-in sparse constants
      OPEN(4,FILE='SCR.33')
      ic=0
1     READ(4,*,END=5333)I,J,K,cx(i+(j-1)*N+(k-1)*N2)
      ic=ic+1
      goto 1
5333  close(4)
      write(6,*)ic,' cartesians read in'
      write(3,*)ic,' cartesians read in'
c
c     check projection
      call proj3(cx,NT3,n)
c
c     symmetrized cartesians (ijk=ikj=kij=kji=jki=jik)
      do 2 i=1,n
      do 2 j=i,n
      do 2 k=j,n
      indijk=i+(j-1)*n+(k-1)*n2
      indikj=i+(k-1)*n+(j-1)*n2
      indjik=j+(i-1)*n+(k-1)*n2
      indjki=j+(k-1)*n+(i-1)*n2
      indkji=k+(j-1)*n+(i-1)*n2
      indkij=k+(i-1)*n+(j-1)*n2
      cijk=cx(indijk)
      cikj=cx(indikj)
      ckij=cx(indkij)
      ckji=cx(indkji)
      cjki=cx(indjki)
      cjik=cx(indjik)
c     write(6,6777)i,j,k,cijk,cikj,cjik,cjki,ckji,ckij
c6777  format(3I3,6f10.6)
      average=(cijk+cikj+ckij+ckji+cjki+cjik)/6.0d0
      cx(indijk)=average
      cx(indikj)=average
      cx(indkij)=average
      cx(indkji)=average
      cx(indjki)=average
2     cx(indjik)=average
      write(6,*)'cx have beed symmetrized'
      write(3,*)'cx have beed symmetrized'
c
c     check projection
      call proj3(cx,NT3,n)
c
c     project rotational-translational invariance, use temporarily CQ for proj
      IF(LP3)THEN
       CALL DOMA(A,NT3,N,HW)
c
c      Ijk = AIi ijk
       WRITE(6,*)' first index'
       DO 52 JJ=1,N
       DO 52 KK=1,N
       INDJK=(JJ-1)*N+(KK-1)*N2
       DO 52 I=1,N
       SUM=0.0d0
       DO 53 II=1,N
53     SUM=SUM+A(I,II)*cx(II+INDJK)
52     cq(I+INDJK)=SUM
c
c      IJk= AJj Ijk
       WRITE(6,*)' second index'
       DO 54 I=1,N
       DO 54 KK=1,N
       INDIK=I+(KK-1)*N2
       DO 54 J=1,N
       SUM=0.0d0
       DO 55 JJ=1,N
55     SUM=SUM+A(J,JJ)*cq((JJ-1)*N+INDIK)
54     cx((J-1)*N+INDIK)=SUM
c
c      IJK= AKk IJk
       WRITE(6,*)' third index'
       DO 56 I=1,N
       DO 56 J=1,N
       INDIJ=I+(J-1)*N
       DO 56 K=1,N
       SUM=0.0d0
       DO 57 KK=1,N
57     SUM=SUM+A(K,KK)*cx((KK-1)*N2+INDIJ)
56     cq((K-1)*N2+INDIJ)=SUM
c
       do 58 i=1,n**3
58     cx(i)=cq(i)
c
       write(6,*)' space coordinates have been projected out '
      ENDIF
c
c     check projection
      call proj3(cx,NT3,n)

c
c     transformation to normal mode coordinates
      write(6,*)'transforming CQ'
c
c     Ijk, I,j<=k gather in CQ:  Ijk = SiI ijk
      do 1001 jj=1,N
      do 1001 kk=jj,N
      ind =(jj-1)*N+(kk-1)*N2
      indp=(kk-1)*N+(jj-1)*N2
      do 1001 I=N7,N
      sum=0.0d0
      do 1002 ii=1,N
1002  sum=sum+CX(ii+ind)*S(ii,I)
      CQ(I+indp)=sum
1001  CQ(I+ind)=sum
      write(6,*)'first index '
c
c     IJk, gather in CX IJK = SjJ Ijk
      do 2001 I=N7,N
      do 2001 kk=1,N
      indk =I+(kk-1)*N2
      do 2001 J=N7,N
      sum=0.0d0
      do 2002 jj=1,N
2002  sum=sum+CQ((jj-1)*N+indk)*S(jj,J)
2001  CX((J-1)*N+indk)=sum
      write(6,*)'second index '
c
c     IJK=skK IJk
      NINDC=0
      do 3001 I=N7,N
      do 3001 J=I,N
      indIJ=I+(J-1)*N
      do 3001 K=J,N
      NINDC=NINDC+1
      sum=0.0d0
      do 3002 kk=1,N
3002  sum=sum+CX(indIJ+(kk-1)*N2)*S(kk,K)
3001  CQ(indIJ+(K-1)*N2)=sum
      write(6,*)'third index NINDC = ',NINDC
      WRITE(6,*)'transformation finished'
      WRITE(6,*)'transformation to normal modes finished'
c
c     write sparse cubics
      open(23,file='CQQ.SCR.TXT')
      NQ=0
      NQT=0
      cm=219470.0d0

      do 62 i=N7,N
      do 62 j=i,N
      do 62 k=j,N
      cqau=cq(i+(j-1)*N+(k-1)*N2)
      cqcn=cqau/sqrt(abs(e(i)*e(j)*e(k)))
      cqcm=cqcn*cm
      if(abs(cqcm).ge.tol3)then
       write(23,3333)I,J,K,cqcn,cqcm
3333   format(3I5,G16.8,' ',f9.1)
       nq=nq+1
      endif
62    nqt=nqt+1
      close(23)
      write(6,6000)nqt,nq,tol3
      write(3,6000)nqt,nq,tol3
6000  format('Number of normal cubics ',I10,/,
     1       'Selected                ',I10,/,
     1       'Limit                   ',F10.7,/,
     1       'Writen in CQQ.SCR.TXT')
c
      deallocate(CX)
      deallocate(CQ)

      RETURN
      END
c
      subroutine proj3(cx,NT3,n)
      real*8 cx(NT3*NT3*NT3),X,Y,Z
      integer*4 n,L
c
      X=0.0d0
      Y=0.0d0
      Z=0.0d0
      DO 43 L=2,N/3
      X=X-CX(3*L-2)
      Y=Y-CX(3*L-1)
43    Z=Z-CX(3*L  )
      WRITE(3,333)X,Y,Z,CX(1),CX(2),CX(3)
      WRITE(6,333)X,Y,Z,CX(1),CX(2),CX(3)
333   FORMAT(/,' Sum rule for cubics - X   Y    Z',/,
     1 1X,3F15.10,/,1X,3F15.10,/,/)
      return
      end
