      SUBROUTINE DOD2QI(S,N,LP4,HW,N7,tol3)
c     in core  transformation of all quartics from cartesian to internal
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      LOGICAL LP4,HW,lex
      include 'dimensions.h'
      PARAMETER (N40=6200000)
      DIMENSION S(NT3,N),cq(NT3),A(NT3,NT3),iu(24)
      real*8,allocatable::CX(:)
      COMMON/CEM/e(NT3)
c
      call w36('DOD2QI in core called')
      inquire(file='D42Q.SCR',exist=lex)
      if(lex)then
       call w36(' D42Q.SCR found on disk, no transformation now')
       return
      endif
      inquire(file='D42C.SCR',exist=lex)
      if(.not.lex)then
       call w36(' D42C.SCR not found')
       return
      endif
c
c     initialize CX:
      allocate(CX(1:N**4),stat=is)
      if(is.ne.0)call report('cannot allocate CX')
      call vz(CX,0.0d0,N**4)

      N2=N**2
      N3=N**3
c
c     read-in sparse constants
      IF(HW)OPEN(41,FILE='D42C.SCR.TXT')
      OPEN(4,FILE='D42C.SCR',FORM='UNFORMATTED')
      ic=0
1     READ(4,END=5333,ERR=5333)i,j,k,l,con
      if(HW)write(41,4002)i,j,k,l,con
4002  format(4i5,G15.6)
      iu(1 )=i+N*(j-1+N*(k-1+N*(l-1)))
      iu(2 )=i+N*(j-1+N*(l-1+N*(k-1)))
      iu(3 )=i+N*(k-1+N*(j-1+N*(l-1)))
      iu(4 )=i+N*(k-1+N*(l-1+N*(j-1)))
      iu(5 )=i+N*(l-1+N*(j-1+N*(k-1)))
      iu(6 )=i+N*(l-1+N*(k-1+N*(j-1)))
      iu(7 )=j+N*(i-1+N*(k-1+N*(l-1)))
      iu(8 )=j+N*(i-1+N*(l-1+N*(k-1)))
      iu(9 )=j+N*(k-1+N*(i-1+N*(l-1)))
      iu(10)=j+N*(k-1+N*(l-1+N*(i-1)))
      iu(11)=j+N*(l-1+N*(i-1+N*(k-1)))
      iu(12)=j+N*(l-1+N*(k-1+N*(i-1)))
      iu(13)=k+N*(i-1+N*(j-1+N*(l-1)))
      iu(14)=k+N*(i-1+N*(l-1+N*(j-1)))
      iu(15)=k+N*(j-1+N*(i-1+N*(l-1)))
      iu(16)=k+N*(j-1+N*(l-1+N*(i-1)))
      iu(17)=k+N*(l-1+N*(i-1+N*(j-1)))
      iu(18)=k+N*(l-1+N*(j-1+N*(i-1)))
      iu(19)=l+N*(i-1+N*(j-1+N*(k-1)))
      iu(20)=l+N*(i-1+N*(k-1+N*(j-1)))
      iu(21)=l+N*(j-1+N*(i-1+N*(k-1)))
      iu(22)=l+N*(j-1+N*(k-1+N*(i-1)))
      iu(23)=l+N*(k-1+N*(i-1+N*(j-1)))
      iu(24)=l+N*(k-1+N*(j-1+N*(i-1)))
      do 3 ii=1,24
      if(iu(ii).gt.N40)then
       write(6,*)i,j,k,l,ii,iu(ii),con
       call report('N40 buffer dimension exceeded')
      endif
3     CX(iu(ii))=con
      ic=ic+1
      goto 1
5333  continue
      write(6,*)ic,' cartesians read in'
      write(3,*)ic,' cartesians read in'
      if(HW)close(41)
      close(4)
c
      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      do 2 ia=2,N/3
      sx=sx+CX(1+3*(ia-1))
      sy=sy+CX(2+3*(ia-1))
2     sz=sz+CX(3+3*(ia-1))
      write(6,6009)sx,sy,sz,CX(1),CX(2),CX(3)
      write(3,6009)sx,sy,sz,CX(1),CX(2),CX(3)
6009  format('Sum rule:',/,3f10.5,/,3f10.5)
      if(LP4)then
       write(6,*)'projecting zero vibrations'
       CALL DOMA(A,NT3,N,HW)
       call matr4(A,NT3,N,CX,cq,1)
       call w36(' space coordinates have been projected out ')
      endif
      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      do 4 ia=2,N/3
      sx=sx+CX(1+3*(ia-1))
      sy=sy+CX(2+3*(ia-1))
4     sz=sz+CX(3+3*(ia-1))
      write(6,6019)sx,sy,sz,CX(1),CX(2),CX(3)
      write(3,6019)sx,sy,sz,CX(1),CX(2),CX(3)
6019  format('Sum rule:',/,3f10.5,/,3f10.5)
c
      write(6,*)'transforming to normal modes'
      do 59 jj=1,N
      do 59 kk=1,N
59    A(jj,kk)=S(kk,jj)

      call matr4(A,NT3,N,CX,cq,N7)
      call w36('transformation to normal modes finished')
c
c     write sparse quartics-all
      open(23,file='D42Q.SCR',form='unformatted')
      NQ=0
      NQT=0
      cm=219470.0d0
      do 62 i=N7,N
      do 62 j=i,N
      do 62 k=j,N
      do 62 l=k,N
      cqau=CX(i+(j-1)*N+(k-1)*N2+(l-1)*N3)
      cqcn=cqau/sqrt(abs(e(i)*e(j)*e(k)*e(l)))
      cqcm=cqcn*cm
      if(abs(cqcm).gt.tol3)then
       write(23)i,j,k,l,cqcn
       if(HW)write(3,3333)I,J,K,L,cqcm
3333   format(4I4,f15.2,f15.8)
       nq=nq+1
      endif
62    nqt=nqt+1
      close(23)
      write(6,6040)nqt,nq,tol3,'D42Q.SCR'
      write(3,6040)nqt,nq,tol3,'D42Q.SCR'
6040  format('Number of normal quartics ',I10,/,
     1       'Selected                  ',I10,/,
     1       'Limit                     ',F10.7,/,
     1       'Writen in ',a7)
c
c     write sparse quartics-diagonal
      open(23,file='DQQ.SCR.TXT')
      NQ=0
      NQT=0
      do 63 i=N7,N
      do 63 j=N7,N
      do 63 k=j,N
      cqau=CX(i+(i-1)*N+(j-1)*N2+(k-1)*N3)
      cqcn=cqau/sqrt(abs(e(i)*e(i)*e(j)*e(k)))
      cqcm=cqcn*cm
      if(abs(cqcm).gt.tol3)then
       write(23,4333)I,J,K,cqcn,cqcm
4333   format(3I6,G16.8,' ',f9.1)
       nq=nq+1
      endif
63    nqt=nqt+1
      close(23)
      write(6,6040)nqt,nq,tol3,'DQQ.SCR.TXT'
      write(3,6040)nqt,nq,tol3,'DQQ.SCR.TXT'

      deallocate(CX)

      RETURN
      END
c
      subroutine matr4(A,NT3,N,CX,cq,N7)
      implicit none
      integer*4 NT3,N,I,J,K,JJ,KK,LL,IND,N2,N3,II,L,N7
      real*8 A(NT3,NT3),CX(*),cq(*),SUM
      N2=N**2
      N3=N**3
      WRITE(6,*)' first index'
      DO 52 JJ=1,N
      DO 52 KK=1,N
      DO 52 LL=1,N
      IND=(JJ-1)*N+(KK-1)*N2+(LL-1)*N3
      DO 521 II=1,N
521   cq(II)=CX(II+IND)
      DO 52 I=N7,N
      SUM=0.0d0
      DO 53 II=1,N
53    SUM=SUM+A(I,II)*cq(II)
52    CX(I+IND)=SUM
c
      WRITE(6,*)' second index'
      DO 54 I=N7,N
      DO 54 KK=1,N
      DO 54 LL=1,N
      IND=I+(KK-1)*N2+(LL-1)*N3
      DO 541 JJ=1,N
541   cq(JJ)=CX((JJ-1)*N+IND)
      DO 54 J=N7,N
      SUM=0.0d0
      DO 55 JJ=1,N
55    SUM=SUM+A(J,JJ)*cq(JJ)
54    CX((J-1)*N+IND)=SUM
c
      WRITE(6,*)' third index'
      DO 56 I=N7,N
      DO 56 J=N7,N
      DO 56 LL=1,N
      IND=I+(J-1)*N+(LL-1)*N3
      DO 561 KK=1,N
561   cq(KK)=CX((KK-1)*N2+IND)
      DO 56 K=N7,N
      SUM=0.0d0
      DO 57 KK=1,N
57    SUM=SUM+A(K,KK)*cq(KK)
56    CX((K-1)*N2+IND)=SUM
c
      WRITE(6,*)' fourth index'
      DO 59 I=N7,N
      DO 59 J=N7,N
      DO 59 K=N7,N
      IND=I+(J-1)*N+(K-1)*N2
      DO 591 LL=1,N
591   cq(LL)=CX((LL-1)*N3+IND)
      DO 59 L=N7,N
      SUM=0.0d0
      DO 60 LL=1,N
60    SUM=SUM+A(L,LL)*cq(LL)
59    CX((L-1)*N3+IND)=SUM
      return
      end
