      SUBROUTINE DOD36I(S,N,LP4,HW,N7,tol3,lqfull,L37)
c     in core  transformation of two-atomic Cartesian quartics to internal
      implicit none
      integer*4 N
      include 'dimensions.h'
      LOGICAL LP4,HW,lex,lqfull,L37
      real*8,allocatable::cx(:),cc(:)
      real*8 S(NT3,NT3),tol3,cq(NT3),A(NT3,NT3),e,cm,cqcn,cqcm,
     1con,sx,sy,sz,cqau,sum
      integer*4 iu(24),N2,N3,N7,i,j,k,ic,NQ,NQT,l,ii,ia,ix,jj,kk,inm,
     1nat,ja,jx,ka,kx,la,lx
      COMMON/CEM/e(NT3)
c
      call w36('DOD36I called')
      if(L37)then
       inquire(file='SCR.37',exist=lex)
      else
       inquire(file='SCR.36',exist=lex)
      endif
      if(.not.lex)then
       call w36(' SCR.36 or SCR.37 not found')
       return
      endif
      N2=N**2
      N3=N**3
      nat=N/3
      cm=219470.0d0
      i=0
c
c     oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
c     complete normal mode quartic ff:
      if(lqfull)then
       call w36('Trafo to normal IJKL')
c      initialize full cx:
       allocate(cx(1:N**4),stat=i)
       if(i.ne.0)call report('cannot allocate cx in dod36i')
       call vz(cx,0.0d0,N**4)
       inquire(file='D42Q.SCR',exist=lex)
       if(lex)then
        call w36(' D42Q.SCR found on disk, no transformation now')
        return
       endif
       if(L37)call report('not yet implemented')
c
c      read-in sparse constants
       OPEN(4,FILE='SCR.36')
       ic=0
1      READ(4,*,END=5333,ERR=5333)i,j,k,l,con
       iu(1 )=i+N*(j-1+N*(k-1+N*(l-1)))
       iu(2 )=i+N*(j-1+N*(l-1+N*(k-1)))
       iu(3 )=i+N*(k-1+N*(j-1+N*(l-1)))
       iu(4 )=i+N*(k-1+N*(l-1+N*(j-1)))
       iu(5 )=i+N*(l-1+N*(j-1+N*(k-1)))
       iu(6 )=i+N*(l-1+N*(k-1+N*(j-1)))
       iu(7 )=j+N*(i-1+N*(k-1+N*(l-1)))
       iu(8 )=j+N*(i-1+N*(l-1+N*(k-1)))
       iu(9 )=j+N*(k-1+N*(i-1+N*(l-1)))
       iu(10)=j+N*(k-1+N*(l-1+N*(i-1)))
       iu(11)=j+N*(l-1+N*(i-1+N*(k-1)))
       iu(12)=j+N*(l-1+N*(k-1+N*(i-1)))
       iu(13)=k+N*(i-1+N*(j-1+N*(l-1)))
       iu(14)=k+N*(i-1+N*(l-1+N*(j-1)))
       iu(15)=k+N*(j-1+N*(i-1+N*(l-1)))
       iu(16)=k+N*(j-1+N*(l-1+N*(i-1)))
       iu(17)=k+N*(l-1+N*(i-1+N*(j-1)))
       iu(18)=k+N*(l-1+N*(j-1+N*(i-1)))
       iu(19)=l+N*(i-1+N*(j-1+N*(k-1)))
       iu(20)=l+N*(i-1+N*(k-1+N*(j-1)))
       iu(21)=l+N*(j-1+N*(i-1+N*(k-1)))
       iu(22)=l+N*(j-1+N*(k-1+N*(i-1)))
       iu(23)=l+N*(k-1+N*(i-1+N*(j-1)))
       iu(24)=l+N*(k-1+N*(j-1+N*(i-1)))
       do 3 ii=1,24
       if(iu(ii).gt.N**4)then
        write(6,*)i,j,k,l,ii,iu(ii),con
        call report('buffer dimension exceeded')
       endif
3      cx(iu(ii))=con
       ic=ic+1
       goto 1
5333   continue
       write(6,*)ic,' cartesians read in'
       write(3,*)ic,' cartesians read in'
       close(4)
c
       sx=0.0d0
       sy=0.0d0
       sz=0.0d0
       do 2 ia=2,N/3
       sx=sx+cx(1+3*(ia-1))
       sy=sy+cx(2+3*(ia-1))
2      sz=sz+cx(3+3*(ia-1))
       write(6,6009)sx,sy,sz,cx(1),cx(2),cx(3)
       write(3,6009)sx,sy,sz,cx(1),cx(2),cx(3)
6009   format('Sum rule:',/,3f10.5,/,3f10.5)
       if(LP4)then
        write(6,*)'projecting zero vibrations'
        CALL DOMA(A,NT3,N,HW)
        call matr4(A,NT3,N,cx,cq,1)
        call w36(' space coordinates have been projected out ')
        sx=0.0d0
        sy=0.0d0
        sz=0.0d0
        do 4 ia=2,N/3
        sx=sx+cx(1+3*(ia-1))
        sy=sy+cx(2+3*(ia-1))
4       sz=sz+cx(3+3*(ia-1))
        write(6,6009)sx,sy,sz,cx(1),cx(2),cx(3)
        write(3,6009)sx,sy,sz,cx(1),cx(2),cx(3)
       endif
c
       write(6,*)'transforming to normal modes'
       do 59 jj=1,N
       do 59 kk=1,N
59     A(jj,kk)=S(kk,jj)
       call matr4(A,NT3,N,cx,cq,N7)
       call w36('transformation to normal modes finished')
c
c      write sparse quartics-all
       open(23,file='D42Q.SCR',form='unformatted')
       NQ=0
       NQT=0
       do 62 i=N7,N
       do 62 j=i,N
       do 62 k=j,N
       do 62 l=k,N
       cqau=cx(i+(j-1)*N+(k-1)*N2+(l-1)*N3)
       cqcn=cqau/sqrt(abs(e(i)*e(j)*e(k)*e(l)))
       cqcm=cqcn*cm
       if(abs(cqcm).gt.tol3)then
        write(23)i,j,k,l,cqcn
        if(HW)write(3,3333)I,J,K,L,cqcm
3333    format(4I4,f15.2,f15.8)
        nq=nq+1
       endif
62     nqt=nqt+1
       close(23)
       write(6,6040)nqt,nq,tol3,'D42Q.SCR'
       write(3,6040)nqt,nq,tol3,'D42Q.SCR'
6040   format('Number of normal quartics ',I10,/,
     1        'Selected                  ',I10,/,
     1        'Limit                     ',F10.7,/,
     1        'Writen in ',a7)
c
c      write sparse quartics-diagonal
       open(23,file='DQQ.SCR.TXT')
       NQ=0
       NQT=0
       do 63 i=N7,N
       do 63 j=N7,N
       do 63 k=j,N
       cqau=cx(i+(i-1)*N+(j-1)*N2+(k-1)*N3)
       cqcn=cqau/sqrt(abs(e(i)*e(i)*e(j)*e(k)))
       cqcm=cqcn*cm
       if(abs(cqcm).gt.tol3)then
        write(23,2323)I,J,K,cqcn,cqcm
2323    format(3i6,G16.8,' ',f9.1)
        nq=nq+1
       endif
63     nqt=nqt+1
       close(23)
       write(6,6040)nqt,nq,tol3,'D42Q.SCR'
       write(3,6040)nqt,nq,tol3,'D42Q.SCR'
c     oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
      else
c      Semi-diagonal normal quartics   DIIJK=SIi SIi' SJj SKk dii'jk
c      use the cx string for normals:
       inquire(file='DQQ.SCR.TXT',exist=lex)
       if(lex)then
        call w36(' DQQ.SCR.TXT found on disk, no transformation now')
        return
       endif
       call w36('Trafo to normal IIJK')
       allocate(cx(1:N3),stat=i)
       if(i.ne.0)call report('cannot allocate cx in dod36i')
       call w36('cx allocated')
       call vz(cx,0.0d0,N3)
       call w36('cx filled')
c      read sparse ff and make the trafo immediately
c      non-redundant sets (i<=j<=k<=l):
       if(L37)then
        OPEN(4,FILE='SCR.37')
        call w36('SCR.37 opened')
       else
        OPEN(4,FILE='SCR.36')
        call w36('SCR.36 opened')
       endif
c
c      if enough memory, make a faster transformation
       allocate(cc(1:81*nat**3),stat=i)
       ic=0
       if(i.eq.0)then
c       FAST FAST FAST FAST FAST FAST FAST FAST FAST FAST FAST
        call w36('cc in dod36i allocated')
        call vz(cc,0.0d0,81*nat**3)
61      READ(4,*,END=63331,ERR=63331)i,j,k,l,con
        ic=ic+1
        if(i.eq.j)then
c        ii
         if(k.eq.i)then
c         ----------------------------------------------------------
c         iii
          if(l.eq.i)then
c          iiii
           call addcc(i,i,i,i,N,cc,con)
          else
c          iiil
           call addcc(i,i,i,l,N,cc,con)
           call addcc(i,i,l,i,N,cc,con)
           call addcc(i,l,i,i,N,cc,con)
           call addcc(l,i,i,i,N,cc,con)
          endif
         else
c         ----------------------------------------------------------
c         iik
          if(l.eq.k)then
c          iikk
           call addcc(i,i,k,k,N,cc,con)
           call addcc(i,k,i,k,N,cc,con)
           call addcc(k,i,i,k,N,cc,con)
           call addcc(i,k,k,i,N,cc,con)
           call addcc(k,i,k,i,N,cc,con)
           call addcc(k,k,i,i,N,cc,con)
          else
           if(l.eq.i)then
c           iiki  - in fact, this does not happen for i<=j=<k=<l
            goto 999
           else
c           iikl
            call addcc(i,i,k,l,N,cc,con)
            call addcc(i,k,i,l,N,cc,con)
            call addcc(k,i,i,l,N,cc,con)
            call addcc(i,k,l,i,N,cc,con)
            call addcc(k,i,l,i,N,cc,con)
            call addcc(k,l,i,i,N,cc,con)
            call addcc(i,i,l,k,N,cc,con)
            call addcc(i,l,i,k,N,cc,con)
            call addcc(l,i,i,k,N,cc,con)
            call addcc(i,l,k,i,N,cc,con)
            call addcc(l,i,k,i,N,cc,con)
            call addcc(l,k,i,i,N,cc,con)
           endif
          endif
c         ----------------------------------------------------------
         endif
        else
c       ============================================================
c        ij
         if(k.eq.j)then
c         ----------------------------------------------------------
c         ijj
          if(l.eq.j)then
c          ijjj
           call addcc(i,j,j,j,N,cc,con)
           call addcc(j,i,j,j,N,cc,con)
           call addcc(j,j,i,j,N,cc,con)
           call addcc(j,j,j,i,N,cc,con)
          else
           if(l.eq.i)then
c           ijji not allowed
            goto 999
           else
c           ijjl
            call addcc(i,j,j,l,N,cc,con)
            call addcc(i,j,l,j,N,cc,con)
            call addcc(i,l,j,j,N,cc,con)
            call addcc(j,j,i,l,N,cc,con)
            call addcc(j,j,l,i,N,cc,con)
            call addcc(j,i,l,j,N,cc,con)
            call addcc(j,l,i,j,N,cc,con)
            call addcc(j,l,j,i,N,cc,con)
            call addcc(j,i,j,l,N,cc,con)
            call addcc(l,j,j,i,N,cc,con)
            call addcc(l,j,i,j,N,cc,con)
            call addcc(l,i,j,j,N,cc,con)
           endif
          endif
         else
c         ----------------------------------------------------------
          if(k.eq.i)then
c          iji
           if(l.eq.i)then
c           ijii - in fact, this does not happen for i<=j=<k=<l
            goto 999
           else
            if(l.eq.j)then
c            ijij - not allowed for i<=j=<k=<l
             goto 999
            else
c            ijil - not allowed
             goto 999
            endif
           endif
c          ----------------------------------------------------------
          else
c          ijk
           if(l.eq.k)then
c           ijkk
            call addcc(i,k,k,j,N,cc,con)
            call addcc(i,k,j,k,N,cc,con)
            call addcc(i,j,k,k,N,cc,con)
            call addcc(k,k,i,j,N,cc,con)
            call addcc(k,k,j,i,N,cc,con)
            call addcc(k,i,j,k,N,cc,con)
            call addcc(k,j,i,k,N,cc,con)
            call addcc(k,j,k,i,N,cc,con)
            call addcc(k,i,k,j,N,cc,con)
            call addcc(j,k,k,i,N,cc,con)
            call addcc(j,k,i,k,N,cc,con)
            call addcc(j,i,k,k,N,cc,con)
           else
            if(l.eq.i)then
c            ijki not allowed
             goto 999
            else
             if(l.eq.j)then
c             ijkj not allwoed
              goto 999
             else
c             ijkl
              call addcc(i,j,k,l,N,cc,con)
              call addcc(i,j,l,k,N,cc,con)
              call addcc(i,k,j,l,N,cc,con)
              call addcc(i,k,l,j,N,cc,con)
              call addcc(i,l,j,k,N,cc,con)
              call addcc(i,l,k,j,N,cc,con)
              call addcc(j,i,k,l,N,cc,con)
              call addcc(j,i,l,k,N,cc,con)
              call addcc(j,k,i,l,N,cc,con)
              call addcc(j,k,l,i,N,cc,con)
              call addcc(j,l,i,k,N,cc,con)
              call addcc(j,l,k,i,N,cc,con)
              call addcc(k,i,j,l,N,cc,con)
              call addcc(k,i,l,j,N,cc,con)
              call addcc(k,j,i,l,N,cc,con)
              call addcc(k,j,l,i,N,cc,con)
              call addcc(k,l,i,j,N,cc,con)
              call addcc(k,l,j,i,N,cc,con)
              call addcc(l,i,j,k,N,cc,con)
              call addcc(l,i,k,j,N,cc,con)
              call addcc(l,j,i,k,N,cc,con)
              call addcc(l,j,k,i,N,cc,con)
              call addcc(l,k,i,j,N,cc,con)
              call addcc(l,k,j,i,N,cc,con)
             endif
            endif
           endif
          endif
c         ----------------------------------------------------------
         endif
        endif
        goto 61
63331   close(4)

        if(LP4)then
         call w36('Projecting zero modes')
         sx=0.0d0
         sy=0.0d0
         sz=0.0d0
         do 233 ia=2,N/3
         sx=sx+cc(1+3*(ia-1))
         sy=sy+cc(2+3*(ia-1))
233      sz=sz+cc(3+3*(ia-1))
         write(6,6009)sx,sy,sz,cc(1),cc(2),cc(3)
         write(3,6009)sx,sy,sz,cc(1),cc(2),cc(3)
         CALL DOMA(A,NT3,N,HW)
c
c        transform first two indices N**3 x N**1-2 scaling
         do 71 ii=1,N**3
71       cx(ii)=0.0d0
c
c        CX IIkl= SIi SIj Cijkl
c        consider only semi-diagonal constants that we have:

c        ia=ja
         do 131 ii=1,N
         do 131 ia=1,nat
         do 131 ix=1,3
         do 131 jx=1,3
         write(6,*)ii,ia,ix,jx,A(3*(ia-1)+ix,ii),A(3*(ia-1)+jx,ii)
         con=A(3*(ia-1)+ix,ii)*A(3*(ia-1)+jx,ii)
         do 131 k=1,N
         do 131 l=1,N
131      cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1   con*cc(nat*((9*ia+3*ix+jx-13)*nat*9+3*(k-1))+l)
         call w36('II   transformed_1')

         sx=0.0d0
         sy=0.0d0
         sz=0.0d0
         do 2333 ia=2,N/3
         sx=sx+cx(1+3*(ia-1))
         sy=sy+cx(2+3*(ia-1))
2333     sz=sz+cx(3+3*(ia-1))
         write(6,6009)sx,sy,sz,cx(1),cx(2),cx(3)
         write(3,6009)sx,sy,sz,cx(1),cx(2),cx(3)

c        ia=ka ia<>ja
         do 142 ka=1,nat
         do 142 ja=1,nat
         if(ja.ne.ka)then
          do 1412 jx=1,3
          j=3*(ja-1)+jx
          do 1412 ii=1,N
          do 1412 ix=1,3
          con=A(3*(ka-1)+ix,ii)*A(3*(ja-1)+jx,ii)
          do 1412 kx=1,3
          k=3*(ka-1)+kx
          do 1412 l=1,N
1412      cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1    con*cc(nat*((9*ka+3*ix+kx-13)*nat*9+3*(j-1))+l)
         endif
142      continue
         call w36('II   transformed_2')

         sx=0.0d0
         sy=0.0d0
         sz=0.0d0
         do 2334 ia=2,N/3
         sx=sx+cx(1+3*(ia-1))
         sy=sy+cx(2+3*(ia-1))
2334     sz=sz+cx(3+3*(ia-1))
         write(6,6009)sx,sy,sz,cx(1),cx(2),cx(3)
         write(3,6009)sx,sy,sz,cx(1),cx(2),cx(3)

c        ia=la ia<>ja ia<>ka
         do 153 la=1,nat
         do 153 ka=1,nat
         if(ka.ne.la)then
          do 1513 ja=1,nat
          if(ja.ne.la)then
           do 1523 ii=1,N
           do 1523 ix=1,3
           do 1523 jx=1,3
           j=3*(ja-1)+jx
           con=A(3*(la-1)+ix,ii)*A(3*(ja-1)+jx,ii)
           do 1523 kx=1,3
           k=3*(ka-1)+kx
           do 1523 lx=1,3
           l=3*(la-1)+lx
1523       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1     con*cc(nat*((9*la+3*ix+lx-13)*nat*9+3*(k-1))+j)
          endif
1513      continue
         endif
153      continue
         call w36('II   transformed_3')

c        ja=ka ia<>ja ia<>ka ia<>la
         do 161 ka=1,nat
         do 161 ia=1,nat
         if(ia.ne.ka)then
          do 1611 la=1,nat
          if(la.ne.ia)then
           do 1621 ix=1,3
           i=3*(ia-1)+ix
           do 1621 jx=1,3
           do 1621 ii=1,N
           con=A(3*(ia-1)+ix,ii)*A(3*(ka-1)+jx,ii)
           do 1621 kx=1,3
           k=3*(ka-1)+kx
           do 1621 lx=1,3
           l=3*(la-1)+lx
1621       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1     con*cc(nat*((9*ka+3*jx+kx-13)*nat*9+3*(i-1))+l)
          endif
1611      continue
         endif
161      continue
         call w36('II   transformed_4')

c        ja=la ia<>ja ia<>ka ia<>la ja<>ka
         do 174 la=1,nat
         do 174 ia=1,nat
         if(ia.ne.la)then
          do 1714 ka=1,nat
          if(ka.ne.ia.and.ka.ne.la)then
           do 1724 ix=1,3
           i=3*(ia-1)+ix
           do 1724 jx=1,3
           do 1724 ii=1,N
           con=A(3*(ia-1)+ix,ii)*A(3*(ka-1)+jx,ii)
           do 1724 kx=1,3
           k=3*(ka-1)+kx
           do 1724 lx=1,3
1724       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1     con*cc(nat*((9*la+3*jx+lx-13)*nat*9+3*(i-1))+k)
          endif
1714      continue
         endif
174      continue
         call w36('II   transformed_5')

c        ka=la ia<>ja ia<>ka ia<>la ja<>ka ja<>la
         do 183 ka=1,nat
         do 183 ia=1,nat
         if(ia.ne.ka)then
          do 1813 ja=1,nat
          if(ja.ne.ia.and.ja.ne.ka)then
           do 1823 ix=1,3
           i=3*(ia-1)+ix
           do 1823 jx=1,3
           j=3*(ja-1)+jx
           do 1823 ii=1,N
           con=A(3*(ia-1)+ix,ii)*A(3*(ka-1)+jx,ii)
           do 1823 kx=1,3
           k=3*(ka-1)+kx
           do 1823 lx=1,3
           l=3*(ka-1)+lx
1823       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1     con*cc(nat*((9*ka+3*kx+lx-13)*nat*9+3*(i-1))+j)
          endif
1813      continue
         endif
183      continue
         call w36('II   transformed')

c        transform third index  N**3
         do 91 jj=1,N
         do 91 ii=1,N
         do 91 la=1,nat
         do 91 lx=1,3
         l=3*(la-1)+lx
         sum=0.0d0
         do 101 ka=1,nat
         do 101 kx=1,3
         k=3*(ka-1)+kx
101      sum=sum+A(k,jj)*cx(N*(N*(ii-1)+k-1)+l)
91       cc(N*(N*(ii-1)+jj-1)+l)=sum
         call w36('  J  transformed')

c        transform fourth index N**3
         do 111 ii=1,N
         do 111 jj=1,N
         do 111 kk=jj,N
         sum=0.0d0
         do 121 la=1,nat
         do 121 lx=1,3
         l=3*(la-1)+lx
121      sum=sum+A(l,kk)*cc(N*(N*(ii-1)+jj-1)+l)
111      cx(ii+(jj-1)*N+(kk-1)*N2)=sum
         call w36('   K transformed')

         do 72 ii=1,N**3
         call report('projection not implemented yet')
c    1  con*cc(nat*((9*ia+3*ix+jx-13)*nat*9+3*(k-1))+l)
72       cc(ii)=cx(ii)

         call w36(' space coordinates have been projected out ')
         sx=0.0d0
         sy=0.0d0
         sz=0.0d0
         do 433 ia=2,N/3
         sx=sx+cc(1+3*(ia-1))
         sy=sy+cc(2+3*(ia-1))
433      sz=sz+cc(3+3*(ia-1))
         write(6,6009)sx,sy,sz,cc(1),cc(2),cc(3)
         write(3,6009)sx,sy,sz,cc(1),cc(2),cc(3)
        endif
c
c       transform first two indices N**3 x N**1-2 scaling
        do 7 ii=1,N**3
7       cx(ii)=0.0d0
c
c       CX IIkl= SIi SIj Cijkl
c       consider only semi-diagonal constants that we have:

c       ia=ja
        do 13 ii=N7,N
        do 13 ia=1,nat
        do 13 ix=1,3
        do 13 jx=1,3
        con=S(3*(ia-1)+ix,ii)*S(3*(ia-1)+jx,ii)
        do 13 k=1,N
        do 13 l=1,N
13      cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1  con*cc(nat*((9*ia+3*ix+jx-13)*nat*9+3*(k-1))+l)
        call w36('II   transformed_1')

c       ia=ka ia<>ja
        do 14 ka=1,nat
        do 14 ja=1,nat
        if(ja.ne.ka)then
         do 141 jx=1,3
         j=3*(ja-1)+jx
         do 141 ii=N7,N
         do 141 ix=1,3
         con=S(3*(ka-1)+ix,ii)*S(3*(ja-1)+jx,ii)
         do 141 kx=1,3
         k=3*(ka-1)+kx
         do 141 l=1,N
141      cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1   con*cc(nat*((9*ka+3*ix+kx-13)*nat*9+3*(j-1))+l)
        endif
14      continue
        call w36('II   transformed_2')

c       ia=la ia<>ja ia<>ka
        do 15 la=1,nat
        do 15 ka=1,nat
        if(ka.ne.la)then
         do 151 ja=1,nat
         if(ja.ne.la)then
          do 152 ii=N7,N
          do 152 ix=1,3
          do 152 jx=1,3
          j=3*(ja-1)+jx
          con=S(3*(la-1)+ix,ii)*S(3*(ja-1)+jx,ii)
          do 152 kx=1,3
          k=3*(ka-1)+kx
          do 152 lx=1,3
          l=3*(la-1)+lx
152       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1    con*cc(nat*((9*la+3*ix+lx-13)*nat*9+3*(k-1))+j)
         endif
151      continue
        endif
15      continue
        call w36('II   transformed_3')

c       ja=ka ia<>ja ia<>ka ia<>la
        do 16 ka=1,nat
        do 16 ia=1,nat
        if(ia.ne.ka)then
         do 163 la=1,nat
         if(la.ne.ia)then
          do 162 ix=1,3
          i=3*(ia-1)+ix
          do 162 jx=1,3
          do 162 ii=N7,N
          con=S(3*(ia-1)+ix,ii)*S(3*(ka-1)+jx,ii)
          do 162 kx=1,3
          k=3*(ka-1)+kx
          do 162 lx=1,3
          l=3*(la-1)+lx
162       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1    con*cc(nat*((9*ka+3*jx+kx-13)*nat*9+3*(i-1))+l)
         endif
163      continue
        endif
16      continue
        call w36('II   transformed_4')

c       ja=la ia<>ja ia<>ka ia<>la ja<>ka
        do 17 la=1,nat
        do 17 ia=1,nat
        if(ia.ne.la)then
         do 171 ka=1,nat
         if(ka.ne.ia.and.ka.ne.la)then
          do 172 ix=1,3
          i=3*(ia-1)+ix
          do 172 jx=1,3
          do 172 ii=N7,N
          con=S(3*(ia-1)+ix,ii)*S(3*(ka-1)+jx,ii)
          do 172 kx=1,3
          k=3*(ka-1)+kx
          do 172 lx=1,3
172       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1    con*cc(nat*((9*la+3*jx+lx-13)*nat*9+3*(i-1))+k)
         endif
171      continue
        endif
17      continue
        call w36('II   transformed_5')

c       ka=la ia<>ja ia<>ka ia<>la ja<>ka ja<>la
        do 18 ka=1,nat
        do 18 ia=1,nat
        if(ia.ne.ka)then
         do 181 ja=1,nat
         if(ja.ne.ia.and.ja.ne.ka)then
          do 182 ix=1,3
          i=3*(ia-1)+ix
          do 182 jx=1,3
          j=3*(ja-1)+jx
          do 182 ii=N7,N
          con=S(3*(ia-1)+ix,ii)*S(3*(ka-1)+jx,ii)
          do 182 kx=1,3
          k=3*(ka-1)+kx
          do 182 lx=1,3
          l=3*(ka-1)+lx
182       cx(N*(N*(ii-1)+k-1)+l)=cx(N*(N*(ii-1)+k-1)+l)+
     1    con*cc(nat*((9*ka+3*kx+lx-13)*nat*9+3*(i-1))+j)
         endif
181      continue
        endif
18      continue
        call w36('II   transformed')

c       transform third index  N**3
        do 9 jj=N7,N
        do 9 ii=N7,N
        do 9 la=1,nat
        do 9 lx=1,3
        l=3*(la-1)+lx
        sum=0.0d0
        do 10 ka=1,nat
        do 10 kx=1,3
        k=3*(ka-1)+kx
10      sum=sum+S(k,jj)*cx(N*(N*(ii-1)+k-1)+l)
9       cc(N*(N*(ii-1)+jj-1)+l)=sum
        call w36('  J  transformed')

c       transform fourth index N**3
        do 11 ii=N7,N
        do 11 jj=N7,N
        do 11 kk=jj,N
        sum=0.0d0
        do 12 la=1,nat
        do 12 lx=1,3
        l=3*(la-1)+lx
12      sum=sum+S(l,kk)*cc(N*(N*(ii-1)+jj-1)+l)
11      cx(ii+(jj-1)*N+(kk-1)*N2)=sum
        call w36('   K transformed')

        deallocate(cc)
c       FAST FAST FAST FAST FAST FAST FAST FAST FAST FAST FAST
       ELSE
c       SLOW SLOW SLOW SLOW SLOW SLOW SLOW SLOW SLOW SLOW SLOW
        call w36
     1  ('cc in dod36i could not be allocated, using slower route')
6       READ(4,END=6333,ERR=6333)i,j,k,l,con
        ic=ic+1
c       ============================================================
        if(i.eq.j)then
c        ii
         if(k.eq.i)then
c         ----------------------------------------------------------
c         iii
          if(l.eq.i)then
c          iiii
           do 81 ii=N7,N
           do 81 jj=N7,N
           do 81 kk=jj,N
           inm=ii+(jj-1)*N+(kk-1)*N2
81         cx(inm)=cx(inm)+S(i,ii)*S(i,ii)*S(i,jj)*S(i,kk)*con
          else
c          iiil
           do 82 ii=N7,N
           do 82 jj=N7,N
           do 82 kk=jj,N
           inm=ii+(jj-1)*N+(kk-1)*N2
82         cx(inm)=cx(inm)+(S(i,ii)*S(i,ii)*S(i,jj)*S(l,kk)
     1                     +S(i,ii)*S(i,ii)*S(l,jj)*S(i,kk)
     1                     +S(i,ii)*S(l,ii)*S(i,jj)*S(i,kk)
     1                     +S(l,ii)*S(i,ii)*S(i,jj)*S(i,kk))*con
          endif
         else
c         ----------------------------------------------------------
c         iik
          if(l.eq.k)then
c          iikk
           do 83 ii=N7,N
           do 83 jj=N7,N
           do 83 kk=jj,N
           inm=ii+(jj-1)*N+(kk-1)*N2
83         cx(inm)=cx(inm)+(S(i,ii)*S(i,ii)*S(k,jj)*S(k,kk)
     1                     +S(i,ii)*S(k,ii)*S(i,jj)*S(k,kk)
     1                     +S(k,ii)*S(i,ii)*S(i,jj)*S(k,kk)
     1                     +S(i,ii)*S(k,ii)*S(k,jj)*S(i,kk)
     1                     +S(k,ii)*S(i,ii)*S(k,jj)*S(i,kk)
     1                     +S(k,ii)*S(k,ii)*S(i,jj)*S(i,kk))*con
          else
           if(l.eq.i)then
c           iiki  - in fact, this does not happen for i<=j=<k=<l
            goto 999
           else
c           iikl
            do 84 ii=N7,N
            do 84 jj=N7,N
            do 84 kk=jj,N
            inm=ii+(jj-1)*N+(kk-1)*N2
84          cx(inm)=cx(inm)+(S(i,ii)*S(i,ii)*S(k,jj)*S(l,kk)
     1                      +S(i,ii)*S(k,ii)*S(i,jj)*S(l,kk)
     1                      +S(k,ii)*S(i,ii)*S(i,jj)*S(l,kk)
     1                      +S(i,ii)*S(k,ii)*S(l,jj)*S(i,kk)
     1                      +S(k,ii)*S(i,ii)*S(l,jj)*S(i,kk)
     1                      +S(k,ii)*S(l,ii)*S(i,jj)*S(i,kk)
     1                      +S(i,ii)*S(i,ii)*S(l,jj)*S(k,kk)
     1                      +S(i,ii)*S(l,ii)*S(i,jj)*S(k,kk)
     1                      +S(l,ii)*S(i,ii)*S(i,jj)*S(k,kk)
     1                      +S(i,ii)*S(l,ii)*S(k,jj)*S(i,kk)
     1                      +S(l,ii)*S(i,ii)*S(k,jj)*S(i,kk)
     1                      +S(l,ii)*S(k,ii)*S(i,jj)*S(i,kk))*con
           endif
          endif
c         ----------------------------------------------------------
         endif
        else
c       ============================================================
c        ij
         if(k.eq.j)then
c         ----------------------------------------------------------
c         ijj
          if(l.eq.j)then
c          ijjj
           do 85 ii=N7,N
           do 85 jj=N7,N
           do 85 kk=jj,N
           inm=ii+(jj-1)*N+(kk-1)*N2
85         cx(inm)=cx(inm)+(S(i,ii)*S(j,ii)*S(j,jj)*S(j,kk)
     1                     +S(j,ii)*S(i,ii)*S(j,jj)*S(j,kk)
     1                     +S(j,ii)*S(j,ii)*S(i,jj)*S(j,kk)
     1                     +S(j,ii)*S(j,ii)*S(j,jj)*S(i,kk))*con
          else
           if(l.eq.i)then
c           ijji not allowed
            goto 999
           else
c           ijjl
            do 86 ii=N7,N
            do 86 jj=N7,N
            do 86 kk=jj,N
            inm=ii+(jj-1)*N+(kk-1)*N2
86          cx(inm)=cx(inm)+(S(i,ii)*S(j,ii)*S(j,jj)*S(l,kk)
     1                      +S(i,ii)*S(j,ii)*S(l,jj)*S(j,kk)
     1                      +S(i,ii)*S(l,ii)*S(j,jj)*S(j,kk)
     1                      +S(j,ii)*S(i,ii)*S(l,jj)*S(j,kk)
     1                      +S(j,ii)*S(i,ii)*S(j,jj)*S(l,kk)
     1                      +S(j,ii)*S(j,ii)*S(i,jj)*S(l,kk)
     1                      +S(l,ii)*S(j,ii)*S(j,jj)*S(i,kk)
     1                      +S(l,ii)*S(j,ii)*S(i,jj)*S(j,kk)
     1                      +S(l,ii)*S(i,ii)*S(j,jj)*S(j,kk)
     1                      +S(j,ii)*S(l,ii)*S(i,jj)*S(j,kk)
     1                      +S(j,ii)*S(l,ii)*S(j,jj)*S(i,kk)
     1                      +S(j,ii)*S(j,ii)*S(l,jj)*S(i,kk))*con
           endif
          endif
         else
c         ----------------------------------------------------------
          if(k.eq.i)then
c          iji
           if(l.eq.i)then
c           ijii - in fact, this does not happen for i<=j=<k=<l
            goto 999
           else
            if(l.eq.j)then
c            ijij - not allowed for i<=j=<k=<l
             goto 999
            else
c            ijil - not allowed
             goto 999
            endif
           endif
c          ----------------------------------------------------------
          else
c          ijk
           if(l.eq.k)then
c           ijkk
            do 87 ii=N7,N
            do 87 jj=N7,N
            do 87 kk=jj,N
            inm=ii+(jj-1)*N+(kk-1)*N2
87          cx(inm)=cx(inm)+(S(i,ii)*S(k,ii)*S(k,jj)*S(j,kk)
     1                      +S(i,ii)*S(k,ii)*S(j,jj)*S(k,kk)
     1                      +S(i,ii)*S(j,ii)*S(k,jj)*S(k,kk)
     1                      +S(k,ii)*S(i,ii)*S(j,jj)*S(k,kk)
     1                      +S(k,ii)*S(i,ii)*S(k,jj)*S(j,kk)
     1                      +S(k,ii)*S(k,ii)*S(i,jj)*S(j,kk)
     1                      +S(j,ii)*S(k,ii)*S(k,jj)*S(i,kk)
     1                      +S(j,ii)*S(k,ii)*S(i,jj)*S(k,kk)
     1                      +S(j,ii)*S(i,ii)*S(k,jj)*S(k,kk)
     1                      +S(k,ii)*S(j,ii)*S(i,jj)*S(k,kk)
     1                      +S(k,ii)*S(j,ii)*S(k,jj)*S(i,kk)
     1                      +S(k,ii)*S(k,ii)*S(j,jj)*S(i,kk))*con
           else
            if(l.eq.i)then
c            ijki not allowed
             goto 999
            else
             if(l.eq.j)then
c             ijkj not allwoed
              goto 999
             else
c             ijkl                  N**3 x N**3 scaling
              do 88 ii=N7,N
              do 88 jj=N7,N
              do 88 kk=jj,N
              inm=ii+(jj-1)*N+(kk-1)*N2
88            cx(inm)=cx(inm)+(S(i,ii)*S(j,ii)*S(k,jj)*S(l,kk)
     1                        +S(i,ii)*S(j,ii)*S(l,jj)*S(k,kk)
     1                        +S(i,ii)*S(k,ii)*S(j,jj)*S(l,kk)
     1                        +S(i,ii)*S(k,ii)*S(l,jj)*S(j,kk)
     1                        +S(i,ii)*S(l,ii)*S(j,jj)*S(k,kk)
     1                        +S(i,ii)*S(l,ii)*S(k,jj)*S(j,kk)
     1                        +S(j,ii)*S(i,ii)*S(k,jj)*S(l,kk)
     1                        +S(j,ii)*S(i,ii)*S(l,jj)*S(k,kk)
     1                        +S(j,ii)*S(k,ii)*S(i,jj)*S(l,kk)
     1                        +S(j,ii)*S(k,ii)*S(l,jj)*S(i,kk)
     1                        +S(j,ii)*S(l,ii)*S(i,jj)*S(k,kk)
     1                        +S(j,ii)*S(l,ii)*S(k,jj)*S(i,kk)
     1                        +S(k,ii)*S(i,ii)*S(j,jj)*S(l,kk)
     1                        +S(k,ii)*S(i,ii)*S(l,jj)*S(j,kk)
     1                        +S(k,ii)*S(j,ii)*S(i,jj)*S(l,kk)
     1                        +S(k,ii)*S(j,ii)*S(l,jj)*S(i,kk)
     1                        +S(k,ii)*S(l,ii)*S(i,jj)*S(j,kk)
     1                        +S(k,ii)*S(l,ii)*S(j,jj)*S(i,kk)
     1                        +S(l,ii)*S(i,ii)*S(j,jj)*S(k,kk)
     1                        +S(l,ii)*S(i,ii)*S(k,jj)*S(j,kk)
     1                        +S(l,ii)*S(j,ii)*S(i,jj)*S(k,kk)
     1                        +S(l,ii)*S(j,ii)*S(k,jj)*S(i,kk)
     1                        +S(l,ii)*S(k,ii)*S(i,jj)*S(j,kk)
     1                        +S(l,ii)*S(k,ii)*S(j,jj)*S(i,kk))*con
             endif
            endif
           endif
          endif
c         ----------------------------------------------------------
         endif
        endif
c       ============================================================
        goto 6
6333    close(4)
       ENDIF
       write(6,*)ic,' cartesians read and transformed'
       write(3,*)ic,' cartesians read and transformed'
c
c      write sparse quartics-diagonal
       open(23,file='DQQ.SCR.TXT')
       NQ=0
       NQT=0
       do 64 i=N7,N
       do 64 j=N7,N
       do 64 k=j,N
c      hartree:
       cqcn=cx(i+(j-1)*N+(k-1)*N2)/sqrt(abs(e(i)*e(i)*e(j)*e(k)))
c      cm-1:
       cqcm=cqcn*cm
       if(abs(cqcm).ge.tol3)then
        write(23,2323)i,j,k,cqcn,cqcm
        nq=nq+1
       endif
64     nqt=nqt+1
       close(23)
       write(6,6040)nqt,nq,tol3,'DQQ.SCR.TXT'
       write(3,6040)nqt,nq,tol3,'DQQ.SCR.TXT'
c     oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
      endif
      deallocate(cx)
      RETURN
999   write(6,*)i,j,k,l
      call report('forbidden combination')
      END
c
      subroutine addcc(i,j,k,l,N,c,con)
      implicit none
      integer*4 i,j,k,l,N,nat,ia,ja,ka,la,ix,jx,kx,lx,i1
      real*8 c(*),con
      nat=N/3
      ia=(i+2)/3
      ix=i-3*(ia-1)
      ja=(j+2)/3
      jx=j-3*(ja-1)
      ka=(k+2)/3
      kx=k-3*(ka-1)
      la=(l+2)/3
      lx=l-3*(la-1)
      if(ia.eq.ja)then
       i1=nat*((9*ia+3*ix+jx-13)*nat*9+3*(k-1))+l
      else
       if(ia.eq.ka)then
        i1=nat*((9*ia+3*ix+kx-13)*nat*9+3*(j-1))+l
       else
        if(ia.eq.la)then
         i1=nat*((9*ia+3*ix+lx-13)*nat*9+3*(k-1))+j
        else
         if(ja.eq.ka)then
          i1=nat*((9*ja+3*jx+kx-13)*nat*9+3*(i-1))+l
         else
          if(ja.eq.la)then
           i1=nat*((9*ja+3*jx+lx-13)*nat*9+3*(i-1))+k
          else
           if(ka.eq.la)then
            i1=nat*((9*ka+3*kx+lx-13)*nat*9+3*(i-1))+j
           else
            write(6,*)i,j,k,l,con
            call report('strange 37 constant in addcc')
           endif
          endif
         endif
        endif
       endif
      endif
      c(i1)=con
      return
      end
