      SUBROUTInE dODQI(S,n,LP4,HW,n7,tol4,NCAN,ICAN)
c
c     dodq in core transformation of cartesian quartics to normal mode
c
      implicit none
      integer*4 n,n7,is,NCAN,ICAN(*)
      include 'dimensions.h'
      LOGICAL LP4,HW,lex
      real*8 S(3*NT0,n),A(3*NT0,3*NT0),cjii,cijj,cijk,cikj,
     2e,tol4,sum,average
      real*8,allocatable:: cx(:),cq(:)
c     cx(3*NT0*3*NT0*3*NT0),cq(3*NT0*3*NT0*3*NT0)
      integer*4 n2,I,J,K,ic,ii,jj,kk,ip,jk,indij,indk,IK
      COMMON/CEM/e(3*NT0)
c
      call w36(' ')
      call w36('Dodqi')
      call w36('^^^^^')

      write(6,6001)HW,N7,N
      write(3,6001)HW,N7,N
6001  format(' HW :',l9,/,
     1       ' N7 :',i9,/,
     1       '  N :',i9,/)

      inquire(file='DQQ.SCR.TXT',exist=lex)
      if(lex)then
       call w36('DQQ.SCR.TXT found on disk, no transformation now')
       return
      endif
c
c     initialize cx:
      allocate(cx(1:n**3),stat=is)
      if(is.ne.0)call report('cannot allocate cx in dodqi')
      allocate(cq(1:n**3),stat=is)
      if(is.ne.0)call report('cannot allocate cq in dodqi')
      n2=n*n
      call vz(cx,0.0d0,n2*n)
c
c     read-in sparse constants
      OPEN(4,FILE='SCR.44')
      ic=0
1     READ(4,*,EnD=5333)I,J,K,cx(i+(j-1)*n+(k-1)*n2)
      ic=ic+1
      goto 1
5333  continue
      write(6,*)ic,' cartesians read in'
      write(3,*)ic,' cartesians read in'
c
c     check projection
      call proj4(cx,n)
c
c     symmetrized cartesians (iijk=iikj)
      do 2 i=1,n
      do 2 j=1,n
      do 2 k=j,n
      cijk=cx(i+(j-1)*n+(k-1)*n2)
      cikj=cx(i+(k-1)*n+(j-1)*n2)
c     write(6,6777)i,j,k,cijk,cikj
c777  format(3I3,6f10.6)
      average=(cijk+cikj)/2.0d0
      cx(i+(j-1)*n+(k-1)*n2)=average
2     cx(i+(k-1)*n+(j-1)*n2)=average
      write(6,*)'cx have beed symmetrized'
      write(3,*)'cx have beed symmetrized iijk=iikj'
c
c     check projection
      call proj4(cx,n)
c
c     iijj=jjii
      do 21 i=1,n
      do 21 j=i,n
      cijj=cx(i+(j-1)*n+(j-1)*n2)
      cjii=cx(j+(i-1)*n+(i-1)*n2)
c     write(3,6777)i,j,j,cijj,cjii
      average=(cijj+cjii)/2.0d0
      cx(i+(j-1)*n+(j-1)*n2)=average
21    cx(j+(i-1)*n+(i-1)*n2)=average
      write(6,*)'cx/diag have beed symmetrized'
      write(3,*)'cx/diag have beed symmetrized iijj=jjii'
c
c     check projection
      call proj4(cx,n)
c
c     project rotational-translational invariance, use temporarily cq for proj
      IF(LP4)THEN
c      oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
       CALL doMA(A,3*NT0,n,HW)
c
c      IIjk = AIi AIi' ii'jk
       WRITE(6,*)' projecting space coordinates'
       WRITE(6,*)' first (double) index'
       do 52 jj=1,n
       do 52 kk=1,n
       jk=(jj-1)*n+(kk-1)*n2
       do 52 I=1,n
       sum=0.0d0
       do 531 ii=1,n
       do 531 ip=1,n
c
c      all non-zero ii ip jj kk
       if(ii.eq.ip)then
        sum=sum+A(I,ii)*A(I,ii)*cx(ii+jk)
       else
        if(ii.eq.jj)then
         sum=sum+A(I,jj)*A(I,ip)*cx(jj+(ip-1)*n+(kk-1)*n2)
        else
         if(ii.eq.kk)then
          sum=sum+A(I,kk)*A(I,ip)*cx(kk+(ip-1)*n+(jj-1)*n2)
         else
          if(ip.eq.jj)then
           sum=sum+A(I,ii)*A(I,jj)*cx(jj+(ii-1)*n+(kk-1)*n2)
          else
           if(ip.eq.kk)then
            sum=sum+A(I,ii)*A(I,kk)*cx(kk+(ii-1)*n+(jj-1)*n2)
           else
            if(jj.eq.kk)then
             sum=sum+A(I,ii)*A(I,ip)*cx(kk+(ii-1)*n+(ip-1)*n2)
            endif
           endif
          endif
         endif
        endif
       endif
531    continue
52     cq(I+jk)=sum
c
c      II J k= AJj IIjk
       WRITE(6,*)' second index'
       do 54 I=1,n
       do 54 kk=1,n
       IK=I+(kk-1)*n2
       do 54 J=1,n
       sum=0.0d0
       do 55 jj=1,n
55     sum=sum+A(J,jj)*cq((jj-1)*n+IK)
54     cx((J-1)*n+IK)=sum
c
c      IJK= AKk IJk
       WRITE(6,*)' third index'
       do 56 I=1,n
       do 56 J=1,n
       InDIJ=I+(J-1)*n
       do 56 K=1,n
       sum=0.0d0
       do 57 kk=1,n
57     sum=sum+A(K,kk)*cx((kk-1)*n2+InDIJ)
56     cq((K-1)*n2+InDIJ)=sum
c
       do 58 i=1,n**3
58     cx(i)=cq(i)
c
       write(6,*)' space coordinates have been projected out '
       write(3,*)' space coordinates have been projected out '
      ENDIF
c     oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
c
c     check projection
      call proj4(cx,n)
c
c     IIjk = AIi AIi' ii'jk
      write(6,*)'transforming DQ into normal modes'
      WRITE(6,*)' first (double) index'
      do 521 jj=1,n
      do 521 kk=1,n
      jk=(jj-1)*n+(kk-1)*n2
      do 521 I=n7,n
      sum=0.0d0
      do 631 ii=1,n
      do 631 ip=1,n
      if(ii.eq.ip)then
       sum=sum+S(ii,I)*S(ii,I)*cx(ii+jk)
      else
       if(ii.eq.jj)then
        sum=sum+S(jj,I)*S(ip,I)*cx(jj+(ip-1)*n+(kk-1)*n2)
       else
        if(ii.eq.kk)then
         sum=sum+S(kk,I)*S(ip,I)*cx(kk+(ip-1)*n+(jj-1)*n2)
        else
         if(ip.eq.jj)then
          sum=sum+S(ii,I)*S(jj,I)*cx(jj+(ii-1)*n+(kk-1)*n2)
         else
          if(ip.eq.kk)then
           sum=sum+S(ii,I)*S(kk,I)*cx(kk+(ii-1)*n+(jj-1)*n2)
          else
           if(jj.eq.kk)then
            sum=sum+S(ii,I)*S(ip,I)*cx(kk+(ii-1)*n+(ip-1)*n2)
           endif
          endif
         endif
        endif
       endif
      endif
631   continue
521   cq(I+jk)=sum
c
c     IJk, gather in cx IJK = SjJ Ijk
      write(6,*)'second index '
      do 2001 I=n7,n
      do 2001 kk=1,n
      indk =I+(kk-1)*n2
      do 2001 J=n7,n
      sum=0.0d0
      do 2002 jj=1,n
2002  sum=sum+cq((jj-1)*n+indk)*S(jj,J)
2001  cx((J-1)*n+indk)=sum
c
c     IJK=skK IJk
      write(6,*)'third index '
      do 3001 I=n7,n
      do 3001 J=n7,n
      indIJ=I+(J-1)*n
      do 3001 K=J,n
      sum=0.0d0
      do 3002 kk=1,n
3002  sum=sum+cx(indIJ+(kk-1)*n2)*S(kk,K)
3001  cq(indIJ+(K-1)*n2)=sum
c
      WRITE(6,*)'transformation finished'
      WRITE(3,*)'transformation to normal modes finished'
c
c
c     write sparse quartics
      call write44(CQ,N7,N,NCAN,ICAN,E,tol4)
c
      deallocate(cx)
      deallocate(cq)

      RETURN
      END
c
      subroutine proj4(cx,n)
      real*8 cx(*),X,Y,Z
      integer*4 n,L
c
      X=0.0d0
      Y=0.0d0
      Z=0.0d0
      n2=n*n
      do 43 L=2,n/3
      X=X-cx(1+(3*(L-1)+1-1)*n2)
      Y=Y-cx(1+(3*(L-1)+2-1)*n2)
43    Z=Z-cx(1+(3*(L-1)+3-1)*n2)
c     1 1 ?
      WRITE(3,333)X,Y,Z,cx(1+0*n2),cx(1+1*n2),cx(1+2*n2)
      WRITE(6,333)X,Y,Z,cx(1+0*n2),cx(1+1*n2),cx(1+2*n2)
333   FORMAT(/,' Sum rule for quartics - X   Y    Z',/,
     1 1X,3F15.10,/,1X,3F15.10,/,/)
      return
      end
