      SUBROUTINE DOHBIGX(NDIM,N,IRQR)
      implicit none
      integer*4 NGE0,NG0,MV,ISB,LEXCL,KG,I,J,K,IBR,ICAN,
     1ICC,IERM,IERR,IJ,IMOD,IN,INI,IRQR,IS,ISA,IT,KK,KKK,L,nn,
     1NCAN,NDIM,NE,NEE,NMM,NZF,JJ,ii,ista
      include 'dimensions.h'
      parameter  (NGE0=24)
      real*8 CM,EAH(MG0),CFJ(NM0),e,a33(NM0)
      integer*4 J1,IYX(2,NGE0),I1,I2,NHBIG,ISI(NGE0,4),
     1N,IBIGSYM,j33(NM0)
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      common/EIGEN/MV
      common/RUNCON/LEXCL
      common/lcbe/e(NT3),live(NT3)
      common/DIA1/NHBIG,IT(NM0),IS(NM0),IBIGSYM(NM0),ICC(NM0,ME0),
     1IN(NM0,ME0)
      logical lex,live
      real*8 VMM
      integer*4 NHAND,iopt
      common/MMM/VMM,NMM,NHAND
      common/iop/iopt(300)
      equivalence (iopt(18),NG0)
      real*8,allocatable:: HBIG(:,:),SMALLC(:,:),SMALLE(:),EE(:)
c     HBIG(NG0,NG0),SMALLC(NG0,NG0)

      write(6,*)'dohbigx'
      inquire(file='EIGEN.SCR',exist=lex)
      if(lex)then
       call w36('EIGEN.SCR found, diagonalization skipped')
       return
      endif
      CM=219470.0d0
C     1 a.u.= 2.1947E5 cm^-1:w
      J1=1
      KG=1
C
C     Start from block IBR, frequency IERM
C
      IYX(1,J1)=1
      IYX(2,J1)=NHBIG
      I1=IYX(1,J1)
      I2=IYX(2,J1)
      NDIM=NHBIG
      ISI(1,1)=I1
      ISI(1,2)=I2
      ISI(1,3)=I1
      ISI(1,4)=I2
c
      IF(.not.LMITIN.AND.NDIM.GT.NG0)CALL REPORT('Block too big')
C
C     Number of eigenvalues to be found: NE; IF IRQR=0, use STurm seq.
      NE=MIN((IRQR*(I2-I1+1)) / NHBIG,NDIM)
      NEE=NE
      IF(NEE.EQ.0)NEE=NDIM
      allocate(SMALLE(1:NDIM),stat=ista)
      if(ista.ne.0)call report('cannot allocate SMALLE in dohbigx')
C
      if(NG0.lt.NDIM)call w36('DIM>NG0, only iterative diagonalization')
      if(LMITIN.or.NG0.lt.NDIM)then
       LMITIN=.true.
       if(NM0.lt.NDIM)call report('DIM>NM0 !!!')
       I=NDIM
       CALL MITINX(NDIM,NMM,NEE,VMM,SMALLE,IERR,MV,J1,'1',0,I)
      else
       allocate(HBIG(1:NDIM,1:NDIM),stat=ista)
       if(ista.ne.0)call report('cannot allocate HBIG om dohbigx')
       allocate(SMALLC(1:NDIM,1:NDIM),stat=ista)
       if(ista.ne.0)call report('cannot allocate SMALLC om dohbigx')
       do 921 I=1,NDIM
       do 921 L=1,NDIM
921    HBIG(I,L)=0.0d0
       OPEN(4,FILE='1A2.SCR',FORM='UNFORMATTED',STATUS='OLD')
       read(4)
       DO 92 I=1,NDIM
       READ(4)nn,(j33(ii),ii=1,nn),(a33(ii),ii=1,nn)
       do 92 ii=1,nn
92     HBIG(j33(ii),I)=a33(ii)
       CLOSE(4)
       call w36('Direct method - Hamiltonian read from 1A2.SCR')
       IF(HW)THEN
        WRITE(3,*)' THE HAMILTONIAN:'
        DO 1206 I=1,NDIM
1206    WRITE(3,1207)(HBIG(I,JJ),JJ=1,NDIM)
1207    FORMAT(10F8.1)
       ENDIF
       IMOD=2
       IERR=0
       allocate(EE(1:NDIM),stat=ista)
       if(ista.ne.0)call report('cannot allocate EE dohbigx')
       CALL TRED12(NG0,NDIM,HBIG,SMALLC,SMALLE,IMOD,IERR,EE)
       deallocate(EE)
       if(IERR.ne.0)call report('Diagonalization error')
       NE=NDIM
       MV=0
       do 1  i=1,NDIM
1      if(SMALLE(i).lt.VMM)MV=MV+1	
       WRITE(3,301)MV,VMM
       WRITE(6,301)MV,VMM
301    format(i5,' eigenvalues smaller than ',f10.2)
       deallocate(HBIG)
      endif
      IF(IERR.NE.0.AND.IERR.NE.8888)CALL REPORT(' DIAG. ERROR ')
C
C     The Hamiltonian is diagonalized in CM-1, take back atomic units:
      DO 105 ISA=1,MV
105   SMALLE(ISA)=SMALLE(ISA)/CM
C
      WRITE(3,*)'From ',MV,' eigenvalues ',MIN(MV,MG0),' kept'
      WRITE(6,*)'From ',MV,' eigenvalues ',MIN(MV,MG0),' kept'
      MV=MIN(MV,MG0)
      ISI(1,3)=1
      ISI(1,4)=MV
      DO 97 ISA=1,MV
      EAH(ISA)=SMALLE(ISA)
      WRITE(3,*)ISA,SMALLE(ISA)*CM
      WRITE(6,*)ISA,SMALLE(ISA)*CM
      IF(LMITIN)GOTO 97
C     eigenvector:
      DO 977 INI=1,NDIM
977   CFJ(INI)=SMALLC(INI,ISA)
      WRITE(3,*)' Eigenvector ',ISA,NDIM,MV
      IF(HW)THEN
       WRITE(3,3333)(CFJ(IJ),IJ=1,NDIM)
3333   FORMAT(10F7.4)
      ENDIF
      CALL SAVEC(ISA,CFJ,NDIM)
97    CONTINUE
      if(.not.LMITIN) deallocate(SMALLC)
C
      IERM=0
      OPEN(45,FILE='EEO.SCR',FORM='UNFORMATTED')
      WRITE(45)MV,(EAH(KK),KK=1,MV)
      WRITE(45)KG,((ISI(KK,KKK),KKK=1,4),KK=1,KG)
      CLOSE(45)
      WRITE(3,*)MV,' energies saved into EEO.SCR'
      WRITE(6,*)MV,' energies saved into EEO.SCR'
      write(6,*)KG,((ISI(k,i),i=1,4),k=1,KG)
C
      ISB=1
      OPEN(4,FILE='EIGEN.SCR',FORM='UNFORMATTED')
      WRITE(4)ISB,N,LEXCL,NHBIG,MV,KG,ISB
      WRITE(4)(IT(I),I=1,NHBIG) ,(IS(I),I=1,NHBIG),
     1((ICC(I,J),I=1,NHBIG),J=1,LEXCL),((IN(I,J),I=1,NHBIG),J=1,LEXCL),
     2(EAH(I),I=1,MV),(E(I),I=ISB,N),(E(I),I=ISB,N),
     3((IYX(K,J),K=1,2),J=1,ISB),((ISI(J,K),K=1,4),J=1,KG)
      CLOSE(4)
      WRITE(6,*)' EIGEN.SCR written'
      WRITE(3,*)' EIGEN.SCR written'
      deallocate(SMALLE)
C
      RETURN
      END
c
      SUBROUTINE DOHBIGX1(NDIM,E1)
c     just get the lowest-energy E1
      implicit none
      integer*4 NG0,MV,I,IBR,ICAN,
     1ICC,IERM,IERR,IN,IS,IT,L,nn,
     1NCAN,NDIM,NE,NEE,NMM,NZF,ii
      include 'dimensions.h'
      real*8 a33(NM0),E1
      integer*4 J1,NHBIG,IBIGSYM,j33(NM0)
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      common/EIGEN/MV
      common/DIA1/NHBIG,IT(NM0),IS(NM0),IBIGSYM(NM0),ICC(NM0,ME0),
     1IN(NM0,ME0)
      real*8 VMM
      integer*4 NHAND,iopt
      common/MMM/VMM,NMM,NHAND
      common/iop/iopt(300)
      equivalence (iopt(18),NG0)
      real*8,allocatable:: HBIG(:,:),SMALLC(:,:),SMALLE(:),EE(:)
c     HBIG(NG0,NG0),SMALLC(NG0,NG0)

      J1=1
      NDIM=NHBIG
      IF(.not.LMITIN.AND.NDIM.GT.NG0)CALL REPORT('Block too big')
      NE=1
      NEE=NE
      allocate(SMALLE(1:NDIM),stat=I)
      if(I.ne.0)call report('Cannot allocate SMALLE in dohbigx1')
C
      if(NG0.lt.NDIM)call w36('DIM>NG0, only iterative diagonalization')
      if(LMITIN.or.NG0.lt.NDIM)then
       LMITIN=.true.
       if(NM0.lt.NDIM)call report('DIM>NM0 !!!')
       I=NDIM
       CALL MITINX(NDIM,NMM,NEE,VMM,SMALLE,IERR,MV,J1,'1',0,I)
      else
       allocate(HBIG(1:NDIM,1:NDIM),stat=ii)
       if(ii.ne.0)call report('cannot allocate HBIG om dohbigx1')
       allocate(SMALLC(1:NDIM,1:NDIM),stat=ii)
       if(ii.ne.0)call report('cannot allocate SMALLC om dohbigx1')
       do 921 I=1,NDIM
       do 921 L=1,NDIM
921    HBIG(I,L)=0.0d0
       OPEN(4,FILE='1A2.SCR',FORM='UNFORMATTED',STATUS='OLD')
       DO 92 I=1,NDIM
       READ(4)nn,(j33(ii),ii=1,nn),(a33(ii),ii=1,nn)
       do 92 ii=1,nn
92     HBIG(j33(ii),I)=a33(ii)
       CLOSE(4)
       call w36('Direct method - Hamiltonian read from 1A2.SCR')
       IERR=0
       allocate(EE(1:NDIM),stat=ii)
       if(ii.ne.0)call report('cannot allocate EE om dohbigx1')
       CALL TRED12(NG0,NDIM,HBIG,SMALLC,SMALLE,2,IERR,EE)
       deallocate(SMALLC,HBIG,EE)
      endif
      if(IERR.ne.0)call report('Diagonalization error')
      E1=SMALLE(1)
      deallocate(SMALLE)
      return
      END
