      SUBROUTINE doteni(S,N,N7)
c
c     S - s matrix (cart/nm) in atomic units is supplied
c     N - number of modes, N7 - starting mode
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      LOGICAL lex,ljj,lnmr,loptrot,lapt
      include 'dimensions.h'
      DIMENSION APT(NT0,3,3),AAT(NT0,3,3),s(NT3,NT3),aatq(NT3,3),
     1aptq(NT3,3),ALPHA(3,3,NT3),alphaq(3,3,NT3),gq(3,3,NT3),
     1aq(3,3,3,NT3),dip0(3),aptn(2*NT3,3),GG(3,3,NT3),optrotx(2*NT3),
     1AA(3,3,3,NT3),u(3),optrotq(2*NT3),sigma0(NT0),polar(3,3),
     1nml(NT3),adum(3,3,3)
c     large arrays:
      real*8,allocatable:: ajmx(:,:,:),ajmq(:,:,:),ajm2(:,:,:),
     1ajmq2(:,:,:),aaa(:,:,:,:,:),sigma2(:,:),sigmaq2(:,:),
     1aataq(:,:),aptaq(:,:),alphaa(:,:,:,:),alphaaq(:,:),gaq(:,:),
     1aaq(:,:),gaa(:,:,:,:),apta(:,:,:,:),aata(:,:,:,:),
     1sigmax(:,:),sigmaq(:,:),ajm0(:,:),optrot2(:),
     1optrotq2(:)
c     ajmx(2*NT3,NT0,NT0),ajmq(2*NT3,NT0,NT0)
c     ajm2(NT3**2,NT0,NT0),ajmq2(NT3**2,NT0,NT0),
c     sigma2(NT3**2,NT0),sigmaq2(NT3**2,NT0)
      COMMON/CEM/e(NT3)
c
      call w36('Transformation of tensor derivatives')
c
      nat=n/3
c
c     later replace fix dimensions by actual ones:
      allocate(aataq(NT3**2,3),aptaq(2*NT3**2,3),alphaa(NT3,3,3,NT3),
     1alphaaq(NT3**2,9),gaq(NT3**2,9),aaq(NT3**2,27),
     1gaa(NT3,3,3,NT3),apta(NT3,NT0,3,3),aata(NT3,NT0,3,3),
     1sigmax(2*NT3,NT0),sigmaq(2*NT3,NT0),ajm0(NT0,NT0),optrot2(NT3**2),
     1optrotq2(NT3**2))
c
c     first dipolar derivatives
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR found, no trafo now')
      else
       inquire(file='FILE.TEN',exist=lex)
       if(.not.lex)then
        call w36('FILE.TEN not found')
        return
       endif
       open(21,file='FILE.TEN')
       call readten(NT0,APT,AAT,NAT)
       close(21)
c
       do 103 i=1,3
       write(3,*)'sum rule - APT',i
       write(6,*)'sum rule - APT',i
103    call sr(i,NT0,APT,NAT)
       do 104 i=1,3
       write(3,*)'sum rule - AAT',i
       write(6,*)'sum rule - AAT',i
104    call sr(i,NT0,AAT,NAT)
c
       do 1 iq=N7,N
       do 1 ixd=1,3
       aptq(iq,ixd)=0.0d0
       aatq(iq,ixd)=0.0d0
       do 1 ia=1,nat
       do 1 iax=1,3
       aatq(iq,ixd)=aatq(iq,ixd)+AAT(ia,iax,ixd)*s((ia-1)*3+iax,iq)
1      aptq(iq,ixd)=aptq(iq,ixd)+APT(ia,iax,ixd)*s((ia-1)*3+iax,iq)

       ndif=0
       do 12 i=N,N7,-1
       ndif=ndif+1
       nml(i)=ndif
       do 12 ix=1,3
       dip0(ix)=0.0d0
       aptq(i,ix)=aptq(i,ix)/sqrt(e(i))
       aptn(i,ix)=aptq(i,ix)
       aptn(i+N,ix)=0.0d0
12     aatq(i,ix)=aatq(i,ix)*sqrt(e(i))
       lapt=.true.
       call wrten1q(dip0,ndif,lapt,aptn,aptq,NT3,aatq,nml,N)
       call w36('(ASCII TENQ.TXT.SCR)')
c
c      write parallel ascii file:
       open(22,file='DIPOLE.TXT.SCR')
       read(22,*,end=299,err=299)u
299    close(22)
      endif
c
c     chemical shift and spin-spin coupling derivatives
      inquire(file='NMR.SCR.TXT',exist=lex)
      if(lex)then
       write(6,7009)N,NAT
       write(3,7009)N,NAT
7009   format('N=',i4,', NAT=',i4)

       allocate(ajmx(1:2*N,1:NAT,1:NAT),stat=is)
       if(is.ne.0)call report('cannot allocate ajmx')
       allocate(ajmq(1:2*N,1:NAT,1:NAT),stat=is)
       if(is.ne.0)call report('cannot allocate ajmq')
       call rdnmr(optrot0,optrotx,sigma0,sigmax,ajm0,ajmx,
     1 NT3,NT0,N,nat,loptrot,lnmr,ljj)

       do 8 iq=N7,N
       optrotq(iq)=0.0d0
       optrotq(N+iq)=0.0d0
       do 10 ia=1,N
       optrotq(iq)=optrotq(iq)+optrotx(ia)*s(ia,iq)
10     optrotq(N+iq)=optrotq(N+iq)+optrotx(ia+N)*s(ia,iq)**2
       do 8 ixd=1,nat
       sigmaq(iq,ixd)=0.0d0
       sigmaq(iq+N,ixd)=0.0d0
       do 9 ia=1,N
       sigmaq(iq,ixd)=sigmaq(iq,ixd)+sigmax(ia,ixd)*s(ia,iq)
9      sigmaq(N+iq,ixd)=sigmaq(N+iq,ixd)+sigmax(N+ia,ixd)*s(ia,iq)**2
       do 8 jxd=1,nat
       ajmq(iq,ixd,jxd)=0.0d0
       ajmq(iq+N,ixd,jxd)=0.0d0
       do 8 ia=1,N
       ajmq(iq,ixd,jxd)=ajmq(iq,ixd,jxd)+ajmx(ia,ixd,jxd)*s(ia,iq)
8      ajmq(N+iq,ixd,jxd)=ajmq(N+iq,ixd,jxd)+ajmx(N+ia,ixd,jxd)
     1 *s(ia,iq)**2
c      open(22,file='DIPOLE.TXT.SCR')
c      read(22,*)u
c      read(22,*)optrot0
c      read(22,*)
c      do 548 i=1,nat
c48    read(22,*)idumm,sigma0(i)
c      read(22,*)
c      do 549 i=1,nat
c      do 549 j=1,nat
c49    read(22,*)idumm,idumm,ajm0(i,j)
c      close(22)

       inquire(file='PROP.TXT.SCR',exist=lex)
       if(lex)then
        call w36('PROPTXT.SCR exist, not overwritten')
       else
        open(21,file='PROP.TXT.SCR')
        write(21,*)N7,N
        if(loptrot)then
         write(21,*)loptrot
         write(21,2125)1,optrot0
2125     format('Optical rotation:',/,i5,/,20x,f10.2)
         do 27 i=N7,N
27       write(21,2126)i,optrotq(i)/dsqrt(e(i)),optrotq(N+i)/e(i)
2126     format(20x,i5,2g15.5)
        endif

        if(lnmr)then
         write(21,*)lnmr
         write(21,2127)N/3
2127     format('Chemical shifts:',/,i5)
         do 28 i=1,N/3
28       write(21,2131)i,sigma0(i)
2131     format(i20,g15.5)
         do 29 i=1,N/3
         do 29 j=N7,N
29       write(21,2128)i,j,sigmaq(j,i)/dsqrt(e(j)),sigmaq(N+j,i)/e(j)
2128     format(i20,i5,2g15.5)
        endif

        if(ljj)then
         write(21,*)ljj
         write(21,2129)N/3*N/3
2129     format('Spin-Spin Couplings:',/,i5)
         do 30 i=1,N/3
         do 30 j=1,N/3
30       write(21,21281)i,j,ajm0(i,j)
21281    format(2i10,g15.5)
         do 31 i=1,N/3
         do 31 j=1,N/3
         do 31 k=N7,N
31       write(21,2130)i,j,k,ajmq(k,j,i)/dsqrt(e(k)),ajmq(k+N,j,i)/e(k)
2130     format(2i10,i5,2g15.5)
        endif

        close(21)
        call w36('PROP.TXT.SCR made')
       endif

       deallocate(ajmx)
       deallocate(ajmq)
      endif
c
c     chemical shift and spin-spin coupling second derivatives
      inquire(file='NMR2.SCR',exist=lex)
      if(lex)then
       call w36('NMR second derivatives found.')
       allocate(ajm2(1:N**2,NAT,1:NAT),stat=is)
       if(is.ne.0)call report('cannot allocate ajm2')
       allocate(ajmq2(1:N**2,1:NAT,1:NAT),stat=is)
       if(is.ne.0)call report('cannot allocate ajmq2')
       allocate(sigma2(1:N**2,1:NAT),stat=is)
       if(is.ne.0)call report('cannot allocate sigma2')
       allocate(sigmaq2(1:N**2,1:NAT),stat=is)
       if(is.ne.0)call report('cannot allocate sigmaq2')
       open(15,file='NMR2.SCR',form='unformatted')
       read(15)optrot0
       read(15)(optrot2(I),I=1,N**2),loptrot
       read(15)(sigma0(II),II=1,NAT)
       read(15)((sigma2(I,II),I=1,N**2),II=1,NAT),lnmr
       read(15)((ajm0(II,J),II=1,NAT),J=1,NAT)
       read(15)(((ajm2(I,II,J),I=1,N**2),II=1,NAT),J=1,NAT),ljj
       close(15)
c
c      transform first index:
       do 81 iq=1,N
       do 81 ja=1,N
       ij=iq+N*(ja-1)
       optrotq2(ij)=0.0d0
       do 101 ia=1,N
       ii=ia+N*(ja-1)
101    optrotq2(ij)=optrotq2(ij)+optrot2(ii)*s(ia,iq)
       do 81 ixd=1,nat
       sigmaq2(ij,ixd)=0.0d0
       do 91 ia=1,N
       ii=ia+N*(ja-1)
91     sigmaq2(ij,ixd)=sigmaq2(ij,ixd)+sigma2(ii,ixd)*s(ia,iq)
       do 81 jxd=1,nat
       ajmq2(ij,ixd,jxd)=0.0d0
       do 81 ia=1,N
       ii=ia+N*(ja-1)
81     ajmq2(ij,ixd,jxd)=ajmq2(ij,ixd,jxd)+ajm2(ii,ixd,jxd)*s(ia,iq)
c
c      transform second index:
       do 82 iq=1,N
       do 82 jq=1,N
       ij=iq+N*(jq-1)
       optrot2(ij)=0.0d0
       do 102 ja=1,N
       ii=iq+N*(ja-1)
102    optrot2(ij)=optrot2(ij)+optrotq2(ii)*s(ja,jq)
       do 82 ixd=1,nat
       sigma2(ij,ixd)=0.0d0
       do 92 ja=1,N
       ii=iq+N*(ja-1)
92     sigma2(ij,ixd)=sigma2(ij,ixd)+sigmaq2(ii,ixd)*s(ja,jq)
       do 82 jxd=1,nat
       ajm2(ij,ixd,jxd)=0.0d0
       do 82 ja=1,N
       ii=iq+N*(ja-1)
82     ajm2(ij,ixd,jxd)=ajm2(ij,ixd,jxd)+ajmq2(ii,ixd,jxd)*s(ja,jq)

       open(21,file='PROP2.TXT.SCR')
331    read(21,*,end=6334,err=6334)
       goto 331
6334   write(21,*)N7,N
       write(21,*)loptrot
       write(21,2125)1,optrot0
       do 271 i=N7,N
       do 271 j= i,N
       ij=i+N*(j-1)
       ji=j+N*(i-1)
271    write(21,21261)i,j,optrot2(ij)/dsqrt(e(i)*e(j)),
     1 optrot2(ji)/dsqrt(e(i)*e(j))
21261  format(20x,2i5,2g15.5)
       write(21,*)lnmr
       write(21,2127)N/3
       do 281 i=1,N/3
281    write(21,2131)i,sigma0(i)
       do 291 i=1,N/3
       do 291 j=N7,N
       do 291 k=j,N
       jk=j+N*(k-1)
       kj=k+N*(j-1)
291    write(21,21282)i,j,k,sigma2(jk,i)/dsqrt(e(j)*e(k)),
     1 sigma2(kj,i)/dsqrt(e(j)*e(k))
21282  format(i20,2i5,2g15.5)
       write(21,*)ljj
       write(21,2129)N/3*N/3
       do 301 i=1,N/3
       do 301 j=1,N/3
301    write(21,21281)i,j,ajm0(i,j)
       do 311 i=1,N/3
       do 311 j=1,N/3
       do 311 k=N7,N
       do 311 l=k,N
       lk=l+N*(k-1)
       kl=k+N*(l-1)
311    write(21,21301)i,j,k,l,ajm2(kl,j,i)/dsqrt(e(k)*e(l)),
     1 ajm2(lk,j,i)/dsqrt(e(k)*e(l))
21301  format(2i10,2i5,2g15.5)
       close(21)
       call w36('PROP2.TXT.SCR made')
       deallocate(ajm2)
       deallocate(ajmq2)
       deallocate(sigma2)
       deallocate(sigmaq2)
      endif
c
c     second dipolar derivatives
      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR found, no trafo now')
      else
       inquire(file='TEN.SCR',exist=lex)
       if(lex)then
        open(15,file='TEN.SCR',form='unformatted')
        read(15)((((APTA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
        read(15)((((AATA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
        write(6,*)'sum rule APTA'
        write(3,*)'sum rule APTA'
        call sr2(APTA,NT0,NT3,nat)
        write(6,*)'sum rule AATA'
        write(3,*)'sum rule AATA'
        call sr2(AATA,NT0,NT3,nat)
c
        do 2 iq=N7,N
        do 2 jq=N7,N
        ij=iq+(jq-1)*n
        do 2 ixd=1,3
        aptaq(N**2+ij,ixd)=0.0d0
        aptaq(ij,ixd)=0.0d0
        aataq(ij,ixd)=0.0d0
        do 2 ia=1,nat
        do 2 iax=1,3
        i1=(ia-1)*3+iax
        do 2 ja=1,nat
        do 2 jax=1,3
        i2=(ja-1)*3+jax
        aataq(ij,ixd)=aataq(ij,ixd)+AATA(i1,ja,jax,ixd)*s(i1,iq)
     1  *s(i2,jq)
2       aptaq(ij,ixd)=aptaq(ij,ixd)+APTA(i1,ja,jax,ixd)*s(i1,iq)
     1  *s(i2,jq)

        ndif=0
        do 3 i=n,n7,-1
        ndif=ndif+1
        nml(ndif)=i
        do 3 j=n,n7,-1
        do 3 k=1,3
        aptaq(i+(j-1)*n,k)=aptaq(i+(j-1)*n,k)/sqrt(e(i)*e(j))
3       aataq(i+(j-1)*n,k)=aataq(i+(j-1)*n,k)*sqrt(e(j)/e(i))
c       aataq(i,j)=d^2m/dpidqj, first index - q
c
        call wrtenq(ndif,N,aptaq,aataq,NT3,nml)
c
       endif
      endif
c
c     polarizability derivatives
      inquire(file='TTTQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTQ.TXT.SCR found, no trafo now')
      else
       inquire(file='FILE.TTT',exist=lex)
       if(lex)then
        open(22,file='FILE.TTT')
        call readttt(N,NAT,ALPHA,GG,AA)
        close(22)
        sx=0.0d0
        sy=0.0d0
        sz=0.0d0
        do i=2,nat
         sx=sx+alpha(1,1,(i-1)*3+1)
         sy=sy+alpha(1,1,(i-1)*3+2)
         sz=sz+alpha(1,1,(i-1)*3+3)
        enddo
        call w36('sum rule Alpha')
        write(3,3001)sx,sy,sz,(alpha(1,1,i),i=1,3)
        write(6,3001)sx,sy,sz,(alpha(1,1,i),i=1,3)
3001    format(3f10.6,/,3f10.6)
        do 11 ixd=1,3
        do 11 iyd=1,3
        do 11 iq=N7,N
        alphaq(ixd,iyd,iq)=0.0d0
        gq(ixd,iyd,iq)=0.0d0
        do 11 ia=1,nat
        do 11 iax=1,3
        i1=iax+(ia-1)*3
        gq(ixd,iyd,iq)=gq(ixd,iyd,iq)+GG(ixd,iyd,i1)*s(i1,iq)
11      alphaq(ixd,iyd,iq)=alphaq(ixd,iyd,iq)+ALPHA(ixd,iyd,i1)*s(i1,iq)
        do 13 ixd=1,3
        do 13 iyd=1,3
        do 13 izd=1,3
        do 13 iq=N7,N
        aq(ixd,iyd,izd,iq)=0.0d0
        do 13 ia=1,nat
        do 13 iax=1,3
        i1=iax+(ia-1)*3
13      aq(ixd,iyd,izd,iq)=aq(ixd,iyd,izd,iq)
     1  +AA(ixd,iyd,izd,i1)*s(i1,iq)

        ndif=0
        do 14 iq=N,N7,-1
        ndif=ndif+1
        nml(ndif)=iq
        do 14 ixd=1,3
        do 14 iyd=1,3
        polar(ixd,iyd)=0.0d0
        alphaq(ixd,iyd,iq)=alphaq(ixd,iyd,iq)/dsqrt(dabs(e(iq)))
        gq(ixd,iyd,iq)=gq(ixd,iyd,iq)/dsqrt(dabs(e(iq)))
        do 14 izd=1,3
        adum(ixd,iyd,izd)=0.0d0
14      aq(ixd,iyd,izd,iq)=aq(ixd,iyd,izd,iq)/dsqrt(dabs(e(iq)))

        call wrttq(polar,ndif,nml,alphaq,alphaq,polar,adum,
     1  gq,aq,NT3)
c
       endif
      endif
c
      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTAQ.TXT.SCR found, no trafo now')
      else
       inquire(file='TTT.SCR',exist=lex)
       if(lex)then
        allocate(aaa(N,3,3,3,N))
        open(15,file='TTT.SCR',form='unformatted')
        read(15)((((alphaa(i,j,k,l),i=1,N),j=1,3),k=1,3),l=1,N)
        read(15)((((gaa(i,j,k,l),i=1,N),j=1,3),k=1,3),l=1,N)
        read(15)(((((aaa(i,j,k,m,l),i=1,N),j=1,3),k=1,3),m=1,3),l=1,N)
        close(15)

        sx=0.0d0
        sy=0.0d0
        sz=0.0d0
        do i=2,nat
         sx=sx+alphaa((i-1)*3+1,1,1,1)
         sy=sy+alphaa((i-1)*3+2,1,1,1)
         sz=sz+alphaa((i-1)*3+3,1,1,1)
        enddo
        write(6,*)'sum rule Alphaa'
        write(3,*)'sum rule Alphaa'
        write(3,3001)sx,sy,sz,(alphaa(i,1,1,1),i=1,3)
        write(6,3001)sx,sy,sz,(alphaa(i,1,1,1),i=1,3)
        sx=0.0d0
        sy=0.0d0
        sz=0.0d0
        do i=2,nat
         sx=sx+gaa((i-1)*3+1,1,1,1)
         sy=sy+gaa((i-1)*3+2,1,1,1)
         sz=sz+gaa((i-1)*3+3,1,1,1)
        enddo
        write(6,*)'sum rule gaa'
        write(3,*)'sum rule gaa'
        write(3,3001)sx,sy,sz,(gaa(i,1,1,1),i=1,3)
        write(6,3001)sx,sy,sz,(gaa(i,1,1,1),i=1,3)
        sx=0.0d0
        sy=0.0d0
        sz=0.0d0
        do i=2,nat
         sx=sx+aaa((i-1)*3+1,1,1,1,1)
         sy=sy+aaa((i-1)*3+2,1,1,1,1)
         sz=sz+aaa((i-1)*3+3,1,1,1,1)
        enddo
        write(6,*)'sum rule aaa'
        write(3,*)'sum rule aaa'
        write(3,3001)sx,sy,sz,(aaa(i,1,1,1,1),i=1,3)
        write(6,3001)sx,sy,sz,(aaa(i,1,1,1,1),i=1,3)
c
        do 21 iq=N7,n
        do 21 jq=N7,n
        ij=iq+(jq-1)*n
        do 21 ixd=1,3
        do 21 iyd=1,3
        ixy=ixd+(iyd-1)*3
        alphaaq(ij,ixy)=0.0d0
        gaq(ij,ixy)=0.0d0
        do 21 ia=1,nat
        do 21 iax=1,3
        i1=(ia-1)*3+iax
        do 21 ja=1,nat
        do 21 jax=1,3
        i2=(ja-1)*3+jax
        gaq(ij,ixy)=gaq(ij,ixy)
     1  +gaa(i1,ixd,iyd,i2)*s(i1,iq)*s(i2,jq)
21      alphaaq(ij,ixy)=alphaaq(ij,ixy)
     1  +alphaa(i1,ixd,iyd,i2)*s(i1,iq)*s(i2,jq)
        do 22 iq=N7,n
        do 22 jq=N7,n
        ij=iq+(jq-1)*n
        do 22 ixd=1,3
        do 22 iyd=1,3
        do 22 izd=1,3
        ixy=ixd+(iyd-1)*3+(izd-1)*9
        aaq(ij,ixy)=0.0d0
        do 22 ia=1,nat
        do 22 iax=1,3
        i1=(ia-1)*3+iax
        do 22 ja=1,nat
        do 22 jax=1,3
        i2=(ja-1)*3+jax
22      aaq(ij,ixy)=aaq(ij,ixy)
     1  +aaa(i1,ixd,iyd,izd,i2)*s(i1,iq)*s(i2,jq)
        do 41 i=N7,n
        do 41 j=N7,n
        do 41 ix=1,27
41      aaq(i+(j-1)*n,ix)=aaq(i+(j-1)*n,ix)/dsqrt(e(i)*e(j))
        do 4 i=N7,n
        do 4 j=N7,n
        do 4 ix=1,9
        alphaaq(i+(j-1)*n,ix)=alphaaq(i+(j-1)*n,ix)/dsqrt(e(i)*e(j))
4       gaq(i+(j-1)*n,ix)=gaq(i+(j-1)*n,ix)/dsqrt(e(i)*e(j))

        ndif=n-N7+1
        do 4001 i=1,N
4001    nml(i)=N7+i-1

        call wrttqaq(ndif,nml,N,NT3,alphaaq,gaq,aaq)
       endif
      endif
      return
      end
c
c     ===================================================
      SUBROUTINE readten(N0,P,A,NAT)
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION P(N0,3,3),A(N0,3,3)
      read(21,*) NAT
      DO 10 L=1,NAT
      DO 10 J=1,3
10    read(21,*) (P(L,J,I),I=1,3)
      DO 221 L=1,NAT
      DO 221 J=1,3
221   read(21,*)(A(L,J,I),I=1,3)
      RETURN
      END
C
      SUBROUTINE readttt(N,NAT,ALPHA,G,A)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION ALPHA(3,3,N),G(3,3,N),A(3,3,3,N)
      read(22,*)
      read(22,*)NAT
      read(22,*)
      read(22,*)
      DO 1 I=1,3
      read(22,*)
      DO 1 L=1,NAT
      DO 1 IX=1,3
      IIND=3*(L-1)+IX
1     read(22,*)Ldum,IXdum,(ALPHA(I,J,IIND),J=1,3)
      read(22,*)
      read(22,*)
      DO 2 I=1,3
      read(22,*)
      DO 2 L=1,NAT
      DO 2 IX=1,3
      IIND=3*(L-1)+IX
2     read(22,*)Ldum,IXdum,(G(I,J,IIND),J=1,3)
      read(22,*)
      read(22,*)
      DO 3 I=1,3
      DO 3 J=1,3
      read(22,*)
      DO 3 L=1,NAT
      DO 3 IX=1,3
      IIND=3*(L-1)+IX
3     read(22,*)Ldum,IXdum,(A(I,J,K,IIND),K=1,3)
      RETURN
      END
c    ============================================================
      subroutine sr(ix,NT0,APT,NAT)
      integer*4 ix,NT0,NAT,ia,i
      real*8 sx,sy,sz,APT(NT0,3,3)
c
      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      do ia=2,nat
       sx=sx+APT(ia,1,ix)
       sy=sy+APT(ia,2,ix)
       sz=sz+APT(ia,3,ix)
      enddo
      write(3,3000)sx,sy,sz,(APT(1,i,ix),i=1,3)
      write(6,3000)sx,sy,sz,(APT(1,i,ix),i=1,3)
3000  format(3f10.6,/,3f10.6)
      return
      end
c    ============================================================
      subroutine sr2(A,NT0,NT3,nat)
      integer*4 NT0,NT3,i
      real*8 sx,sy,sz,A(NT3,NT0,3,3)
      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      do 1 i=2,nat
      sx=sx+A((i-1)*3+1,1,1,1)
      sy=sy+A((i-1)*3+2,1,1,1)
1     sz=sz+A((i-1)*3+3,1,1,1)
      write(3,3001)sx,sy,sz,(A(i,1,1,1),i=1,3)
      write(6,3001)sx,sy,sz,(A(i,1,1,1),i=1,3)
3001  format(3f10.6,/,3f10.6)
      write(6,*)'second index'
      write(3,*)'second index'
      sx=0.0d0
      sy=0.0d0
      sz=0.0d0
      do 2 i=2,nat
      sx=sx+A(1,i,1,1)
      sy=sy+A(2,i,1,1)
2     sz=sz+A(3,i,1,1)
      write(3,3001)sx,sy,sz,(A(i,1,1,1),i=1,3)
      write(6,3001)sx,sy,sz,(A(i,1,1,1),i=1,3)
      return
      end
