      SUBROUTINE dotenix(N,bu)
c
c     S - s matrix (cart/nm) in atomic units is supplied
c     N - number of modes, N7 - starting mode
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      LOGICAL lex,ljj,loptrot,lnmr
      include 'dimensions.h'
      DIMENSION APT(NT0,3,3),bu(NT0,3,3),
     1AAT(NT0,3,3),aatq(NT3,3),aptq(NT3,3),aptn(NT3,3),
     1aataq(NT3**2,3),aptaq(2*NT3**2,3),ALPHA(3,3,NT3),
     1ALPHAA(NT3,3,3,NT3),alphaq(NT3,9),alphaaq(NT3**2,9),
     1apta(NT3,NT0,3,3),aata(NT3,NT0,3,3),GG(3,3,NT3),
     1AA(3,3,3,NT3),u(3),sigmax(2*NT3,NT0),sigmaq(2*NT3,NT0),
     1optrotx(2*NT3),dip0(3),nml(NT3),
     1optrotq(2*NT3),sigma0(NT0),ajm0(NT0,NT0),optrot2(NT3**2),
     1optrotq2(NT3**2),ggaq(NT3**2,9),aaaq(NT3**2,27)
c    large arrays:
      real*8,allocatable:: ajmx(:,:,:),ajmq(:,:,:),ajm2(:,:,:),
     1ajmq2(:,:,:),
     1sigma2(:,:),sigmaq2(:,:)
c     ajmx(2*NT3,NT0,NT0),ajmq(2*NT3,NT0,NT0)
c     ajm2(NT3**2,NT0,NT0),ajmq2(NT3**2,NT0,NT0),
c     sigma2(NT3**2,NT0),sigmaq2(NT3**2,NT0)
      logical live
      COMMON/lcbe/e(NT3),live(NT3)
      common/MASS/AM(NT3)
c
      call w36('Transformation of tensor derivatives')
c
      nat=n/3
      SFACR=0.02342179d0
      amu=1.0d0/SFACR**2
c
c     first dipolar derivatives
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR found, no trafo now')
       goto 10001
      endif
      inquire(file='FILE.TEN',exist=lex)
      if(.not.lex)call report('FILE.TEN not found')
      open(21,file='FILE.TEN')
      call readten(NT0,APT,AAT,NAT)
      close(21)
c
      do 101 i=1,3
      write(3,*)'sum rule - APT',i
      write(6,*)'sum rule - APT',i
101   call sr(i,NT0,APT,NAT)
      do 102 i=1,3
      write(3,*)'sum rule - AAT',i
      write(6,*)'sum rule - AAT',i
102   call sr(i,NT0,AAT,NAT)
c
      ndif=0
      do 1 ia=1,nat
      do 1 iax=1,3
      i=iax+3*(ia-1)
      ndif=ndif+1
      nml(ndif)=i
      dip0(iax)=0.0d0
      do 1 ixd=1,3
      aatq(i,ixd)=0.0d0
      aptq(i,ixd)=0.0d0
      if(live(i))then
      do 12 jax=1,3
      aatq(i,ixd)=aatq(i,ixd)+AAT(ia,jax,ixd)*bu(ia,jax,iax)
12    aptq(i,ixd)=aptq(i,ixd)+APT(ia,jax,ixd)*bu(ia,jax,iax)
      aatq(i,ixd)=aatq(i,ixd)/sqrt(e(i)*AM(i)*amu)
      aptq(i,ixd)=aptq(i,ixd)/sqrt(e(i)*AM(i)*amu)
      aptn(i,ixd)=aptq(i,ixd)
      aptn(i+N,ixd)=0.0d0
      endif
1     continue

      call wrten1q(dip0,ndif,.true.,aptn,aptq,NT3,aatq,nml,N)
c
c     write parallel ascii file:
      open(22,file='DIPOLE.TXT.SCR')
      read(22,*)u
      close(22)
      open(21,file='TENQ.TXT.SCR')
      write(21,2100)u
2100  format(3f15.7,' dipole (au)')
      write(21,*)'APT AAT first normal derivatives'
      write(21,*)n
      do 5 i=1,n
      do 5 ix=1,3
5     write(21,9000)i,i,ix,aptq(i,ix),
     1aptq(i,ix)/sqrt(e(i))
9000  format(3i5,2f15.6)
      do 6 i=1,n
      do 6 ix=1,3
6     write(21,9000)i,i,ix,aatq(i,ix)
      close(21)
      call w36('(ASCII TENQ.TXT.SCR)')
c
c     chemical shift and spin-spin coupling derivatives
      inquire(file='NMR.SCR.TXT',exist=lex)
      if(lex)then
       allocate(ajmx(1:2*N,1:NAT,1:NAT))
       allocate(ajmq(1:2*N,1:NAT,1:NAT))
       call rdnmr(optrot0,optrotx,sigma0,sigmax,ajm0,ajmx,
     1 NT3,NT0,N,nat,loptrot,lnmr,ljj)

       do 10 ia=1,N/3
       do 10 ix=1,3
       i=ix+3*(ia-1)

       optrotq(i+N)=0.0d0
       optrotq(i  )=0.0d0
       do 8 ixd=1,nat
       sigmaq(i+N,ixd)=0.0d0
       sigmaq(i  ,ixd)=0.0d0
       do 8 jxd=1,nat
       ajmq(i+N,ixd,jxd)=0.0d0
8      ajmq(i  ,ixd,jxd)=0.0d0

       if(live(i))then
       do 13 ixp=1,3
       ip=ixp+3*(ia-1)
       optrotq(i)=optrotq(i)+optrotx(ip)*bu(ia,ixp,ix)
       do 13 ixd=1,nat
       sigmaq(i,ixd)=sigmaq(i,ixd)+sigmax(ip,ixd)*bu(ia,ixp,ix)
       do 13 jxd=1,nat
13     ajmq(i,ixd,jxd)=ajmq(i,ixd,jxd)+ajmx(ip,ixd,jxd)*bu(ia,ixp,ix)

       do 14 ixp=1,3
       ip=ixp+3*(ia-1)
       optrotq(i+N)=optrotq(i+N)+optrotx(ip+N)*
     1 bu(ia,ixp,ix)*bu(ia,ixp,ix)
       do 14 ixd=1,nat
       sigmaq(i+N,ixd)=sigmaq(i+N,ixd)+sigmax(ip+N,ixd)*
     1 bu(ia,ixp,ix)*bu(ia,ixp,ix)
       do 14 jxd=1,nat
14     ajmq(i+N,ixd,jxd)=ajmq(i+N,ixd,jxd)+ajmx(ip+N,ixd,jxd)*
     1 bu(ia,ixp,ix)*bu(ia,ixp,ix)

       optrotq(i+N)=optrotq(i+N)/(e(i)*AM(i)*amu)
       optrotq(i)=optrotq(i)/dsqrt(e(i)*AM(i)*amu)
       do 16 ixd=1,nat
       sigmaq(i+N,ixd)=sigmaq(i+N,ixd)/(e(i)*AM(i)*amu)
       sigmaq(i,ixd)=sigmaq(i,ixd)/dsqrt(e(i)*AM(i)*amu)
       do 16 jxd=1,nat
       ajmq(i+N,ixd,jxd)=ajmq(i+N,ixd,jxd)/(e(i)*AM(i)*amu)
16     ajmq(i,ixd,jxd)=ajmq(i,ixd,jxd)/sqrt(e(i)*AM(i)*amu)
       endif
10     continue

c      open(22,file='DIPOLE.TXT.SCR')
c      read(22,*)u
c      read(22,*)optrot0
c      read(22,*)
c      do 548 i=1,nat
c48    read(22,*)idumm,sigma0(i)
c      read(22,*)
c      do 549 i=1,nat
c      do 549 j=1,nat
c49    read(22,*)idumm,idumm,ajm0(i,j)
c      close(22)
       inquire(file='PROP.TXT.SCR',exist=lex)
       if(lex)then
        call w36('PROP.TXT.SCR exists, not overwritten')
       else
        open(21,file='PROP.TXT.SCR')
        write(21,*)1,N
        write(21,*)loptrot
        write(21,2125)1,optrot0
2125    format('Optical rotation:',/,i5,/,20x,f10.2)
        do 27 i=1,N
27      write(21,2126)i,optrotq(i),optrotq(N+i)
2126    format(20x,i5,2f15.5)
        write(21,*)lnmr
        write(21,2127)N/3
2127    format('Chemical shifts:',/,i5)
        do 28 i=1,N/3
28      write(21,2131)i,sigma0(i)
2131    format(i20,f10.5)
        do 29 i=1,N/3
        do 29 j=1,N
29      write(21,2128)i,j,sigmaq(j,i),sigmaq(j+N,i)
2128    format(i20,i5,2f15.5)
        write(21,*)ljj
        write(21,2129)N/3*N/3
2129    format('Spin-Spin Couplings:',/,i5)
        do 30 i=1,N/3
        do 30 j=1,N/3
30      write(21,21281)i,j,ajm0(i,j)
21281   format(2i10,f10.5)
        do 31 i=1,N/3
        do 31 j=1,N/3
        do 31 k=1,N
31      write(21,2130)i,j,k,ajmq(k,j,i),ajmq(N+k,j,i)
2130    format(2i10,i5,2f15.5)
        close(21)
        call w36('PROP.TXT.SCR made')
       endif

       deallocate(ajmx)
       deallocate(ajmq)
      endif
c
c     chemical shift and spin-spin coupling second derivatives
      inquire(file='NMR2.SCR',exist=lex)
      if(lex)then
       call w36('NMR second derivatives found.')
       allocate(ajm2(1:N**2,NAT,1:NAT))
       allocate(ajmq2(1:N**2,1:NAT,1:NAT))
       allocate(sigma2(1:N**2,1:NAT))
       allocate(sigmaq2(1:N**2,1:NAT))
       open(15,file='NMR2.SCR',form='unformatted')
       read(15)optrot0
       read(15)(optrot2(I),I=1,N**2),loptrot
       read(15)(sigma0(II),II=1,NAT)
       read(15)((sigma2(I,II),I=1,N**2),II=1,NAT),lnmr
       read(15)((ajm0(II,J),II=1,NAT),J=1,NAT)
       read(15)(((ajm2(I,II,J),I=1,N**2),II=1,NAT),J=1,NAT),ljj
       close(15)

c      transform first index iq:
       do 84 ia=1,nat
       do 84 ix=1,3
       iq=ix+3*(ia-1)
       do 84 ja=1,N
       ij=iq+N*(ja-1)
       optrotq2(ij)=0.0d0
       do 81 ixd=1,nat
       sigmaq2(ij,ixd)=0.0d0
       do 81 jxd=1,nat
81     ajmq2(ij,ixd,jxd)=0.0d0
       if(live(iq))then
       do 103 ixp=1,3
       iqp=ixp+3*(ia-1)
       ii=iqp+N*(ja-1)
       optrotq2(ij)=optrotq2(ij)+optrot2(ii)*bu(ia,ixp,ix)/
     1 dsqrt(e(iq)*AM(iq)*amu)
       do 103 ixd=1,nat
       sigmaq2(ij,ixd)=sigmaq2(ij,ixd)+sigma2(ii,ixd)*bu(ia,ixp,ix)/
     1 dsqrt(e(iq)*AM(iq)*amu)
       do 103 jxd=1,nat
103    ajmq2(ij,ixd,jxd)=ajmq2(ij,ixd,jxd)+ajm2(ii,ixd,jxd)
     1 *bu(ia,ixp,ix)/dsqrt(e(iq)*AM(iq)*amu)
       endif
84     continue
c
c      transform second index:
       do 83 iq=1,N
       do 83 ja=1,nat
       do 83 jx=1,3
       jq=jx+3*(ja-1)
       ij=iq+N*(jq-1)
       optrot2(ij)=0.0d0
       do 82 ixd=1,nat
       sigma2(ij,ixd)=0.0d0
       do 82 jxd=1,nat
82     ajm2(ij,ixd,jxd)=0.0d0
       do 104 jxp=1,3
       jqp=jxp+3*(ja-1)
       jj=iq+N*(jqp-1)
       optrot2(ij)=optrot2(ij)+optrotq2(jj)*bu(ja,jxp,jx)
     1 /dsqrt(e(jq)*AM(jq)*amu)
       do 104 ixd=1,nat
       sigma2(ij,ixd)=sigma2(ij,ixd)+sigmaq2(jj,ixd)*bu(ja,jxp,jx)
     1 /dsqrt(e(jq)*AM(jq)*amu)
       do 104 jxd=1,nat
104    ajm2(ij,ixd,jxd)=ajm2(ij,ixd,jxd)+ajmq2(jj,ixd,jxd)*bu(ja,jxp,jx)
     1 /dsqrt(e(jq)*AM(jq)*amu)
83     continue

       open(21,file='PROP2.TXT.SCR')
331    read(21,*,end=6334,err=6334)
       goto 331
6334   write(21,*)1,N
       write(21,*)loptrot
       write(21,2125)1,optrot0
       do 271 i=1,N
       do 271 j= i,N
       ij=i+N*(j-1)
       ji=j+N*(i-1)
271    write(21,21261)i,j,optrot2(ij),optrot2(ji)
21261  format(20x,2i5,2g15.5)
       write(21,*)lnmr
       write(21,2127)N/3
       do 281 i=1,N/3
281    write(21,2131)i,sigma0(i)
       do 291 i=1,N/3
       do 291 j=1,N
       do 291 k=j,N
       jk=j+N*(k-1)
       kj=k+N*(j-1)
291    write(21,21282)i,j,k,sigma2(jk,i),sigma2(kj,i)
21282  format(i20,2i5,2g15.5)
       write(21,*)ljj
       write(21,2129)N/3*N/3
       do 301 i=1,N/3
       do 301 j=1,N/3
301    write(21,21281)i,j,ajm0(i,j)
       do 311 i=1,N/3
       do 311 j=1,N/3
       do 311 k=1,N
       do 311 l=k,N
       lk=l+N*(k-1)
       kl=k+N*(l-1)
311    write(21,21301)i,j,k,l,ajm2(kl,j,i),ajm2(lk,j,i)
21301  format(2i10,2i5,2g15.5)
       close(21)
       call w36('PROP2.TXT.SCR made')
       deallocate(ajm2)
       deallocate(ajmq2)
       deallocate(sigma2)
       deallocate(sigmaq2)
      endif
c
c     second dipolar derivatives
10001 continue
      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR found, no trafo now')
       goto 10002
      endif
      inquire(file='TEN.SCR',exist=lex)
      if(lex)then
       open(15,file='TEN.SCR',form='unformatted')
       read(15)((((APTA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
       read(15)((((AATA(i,j,k,l),i=1,N),j=1,nat),k=1,3),l=1,3)
       write(6,*)'sum rule APTA'
       write(3,*)'sum rule APTA'
       call sr2(APTA,NT0,NT3,nat)
       write(6,*)'sum rule AATA'
       write(3,*)'sum rule AATA'
       call sr2(AATA,NT0,NT3,nat)
c
       ndif=0
       do 2 ia=1,nat
       do 2 ix=1,3
       i=ix+3*(ia-1)
       ndif=ndif+1
       nml(ndif)=i
       do 2 ja=1,nat
       do 2 jx=1,3
       j=jx+3*(ja-1)
       ij=i+n*(j-1)
       do 2 k=1,3
       aataq(ij,k)=0.0d0
       aptaq(ij,k)=0.0d0
       aptaq((3*nat)**2+ij,k)=0.0d0
       if(live(i).and.live(j))then
       do 3 ixp=1,3
       ip=ixp+3*(ia-1)
       do 3 jxp=1,3
       aataq(ij,k)=aataq(ij,k)+AATA(ip,ja,jxp,k)*bu(ia,ixp,ix)
     1 *bu(ja,jxp,jx)
3      aptaq(ij,k)=aptaq(ij,k)+APTA(ip,ja,jxp,k)*bu(ia,ixp,ix)
     1 *bu(ja,jxp,jx)
       aptaq(ij,k)=aptaq(ij,k)/dsqrt(e(i)*AM(i)*amu*e(j)*AM(j)*amu)
       aataq(ij,k)=aataq(ij,k)/dsqrt(e(i)*AM(i)*amu/e(j)*AM(j)*amu)
c      aataq(i,j)=d^2m/dpidqj, first index - q
       endif
2      continue
c
       call wrtenq(ndif,N,aptaq,aataq,NT3,nml)
c
      endif
10002 continue
c
c     polarizability derivatives
      inquire(file='TTTQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTQ.TXT.SCR found, no trafo now')
       goto 10003
      endif
      inquire(file='FILE.TTT',exist=lex)
      if(lex)then
       open(22,file='FILE.TTT')
       call readttt(N,NAT,ALPHA,GG,AA)
       close(22)
       sx=0.0d0
       sy=0.0d0
       sz=0.0d0
       do i=2,nat
        sx=sx+alpha(1,1,(i-1)*3+1)
        sy=sy+alpha(1,1,(i-1)*3+2)
        sz=sz+alpha(1,1,(i-1)*3+3)
       enddo
       call w36('sum rule Alpha')
       write(3,3001)sx,sy,sz,(alpha(1,1,i),i=1,3)
       write(6,3001)sx,sy,sz,(alpha(1,1,i),i=1,3)
3001   format(3f10.6,/,3f10.6)
       do 11 ixd=1,3
       do 11 iyd=1,3
       ixy=ixd+(iyd-1)*3
       do 11 ia=1,nat
       do 11 ix=1,3
       i=ix+(ia-1)*3
       alphaq(i,ixy)=0.0d0
       if(live(i))then
       do 15 ixp=1,3
       ip=ixp+3*(ia-1)
15     alphaq(i,ixy)=alphaq(i,ixy)+ALPHA(ixd,iyd,ip)*bu(ia,ixp,ix)
       alphaq(i,ixy)=alphaq(i,ixy)/dsqrt(e(i)*AM(i)*amu)
       endif
11     continue
c
       open(9,file='TTTQ.TXT.SCR')
       write(9,9004)((0.0d0,j=1,3),i=1,3)
9004   format(3(3f15.7,' au',/),
     1 ' Normal mode polarizability derivatives num anal')
       write(9,*)N
       DO 19 I=1,N
       do 19 j=1,3
       do 19 k=1,3
       ix=j+3*(k-1)
19     write(9,9005)I,I,j,k,alphaq(I,ix),alphaq(I,ix)
9005   format(4i5,2f15.6)
       close(9)

      endif
10003 continue
c
      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTAQ.TXT.SCR found, no trafo now')
       return
      endif
      inquire(file='TTT.SCR',exist=lex)
      if(lex)then
       open(15,file='TTT.SCR',form='unformatted')
       read(15)((((alphaa(i,j,k,l),i=1,N),j=1,3),k=1,3),l=1,N)
       close(15)
       sx=0.0d0
       sy=0.0d0
       sz=0.0d0
       do i=2,nat
        sx=sx+alphaa((i-1)*3+1,1,1,1)
        sy=sy+alphaa((i-1)*3+2,1,1,1)
        sz=sz+alphaa((i-1)*3+3,1,1,1)
       enddo
       write(6,*)'sum rule Alphaa'
       write(3,*)'sum rule Alphaa'
       write(3,3001)sx,sy,sz,(alphaa(i,1,1,1),i=1,3)
       write(6,3001)sx,sy,sz,(alphaa(i,1,1,1),i=1,3)
c
       do 21 ixd=1,3
       do 21 iyd=1,3
       ixy=ixd+(iyd-1)*3
       alphaaq(ij,ixy)=0.0d0
       ggaq(ij,ixy)=0.0d0
       aaaq(ij,ixy)=0.0d0
       aaaq(ij,ixy+9)=0.0d0
       aaaq(ij,ixy+18)=0.0d0
       do 21 ia=1,nat
       do 21 iax=1,3
       i1=(ia-1)*3+iax
       do 21 ja=1,nat
       do 21 jax=1,3
       i2=(ja-1)*3+jax
       ij=i1+(i2-1)*n
       alphaaq(ij,ixy)=0.0d0
       if(live(i1).and.live(i2))then
       do 22 ixp=1,3
       ip=(ia-1)*3+ixp
       do 22 jxp=1,3
       jp=(ja-1)*3+jxp
22     alphaaq(ij,ixy)=alphaaq(ij,ixy)+alphaa(ip,ixd,iyd,jp)*
     1 bu(ia,ixp,iax)*bu(ja,jxp,jax)
       alphaaq(ij,ixy)=alphaaq(ij,ixy)
     1 /dsqrt(e(i1)*AM(i1)*amu*e(i2)*AM(i2)*amu)
       endif
21     continue

       call wrttqaq(n,nml,N,NT3,alphaaq,ggaq,aaaq)
      endif
      return
      end
c
