      SUBROUTINE ENA3(ASL)
c     perturbation property calculation with possible degenerate levels
      implicit none
      integer*4 NX4,NQQ,NXX,iu,K,ISY1,ISY2,ix
      include 'dimensions.h'
      PARAMETER (NX4=NT3*((NT3*(NT3+1))/2),
     1NQQ=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6,
     1NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6 )
      INTEGER*4 STATE1(NT3),STATE2(NT3),N,N7,ICS,NCSP,NCAN,ICAN,
     1NZF,IBR,IERM,LEXCL,K4,L44,KP4,LPP4,NCO,NAT,I,J,idumm,
     1ifindsym1,im,imo,iq,jq,jx,L,ndif,NDSP,I1,I2,
     1I3,I4,I5,iud,nud,IDS,NN,N77
      real*8 avq(NT3),avq2(NT3,NT3),CQ4,DS,CH,AH4L,CM,
     1S(NT3,NT3),R(3,NT0),X(3,NT0),E,A,CIJK,CS,BOHR,dm,
     1QPQ(3,NT3,NT3),ASL,ADUM,
     1EF,E1,E2,E3,E4,E5,S1QIQJS2,u(3),aptn(NT3*2,3),DEBYE,
     1aptaq(2*NT3**2,3),aataq(NT3**2,3)
      COMMON/CEM/E(NT3)
      LOGICAL L4,LSPARSE,lex
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4
      COMMON/DIA2A/CIJK(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      real*8 ropt,OH,DOH
      COMMON/opt/ropt(100)
      equivalence (OH,ropt(15)),(DOH,ropt(16))
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LH40
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/VQA/CQ4(NT3,NT3,NT3)
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      COMMON/RUNCON/LEXCL
      COMMON/V4/CH(NX4),K4(NX4),L44(NX4),KP4(NX4),LPP4(NX4),
     1AH4L,NCO
      COMMON/BLANKC/N77,NN
      logical lopt,lfff
      COMMON/lop/lopt(300)
      equivalence (lopt(43),lfff)

      call w36(' ')
      call w36('Ena3')
      call w36('^^^^')

      if(lfff)call report('Ena3 not compatible with LFFF')

      CM=219470.0d0
C     1 a.u.= 2.1947E5 cm^-1
      BOHR=0.529177d0
      DEBYE=2.541732d0
      call w36('Properties by perturbation')
      N77=N7
      NN=N

      OPEN(2,FILE='FILE.X')
      READ(2,*)
      READ(2,*)NAT
      DO 36 K=1,NAT
      READ(2,*)idumm,(R(I,K),I=1,3)
      DO 36 I=1,3
36    R(I,K)=R(I,K)/BOHR
      CLOSE(2)
      call w36('Coordinates from FILE.X')

      OPEN(2,FILE='SMAT.SCR',FORM='UNFORMATTED')
      READ(2)NAT,(E(I),I=1,3*NAT),((S(I,J),J=1,3*NAT),I=1,3*NAT)
      CLOSE(2)
      call w36('SMATRIX from SMAT.SCR')

      call rdtenq(aptaq,aataq,N,NT3)
      do 90 i=N7,n
      do 90 j=N7,n
      do 90 ix=1,3
90    QPQ(ix,i,j)=aptaq(i+(j-1)*n,ix)

      call w36('PERTURBATIONAL CALCULATION ENA3')
      write(6,6363)QUARTIC,LSPARSE,LEXCL,N7,N
      write(3,6363)QUARTIC,LSPARSE,LEXCL,N7,N
6363  format('quartic',l2,', sparse',l2,', LEXCL',i3,', N7',i4,', N',i4)
c
      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)

c     user-requested states
      nud=0
      inquire(file='HAND.OPT',exist=lex)
      if(lex)then
       call w36(' user defined states:')
       OPEN(2,FILE='HAND.OPT')
891    READ(2,*,end=892,err=892)(STATE2(J),J=N7,N)
       nud=nud+1
       goto 891
892    close(2)
       if(nud.gt.0)then
        write(6,6009)nud
        write(3,6009)nud
6009    format(i5,' user-defined states')
       endif
      endif
c
c     loop over ground and fundamental states S1:
      do 3333 iu=N7-1,N+nud
      DO 33 I=N7,N
      STATE1(I)=0
33    STATE2(I)=0
      EF=0.0d0
      E1=0.0d0
      E2=0.0d0
      E3=0.0d0
      E4=0.0d0
      E5=0.0d0
      if(iu.eq.N7-1)then
       write(3,3011)
       write(6,3011)
3011   format(/,/,' Ground state properties:',/
     1           ,' ************************',/)
      else
       if(iu.le.N)then
        write(3,3010)iu,E(iu)*CM
        write(6,3010)iu,E(iu)*CM
3010    format(/,/,' Properties of state ',i5,f10.2,' cm-1:',/,
     1             ' *****************************************',/)
        STATE1(iu)=1
        EF=E(iu)
       else
        OPEN(2,FILE='HAND.OPT')
        do 893 iud=1,iu-N
893     READ(2,*)(STATE1(J),J=N7,N)
        close(2)
        do 894 J=N7,N
894     EF=EF+dble(state1(J))*E(J)
        write(3,3010)iu,EF*CM
        write(6,3010)iu,EF*CM
       endif
      endif
      ISY1=IFINDSYM1(N,STATE1,N7)
c
c     avq =2 sum(S2) VS1S1/ES1S2 <S1|Q|S2>
c     avq2=sum(S2) VS1S1/ES1S2 <S1|QQ|S2>+0.5<STATE1|QQ|STATE1>
      do 10 I=N7,N
      avq(I)=0.0d0
      do 10 J=N7,N
10    avq2(I,J)=0.5d0*S1QIQJS2(STATE1,I,J,STATE1)
c
c     generate excited states:
C
C     GROUND STATE:
      ISY2=IFINDSYM1(N,STATE2,N7)
      IF(ISY2.EQ.ISY1)call addstate(avq,avq2,EF,0.0d0)
C     MONO-EXCITED STATES:
      DO 66 I1=N7,N
      STATE2(I1)=STATE2(I1)+1
      E1=E(I1)
      ISY2=IFINDSYM1(N,STATE2,N7)
      IF(ISY2.EQ.ISY1)call addstate(avq,avq2,EF,E1)
      IF(LEXCL.LT.2)GOTO 72
C     DOUBLE EXCITED STATES:
      DO 67 I2=I1,N
      STATE2(I2)=STATE2(I2)+1
      E2=E1+E(I2)
      ISY2=IFINDSYM1(N,STATE2,N7)
      IF(ISY2.EQ.ISY1)call addstate(avq,avq2,EF,E2)
      IF(LEXCL.LT.3)GOTO 74
C     TRIPLE-EXCITED STATES:
      DO 68 I3=I2,N
      STATE2(I3)=STATE2(I3)+1
      ISY2=IFINDSYM1(N,STATE2,N7)
      E3=E2+E(I3)
      IF(ISY2.EQ.ISY1)call addstate(avq,avq2,EF,E3)
      IF(LEXCL.LT.4)GOTO 76
C     QUADRUPLE-EXCITED STATES:
      DO 69 I4=I3,N
      STATE2(I4)=STATE2(I4)+1
      ISY2=IFINDSYM1(N,STATE2,N7)
      E4=E3+E(I4)
      IF(ISY2.EQ.ISY1)call addstate(avq,avq2,EF,E4)
      IF(LEXCL.LT.5)GOTO 78
C     PENTA-EXCITED STATES:
      DO 70 I5=I4,N
      STATE2(I5)=STATE2(I5)+1
      ISY2=IFINDSYM1(N,STATE2,N7)
      E5=E4+E(I5)
      IF(ISY2.EQ.ISY1)call addstate(avq,avq2,EF,E5)
70    STATE2(I5)=STATE2(I5)-1
78    CONTINUE
69    STATE2(I4)=STATE2(I4)-1
76    CONTINUE
68    STATE2(I3)=STATE2(I3)-1
74    CONTINUE
67    STATE2(I2)=STATE2(I2)-1
72    CONTINUE
66    STATE2(I1)=STATE2(I1)-1
C
      write(6,6005)
      write(3,6005)
6005  format(' Normal mode averages <qi> <qii> <Qii>:')
      DO 551 IQ=N7,N
      write(3,6008)IQ,avq(IQ),avq2(IQ,IQ),avq2(IQ,IQ)/E(IQ)
551   write(6,6008)IQ,avq(IQ),avq2(IQ,IQ),avq2(IQ,IQ)/E(IQ)
6008  format(i5,3f10.5)
c
c     property at state f':
c     from second order perturbation theory we get
c     f'=f+sum(e)Vef/(Ef-Ee) e
c     where e,f are unperturbed states, so that
c     pf'=<f'|p|f'>=<f+sum(e)Vef/(Ef-Ee) e|p|f+sum(e)Vef/(Ef-Ee) e>
c     pf'~<f|p|f>+2sum(e)<f|p|e>Vef/(Ef-Ee)
c     we can expand p aroudn equilibrium p0,
c     p=p0+dp/dQi Qi+0.5dp^2/dQi/dQj2QiQj=p0+pi Qi+0.5pij QiQj
c     pf'~p0+0.5pij<f|QiQj|f>+2sum(e)pi<f|Qi|e>Vef/(Ef-Ee)
c     +sum(e)pij<f|QiQj|e>Vef/(Ef-Ee)
c     =p0+pij(0.5<f|QiQj|f>+sum(e)<f|QiQj|e>Vef/(Ef-Ee))
c      +2sum(e)pi<f|Qi|e>Vef/(Ef-Ee)
c
c     therefore, we define
c     avqi = 2 sum(e) Vef/(Ef-Ee) <f|Qi|e>
c     avq2ij=0.5<f|QiQj|f>+sum(e) Vef/(Ef-Ee) <f|QiQj|e>
c     so that
c           p=p0+pij avq2ij+pi avqi
c
c     for the dimensionaless coordinates qi, the elemets are
c     divided by sqrt(ei)
c
c     geometry
      DO 19 L=1,NAT
      DO 19 ix=1,3
      X(ix,L)=R(ix,L)
      DO 19 IQ=N7,N
19    X(ix,L)=X(ix,L)+S(3*(L-1)+ix,IQ)*avq(IQ)/DSQRT(DABS(E(IQ)))
      DO 56 L=1,NAT
      WRITE(6,5242)idumm,(X(ix,L)*BOHR,ix=1,3)
56    WRITE(3,5242)idumm,(X(ix,L)*BOHR,ix=1,3)
5242  FORMAT(I5,3F15.8)
c
c     dipole moment u=u0+APT.<q>
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       open(9,file='TENQ.TXT.SCR')
       read(9,*)(u(ix),ix=1,3)
       dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
       write(6,6003)
       write(3,6003)
6003   format(/,' Dipole moments          atomic units     ',
     1 '                           debye')
       write(3,6004)
       write(6,6004)
6004   format(' equilibrium:')
       write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
       write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
6002   format(2('       ux       uy       uz      norm'),/,
     1 2(3f9.5,1x,f9.5),/)
       read(9,*)
       read(9,*)ndif
       do 231 im=N7,N
       do 231 jx=1,3
       aptn(im+N,jx)=0.0d0
231    aptn(im,jx)=0.0d0
       do 23 im=1,ndif
       do 23 jx=1,3
23     read(9,*)idumm,imo,idumm,aptn(imo,jx),aptn(imo+N,jx)
       close(9)
       do 21 jx=1,3
       do 21 IQ=N7,N
21     u(jx)=u(jx)+aptn(IQ,jx)*avq(IQ)
       dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
       write(3,6006)
       write(6,6006)
6006   format(' with first-derivative corrections:')
       write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
       write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
       inquire(file='TENAQ.TXT.SCR',exist=lex)
       if(lex)then
        do 221 jx=1,3
        do 221 IQ=N7,N
        do 221 JQ=N7,N
221     u(jx)=u(jx)+QPQ(jx,IQ,JQ)*avq2(IQ,JQ)
        dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
       else
        do 222 jx=1,3
        do 222 IQ=N7,N
222     u(jx)=u(jx)+aptn(IQ+N,jx)*avq2(IQ,IQ)
        dm=dsqrt(u(1)**2+u(2)**2+u(3)**2)
       endif
       write(3,6007)
       write(6,6007)
6007   format(' with first and second-derivative corrections:')
       write(6,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
       write(3,6002)(u(ix),ix=1,3),dm,(u(ix)*DEBYE,ix=1,3),dm*DEBYE
      endif
c
c     other properties from first derivatives:
      call proder(avq,avq2,N7)

3333  continue
      call w36('Ena3-ok')
      RETURN
      END

      subroutine addstate(avq,avq2,E1,E2)
      implicit none
      logical*4 L4
      integer*4 N7,N,S1,S2,i,j,NCAN,ICAN,NZF,IBR,
     1IERM,ic
      include 'dimensions.h'
      COMMON/SUM/A,S1(NT3),S2(NT3),N7,N,L4
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LH40,LSPARSE
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      real*8 avq(*),avq2(NT3,NT3),E2,E1,A,rat,AAf,S1QIS2,
     1S1QIQJS2,V
      ic=0
      do 1 I=N7,N
1     if(S1(I).ne.S2(I))ic=ic+1
      if(ic.eq.0)return
      V=0.0d0
      A=0.0d0
C     Quartic
      IF(QUARTIC)THEN
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       V=V+A
c      write(6,*)'quartic',A
      ENDIF
      A=0.0d0
C     Kinetic
      IF(LH40)THEN
       CALL SUM4
       V=V+A
c      write(6,*)'kinetic',A
      ENDIF
C     VE
      A=0.0d0
      IF(NZF.NE.0)THEN
       CALL SUMSE
       V=V+A
c      write(6,*)'nzf',A
      ENDIF
C     V3
      A=0.0d0
      IF(LSPARSE)THEN
       CALL SUMSGHOST
       V=V+A
      ELSE
       CALL SUMS
       V=V+A
      ENDIF
c      write(6,*)'cube',A
      if(dabs(V).gt.1.0d-10)then
       rat=AAf(E1,E2,V)/V
c      rat ~ V/(E1-E2)
c      del=0.0d0
       do 11 I=N7,N
       avq(I)=avq(I)+2.0d0*rat*S1QIS2(S1,I,S2)
c      del=del+2.0d0*rat*S1QIS2(S1,I,S2)
c      if(rat*S1QIS2(S1,I,S2).ne.0.0d0)write(6,*)I,rat,S1QIS2(S1,I,S2)
       do 11 J=N7,N
11     avq2(I,J)=avq2(I,J)+rat*S1QIQJS2(S1,I,J,S2)
c      if(del.ne.0.0d0)then
c     write(6,*)del,E1,E2,V
c     write(6,700)(S1(I),I=N7,N)
c     write(6,700)(S2(I),I=N7,N)
c00   format(120i1)
c      stop
c      endif
      endif
      return
      end
