      subroutine evscf(vscf_nbase,nnmodes,EOLD,N,N7)
c     routine to get vscf energies, originally written by P. Danecek
      include 'common.h'
      real*8 EOLD(*)
      integer*4 vscf_nbase,nnmodes,N,N7

      call init_fdpool()
      call start_logging()
      call evscf_freqs(nnmodes,vscf_nbase,EOLD,N,N7)
      call stop_logging()
      end

      subroutine evscf_freqs(nnmodes,vscf_nbase,E,N,N7)
      include 'common.h'
      real*8 AC,E(*)
      real*8,allocatable:: CQ(:)
      integer nnmodes,vscf_nbase,N,N7,i,j,k,NOFF
      integer imode,is
      integer func_exc(nnmodes)
      real*8 qff2(nnmodes), qff3(nnmodes,nnmodes,nnmodes)
      real*8 qff4(nnmodes,nnmodes,nnmodes)
      real*8 gnd_ept0, gnd_ept1, ept0,ept1
      real*8 freq_pt0

      allocate(CQ(1:N**3),stat=is)
      if(is.ne.0)call report('cannot allocate CQ in docq')

      noff=N7-1
      do 1 i=1,nnmodes
c     in atomic units, (hartrees)
1     qff2(i)=e(i+noff)
c
c     call ff3_read_symmetric(nnmodes, qff3, getopt_or_die('GVIB_QFF3'))
      call load3(CQ,N)
      DO 4 I=N7,N
      DO 4 J=I,N
      DO 4 K=J,N
      AC=CQ(I+(J-1)*N+(K-1)*N**2)
      qff3(I-noff,J-noff,K-noff)=AC
      qff3(J-noff,I-noff,K-noff)=AC
      qff3(K-noff,J-noff,I-noff)=AC
      qff3(I-noff,K-noff,J-noff)=AC
      qff3(K-noff,I-noff,J-noff)=AC
4     qff3(J-noff,K-noff,I-noff)=AC
      deallocate(CQ)

c     call qff4_read(nnmodes, qff4, getopt_or_die('GVIB_QFF4'))
      do 6 i=1,nnmodes
      do 6 j=1,nnmodes
      do 6 k=1,nnmodes
6     qff4(i,j,k)=0.0d0
      OPEN(4,FILE='DQQ.SCR.TXT',STATUS='OLD')
7     READ(4,*,end=99,err=99)i,j,k,AC
c     AC=AC/DABS(E(i))/DSQRT(ABS(E(j)*E(k)))
      if(i.ge.N7.and.j.ge.N7.and.k.ge.N7)then
       qff4(k-noff,j-noff,i-noff)=AC
       qff4(j-noff,k-noff,i-noff)=AC
      endif
c     write(6,*)AC
      goto 7
99    CLOSE(4)

      do 2 imode=1,nnmodes
2     func_exc(imode) = 0
      call calc_evscf_energies(nnmodes,vscf_nbase,func_exc, qff2,qff3,
     1qff4, gnd_ept0,gnd_ept1)
      if (verbose) write(log_fd,*)'  -> zero-point VSCF energy = ',
     1gnd_ept1*cminv_to_JouleMol*V2sqrt_to_cminv,' [Joules/Mol]'

      write(6,6001)
      write(3,6001)
6001  format('  EVSCF energies',/,80(1h-))
      write(3,6002)0 ,  V2sqrt_to_cminv * gnd_ept1,0.0d0
      do 3 imode=1,nnmodes
      if (imode.gt.1) func_exc(imode-1) = 0
      func_exc(imode) = 1
      call calc_evscf_energies(nnmodes,vscf_nbase,func_exc,
     1qff2,qff3,qff4, ept0,ept1)
      freq_pt0 = V2sqrt_to_cminv * (ept1-gnd_ept1)
      write(3,6002)imode,V2sqrt_to_cminv*ept1,freq_pt0
3     write(6,6002)imode,V2sqrt_to_cminv*ept1,freq_pt0
6002  format(i6,2f12.2)
      write(6,6003)
      write(3,6003)
6003  format(80(1h-))


      end
