      subroutine evscf_iteration(vscf_nbase,nnmodes,qff2,qff3,qff4,
     1func_exc, vscf_func, vscf_funcs,vscf_energies,evscf)
      include 'common.h'
c In:
      integer vscf_nbase,nnmodes
      integer func_exc(nnmodes)
      real*8 qff2(nnmodes), qff3(nnmodes,nnmodes,nnmodes)
      real*8 qff4(nnmodes,nnmodes,nnmodes)      
c Out:
      ! The parameters of vscf_funcs are: (excitations,vscf_base_funcs_coefficients,modes)
      real*8 vscf_funcs(vscf_nbase,vscf_nbase,nnmodes)
      
      ! The one-mode VSCF energies of excited states
      real*8  vscf_energies(vscf_nbase,nnmodes)

      ! The total energy of the requested multimode function
      real*8 evscf
c InOut:
      ! The first index of vscf_func goes over the coefficients, the second over modes
      real*8 vscf_func(vscf_nbase,nnmodes)

      
      integer imode,ie,ibase,j
      real*8 hamiltonian(vscf_nbase,vscf_nbase)
      real*8 energies(vscf_nbase), mean_q1234(nnmodes,4), e(vscf_nbase) !, en

   
      call calc_vscf_mean_q1234(vscf_nbase,nnmodes,vscf_func,mean_q1234)

      evscf = 0
      do imode=1,nnmodes

	    call init_1mode_vscf_hamiltonian(imode,vscf_nbase,nnmodes,
     1      qff2,qff3,qff4,mean_q1234,hamiltonian)

	    call tred2(hamiltonian, vscf_nbase, energies, e)
	    call tqli(energies, e, vscf_nbase, hamiltonian, .true.)

	    ! The solutions are sorted ascendently from tqli.
	    ie = func_exc(imode)+1
	    if ( ie.lt.1 .or. ie.gt.vscf_nbase ) then
		  write(log_fd,*)'FIXME: func_exc out of range: ',ie,
     1            func_exc(imode),vscf_nbase
		  write(0,*)'FIXME: func_exc out of range: ',ie,
     1            func_exc(imode),vscf_nbase
		  call exit_nicely()
	    end if

	    ! The energy should not be negative
	    if (energies(ie).lt.0) then
		  write(log_fd,*)'FIXME: energies<0 .. ',energies
		  write(0,*)'FIXME: energies<0 .. ',energies
		  write(log_fd,*)'The old VSCF function was:'
		  write(0,*)'The old VSCF function was:'
		  do j=1,nnmodes
			write(log_fd,*)'imode=',j,' .. ',
     1                  (vscf_func(ie,j),ie=1,vscf_nbase)
			write(0,*)'imode=',j,' .. ',(vscf_func(ie,j),
     1                  ie=1,vscf_nbase)
		  end do
		  call exit_nicely()
	    end if

	    evscf = evscf + energies(ie)

	    ! Update the i-th normal mode's wavefunctions
	    ! ... the self-consistent solution:
	    do ibase=1,vscf_nbase
		  vscf_func(ibase,imode) = hamiltonian(ibase,ie)
	    end do
	    
	    ! ... the orthogonal solutions (we need to change the descendent order
	    ! to ascendent)
	    do ibase=1,vscf_nbase
		  do ie=1,vscf_nbase
		   vscf_funcs(ie,ibase,imode) = hamiltonian(ibase,ie)
		  end do
		  vscf_energies(ibase,imode) = energies(ibase)
	    end do
      end do

c      call calc_vscfpt1_energy(nnmodes,vscf_nbase,vscf_func,qff2,qff3,qff4,en)
c      write(log_fd,*)        '    total E(vscf+pt1): ',en*V2sqrt_to_cminv,' [1/cm]'
c      if (verbose) write(*,*)'    total E(vscf+pt1): ',en*V2sqrt_to_cminv,' [1/cm]'

      end 


