      subroutine harmonic(FCAR,zim,nat,s,lnm,LSCALED)
      implicit none
      integer*4 N,IERR,i,nat,j,IMOD,JMIN,K
      include 'dimensions.h'
      real*8 ZIM(NT3),AS(NT3),FCAR(NT3,NT3),s(NT3,NT3),E(NT3),
     1eh,ZM,FNEW,SMAT,Q,CONST,CM,SFACR,WMIN,A
      COMMON/ITERA/ZM(NT3),FNEW(NT3,NT3),SMAT(NT3,NT3),Q(NT3),N
      DATA IERR/0/
      COMMON/CEM/eh(NT3)
      logical LSCALED,lnm

      call w36(' ')
      call w36('Harmonic')
      call w36('^^^^^^^^')
      N=3*nat
      CM=219470.0d0
      SFACR=0.02342179d0
      write(3,*)'masses:'
      do i=1,3*nat
       write(3,3000)(i+2)/3,i,zim(i)
      enddo
3000  format(4(I3,I4,F9.2))
      open(21,file='ZIM.SCR',form='unformatted')
      write(21)(zim(i),i=1,3*nat)
      close(21)
      DO 220 I=1,3*nat
220   ZM(I)=1.0d0/DSQRT(ZIM(I))
c
      CONST=4.359828d0/0.5291772d0/0.5291772d0
      do 3 i=1,3*nat
      do 3 j=1,3*nat
c     write(6,*)i,j,fcar(i,j)
3     FCAR(i,j)=FCAR(i,j)*const
c
      call w36('Projecting out zero vibrations ')
      CALL PROJECT(FCAR,NT3)
      open(21,file='P.FC')
      call writeff2(NT3,3*nat,FCAR)
      close(21)
c
c     mass-weighed force field:
      CALL FAST(N,FCAR,FNEW,ZM)
c
c     diagonalize FF:
      IMOD=2
      call w36('Diagonalizaing FF')
      CALL TRED12(NT3,N,FNEW,SMAT,Q,IMOD,IERR,E)
      IF(IERR.NE.0)call report('Diagonalization error')
c
c     make eigenvectors always with the first element non-negative
      do 80 i=1,3*nat
      if(SMAT(1,i).lt.0.0d0)then
       do 81 j=1,3*nat
81     SMAT(j,i)=-SMAT(j,i)
      endif
80    continue
c
      call w36('Harmonic frequencies from current FF (cm-1):')
      do 2 I=1,3*nat
      if(Q(I).lt.0)then
       AS(I)=-DSQRT(ABS(Q(I)))*1302.828d0
       write(6,3002)I,dabs(AS(I))
       write(3,3002)I,dabs(AS(I))
3002   format(I4,'i',F9.2,$)
      else
       AS(i)= DSQRT(ABS(Q(I)))*1302.828d0
       write(3,3001)I,AS(I)
       write(6,3001)I,AS(I)
3001   format(I4,F10.2,$)
      endif
      if(mod(i,5).eq.0)write(3,*)
2     if(mod(i,5).eq.0)write(6,*)
      write(3,*)
      write(6,*)
C
      call w36('Mass-weighted S-matrices produced')
c
c
      if(.not.lnm.and..not.LSCALED)then
       do 4 i=1,N
       eh(i)=AS(i)/CM
       do 4 j=1,N
4      S(i,j)=SMAT(i,j)*SFACR/dsqrt(zim(i))
       call w36('Current S-matrix used')
      else
       call w36('S-matrix from F.INP used, current forgotten')
      endif

      call w36(' Ordering frequencies min ...wmax')
      DO 6 I=1,N-1
      WMIN=eh(I)
      JMIN=I
      DO 8 J=I+1,N
      IF(eh(J).LT.WMIN)THEN
       WMIN=eh(J)
       JMIN=J
      ENDIF
8     CONTINUE
      IF(JMIN.NE.I)THEN
       DO 7 K=1,N
       A=S(K,I)
       S(K,I)=S(K,JMIN)
7      S(K,JMIN)=A
       A=eh(I)
       eh(I)=eh(JMIN)
       eh(JMIN)=A
      ENDIF
6     CONTINUE

      do 9 i=1,N
9     AS(i)=eh(i)*cm
      CALL SMATOUT(S,AS,N)
c
c     put back FF into atomic units:
      do 61 i=1,3*nat
      do 61 j=1,3*nat
61    FCAR(i,j)=FCAR(i,j)/const
c
      call w36('Harmonic-ok')
      return
      END
C
      SUBROUTINE SMATOUT(S,AS,NAT3)
C     dX  =  S dQ   S(nat3xnint)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      DIMENSION S(NT3,NAT3),AS(NAT3)
      SFACR=0.02342179d0
      OPEN(34,FILE='FS4.INP')
      WRITE(34,10)NAT3,NAT3,NAT3/3
10    FORMAT(3I5)
      OPEN(35,FILE='FILE.X',STATUS='OLD')
      READ(35,*)
      READ(35,*)NAT
      DO 3 I=1,NAT
      READ(35,*)IAT,X,Y,Z
3     WRITE(34,11)IAT,X,Y,Z
11    FORMAT(I4,3F12.6)
      CLOSE(35)
      WRITE(34,14)
14    FORMAT(' Atom Mode    X-disp.    Y-disp.      Z-disp.')
      DO 1 I=1,NAT3/3
      DO 1 J=1,NAT3
1     WRITE(34,15)I,J,(S(3*(I-1)+k,J)/SFACR,k=1,3)
15    FORMAT(2I5,3F11.6)
      WRITE(34,11)NAT3
      WRITE(34,13)(AS(I),I=1,NAT3)
13    format(6F11.3)
      CLOSE(34)
      WRITE(*,*)'Current S-matrix written to FS4.INP'
      RETURN
      END

      SUBROUTINE TRED12(NT3,N,A,Z,D,IEIG,IERR,E)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION A(NT3,NT3),Z(NT3,NT3),D(*),E(NT3)
      IF (IEIG .LT. 0) GO TO 110
      DO 100 I = 1, N
C
      DO 100 J = 1, I
      Z(I,J) = A(I,J)
  100 CONTINUE
C
  110 ICODE = IABS(IEIG)
      IF (N .EQ. 1) GO TO 320
C     :::::::::: FOR I=N STEP -1 UNTIL 2 DO -- ::::::::::
      DO 300 II = 2, N
      I = N + 2 - II
      L = I - 1
      H = 0.0D0
      SCALE = 0.0D0
      IF (L .LT. 2) GO TO 130
C     :::::::::: SCALE ROW (ALGOL TOL THEN NOT NEEDED) ::::::::::
      DO 120 K = 1, L
  120 SCALE = SCALE + DABS(Z(I,K))
C
      IF (DABS(SCALE) .GT. 1.0D-10) GO TO 140
  130 E(I) = Z(I,L)
      GO TO 290
C
  140 DO 150 K = 1, L
      F = Z(I,K) / SCALE
      Z(I,K) = F
      H = H + F * F
  150 CONTINUE
C
      G = -DSIGN(DSQRT(H),F)
      E(I) = SCALE * G
      H = H - F * G
      Z(I,L) = F - G
      F = 0.0D0
C
      DO 240 J = 1, L
      IF (ICODE .EQ. 2) Z(J,I) = Z(I,J) / (SCALE * H)
      G = 0.0D0
C     :::::::::: FORM ELEMENT OF A*U ::::::::::
      DO 180 K = 1, J
  180 G = G + Z(J,K) * Z(I,K)
C
      JP1 = J + 1
      IF (L .LT. JP1) GO TO 220
C
      DO 200 K = JP1, L
  200 G = G + Z(K,J) * Z(I,K)
C     :::::::::: FORM ELEMENT OF P ::::::::::
  220 E(J) = G / H
      F = F + E(J) * Z(I,J)
  240 CONTINUE
C
      HH = F / (H + H)
C     :::::::::: FORM REDUCED A ::::::::::
      DO 260 J = 1, L
      F = Z(I,J)
      G = E(J) - HH * F
      E(J) = G
C
      DO 260 K = 1, J
      Z(J,K) = Z(J,K) - F * E(K) - G * Z(I,K)
  260 CONTINUE
C
      DO 280 K = 1, L
  280 Z(I,K) = SCALE * Z(I,K)
C
  290 D(I) = H
  300 CONTINUE
C
  320 D(1) = 0.0D0
      E(1) = 0.0D0
C     :::::::::: ACCUMULATION OF TRANSFORMATION MATRICES ::::::::::
      IF (ICODE .NE. 2) GO TO 600
      DO 500 I = 1, N
      L = I - 1
      IF (DABS(D(I)) .LT. 1.0D-10) GO TO 380
C
      DO 360 J = 1, L
      G = 0.0D0
C
      DO 340 K = 1, L
  340 G = G + Z(I,K) * Z(K,J)
C
      DO 360 K = 1, L
      Z(K,J) = Z(K,J) - G * Z(K,I)
  360 CONTINUE
C
  380 D(I) = Z(I,I)
      Z(I,I) = 1.0D0
      IF (L .LT. 1) GO TO 500
C
      DO 400 J = 1, L
      Z(I,J) = 0.0D0
      Z(J,I) = 0.0D0
  400 CONTINUE
C
  500 CONTINUE
C
  620 CALL TQL12 (NT3,N,Z,D,IERR,ICODE,E)
      RETURN
C     :::::::::: ALTERNATE FINAL LOOP FOR EIGENVALUES ONLY ::::::::::
  600 DO 610 I=1,N
  610 D(I) = Z(I,I)
      GO TO 620
      END
C
      SUBROUTINE TQL12(NT3,N,Z,D,IERR,ICODE,E)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION Z(NT3,NT3),D(*),E(*)
      REAL*8 MACHEP
      EPS = 1.0D0
   10 EPS = 0.50D0*EPS
      TOL1 = EPS + 1.0D0
      IF((TOL1.GT.1.0D0).AND.(TOL1-EPS.EQ.1.0D0)) GO TO 10
      IF(TOL1-EPS.EQ.1.0D0)  EPS = EPS + EPS
      MACHEP = EPS
C
C     MACHEP=16.0D0**(-13)
C
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      F = 0.0D0
      B = 0.0D0
      E(N) = 0.0D0
C
      DO 240 L = 1, N
      J = 0
      H = MACHEP * (DABS(D(L)) + DABS(E(L)))
      IF (B .LT. H) B = H
C     :::::::::: LOOK FOR SMALL SUB-DIAGONAL ELEMENT ::::::::::
      DO 110 M = L, N
      IF (DABS(E(M)) .LE. B) GO TO 120
C     :::::::::: E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ::::::::::
  110 CONTINUE
C
  120 IF (M .EQ. L) GO TO 220
  130 IF (J .EQ. 30) GO TO 1000
      J = J + 1
C     :::::::::: FORM SHIFT ::::::::::
      L1 = L + 1
      G = D(L)
      P = (D(L1) - G) / (2.0D0 * E(L))
      R = DSQRT(P*P+1.0D0)
      D(L) = E(L) / (P + DSIGN(R,P))
      H = G - D(L)
C
      DO 140 I = L1, N
  140 D(I) = D(I) - H
C
      F = F + H
C     :::::::::: QL TRANSFORMATION ::::::::::
      P = D(M)
      C = 1.0D0
      S = 0.0D0
      MML = M - L
C     :::::::::: FOR I=M-1 STEP -1 UNTIL L DO -- ::::::::::
      DO 200 II = 1, MML
      I = M - II
      G = C * E(I)
      H = C * P
      IF (DABS(P) .LT. DABS(E(I))) GO TO 150
      C = E(I) / P
      R = DSQRT(C*C+1.0D0)
      E(I+1) = S * P * R
      S = C / R
      C = 1.0D0 / R
      GO TO 160
  150 C = P / E(I)
      R = DSQRT(C*C+1.0D0)
      E(I+1) = S * E(I) * R
      S = 1.0D0 / R
      C = C * S
  160 P = C * D(I) - S * G
      D(I+1) = H + S * (C * G + S * D(I))
C     :::::::::: FORM VECTOR ::::::::::
      IF (ICODE .NE. 2) GO TO 200
      DO 180 K = 1, N
      H = Z(K,I+1)
      Z(K,I+1) = S * Z(K,I) + C * H
      Z(K,I) = C * Z(K,I) - S * H
  180 CONTINUE
C
  200 CONTINUE
C
      E(L) = S * P
      D(L) = C * P
      IF (DABS(E(L)) .GT. B) GO TO 130
  220 D(L) = D(L) + F
  240 CONTINUE
C     :::::::::: ORDER EIGENVALUES AND EIGENVECTORS ::::::::::
C     :::ASCENDING ORDER
      DO 300 II = 2, N
      I = II - 1
      K = I
      P = D(I)
C
      DO 260 J = II, N
      IF (D(J) .GE. P) GO TO 260
      K = J
      P = D(J)
  260 CONTINUE
C
      IF (K .EQ. I) GO TO 300
      D(K) = D(I)
      D(I) = P
C
      IF (ICODE .NE. 2) GO TO 300
      DO 280 J = 1, N
      P = Z(J,I)
      Z(J,I) = Z(J,K)
      Z(J,K) = P
  280 CONTINUE
C
  300 CONTINUE
C
      GO TO 1001
C     :::::::::: SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ::::::::::
 1000 IERR = L
 1001 RETURN
      END

      SUBROUTINE FAST(NA,FCAR,FNEW,ZM)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4(I-N)
      include 'dimensions.h'
      DIMENSION FCAR(NT3,NA),FNEW(NT3,NA),ZM(NA)
      DO 214 I=1,NA
      UI=ZM(I)
      DO 214 J=I,NA
      FNEW(I,J)=FCAR(I,J)*ZM(J)*UI
214   FNEW(J,I)=FNEW(I,J)
      RETURN
      END
C
      SUBROUTINE PROJECT(F,N0)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      DIMENSION F(N0,N0)
      COMMON/ITERA/ZM(NT3),A(NT3,NT3),TEM(NT3,NT3),Q(NT3),N
      WRITE(*,*)'Projecting transl/rotations from the force field...'
      CALL DOMA4(A,N0,N)
      DO 1 I=1,N
      DO 1 J=1,N
      TEM(I,J)=0.0d0
      DO 1 II=1,N
1     TEM(I,J)=TEM(I,J)+A(I,II)*F(II,J)
      DO 2 I=1,N
      DO 2 J=1,N
      F(I,J)=0.0d0
      DO 2 II=1,N
2     F(I,J)=F(I,J)+TEM(I,II)*A(J,II)
      RETURN
      END

      SUBROUTINE DOMA4(A,NDIM,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      PARAMETER (MX=NT3/3)
      DIMENSION C(3,MX),A(NDIM,N)
      real*8,allocatable::TEM(:,:)
      AMACH=0.00000000000001d0
      NAT=N/3
      allocate(TEM(N,N))
      OPEN(4,FILE='FILE.X',STATUS='OLD')
      READ(4,*)
      READ(4,*)NAT
      DO 11 I=1,NAT
11    READ(4,*)IDUMM,(C(II,I),II=1,3)
      CLOSE(4)
      DO 12 I=1,N
      DO 12 J=1,6
12    A(I,J)=0.0d0
      DO 1 I=1,NAT
      A(3*I-2,1)= 1.00d0
      A(3*I-1,2)= 1.00d0
      A(3*I  ,3)= 1.00d0
      A(3*I-2,4)=-C(2,I)
      A(3*I-1,4)= C(1,I)
      A(3*I-1,5)=-C(3,I)
      A(3*I  ,5)= C(2,I)
      A(3*I-2,6)= C(3,I)
1     A(3*I  ,6)=-C(1,I)
      N6=6
      CALL ORT4(A,NDIM,N6,NAT)
      ICOL=1
5     IF(ICOL.GT.N6)GOTO 8
      S=0.0d0
      DO 6 J=1,N
6     S=S+A(J,ICOL)**2
      IF(S.LT.1000.0d0*AMACH)THEN
       DO 7 J=1,N
7      A(J,ICOL)=A(J,N6)
       N6=N6-1
       GOTO 5
      ENDIF
      ICOL=ICOL+1
      GOTO 5
8     CONTINUE
      WRITE(*,*)N6,' coordinates projected'
      DO 2 I=1,N
      DO 2 J=1,N
      TEM(I,J)=0.0d0
      DO 2 II=1,N6
2     TEM(I,J)=TEM(I,J)+A(I,II)*A(J,II)
      DO 3 I=1,N
      DO 4 J=1,N
4     A(I,J)=-TEM(I,J)
3     A(I,I)=A(I,I)+1.0d0
      RETURN
      END
C     ============================================================
      SUBROUTINE ORT4(A,NDIM,N6,NAT)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION A(NDIM,N6)
      AMACH=0.00000000000001d0
      NAT3=3*NAT
      C=0.0d0
      DO 1 I=1,NAT3
1     C=C+A(I,1)**2
      IF(C.GT.AMACH)C=1.0d0/DSQRT(C)
      DO 2 I=1,NAT3
2     A(I,1)=A(I,1)*C
      DO 3 IC=2,N6
C     Column IC, orthonormalize to previous columns:
      DO 3 ICP=1,IC-1
      SP=0.0d0
      DO 5 J=1,NAT3
5     SP=SP+A(J,IC)*A(J,ICP)
C     Subtract projection to ICP:
      DO 6 J=1,NAT3
6     A(J,IC)=A(J,IC)-SP*A(J,ICP)
C     Normalize :
      SP=0.0d0
      DO 7 J=1,NAT3
7     SP=SP+A(J,IC)**2
      IF(SP.GT.AMACH)SP=1.0d0/DSQRT(SP)
      DO 3 J=1,NAT3
3     A(J,IC)=A(J,IC)*SP
      RETURN
      END
