      subroutine lcbsx(N,IP4,YLIM,XLIM,LP3,LP4,IRQR,lxdia,lcopt,lcda)
c     calculates vibrations in local cartesian normal mode basis
      implicit none
      integer*4 nosc,i,ia,ix,IP4,N,nat,NXX,IRQR,NHBIG,j,
     1IERR,ixp,jxp,jx,ja,ic,nvar,iu,is
      include 'dimensions.h'
      parameter (NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6)
      real*8 eii,AM,CM,XLIM,
     1YLIM,SFACR,amu,S(NT3,NT3),u(3,3),au(3),su(3,3),BUFF(3),
     2bu(NT0,3,3),var(NT3),bu2,eii2,eii2i
      integer*4 ivar(NT3),nxy,ibe
      common/lcbe/eii(NT3),live(NT3)
      real*8 FCAR,cx,dx
      integer*4 icx,idx,N33,N44
      COMMON/dia3/FCAR(NT3,NT3),cx(NXX),dx(NXX),
     1icx(3,NXX),idx(4,NXX),N33,N44
      common/MASS/AM(NT3)
      logical lex,LP3,LP4,live,lxdia,lcopt,lcda,lcxy,lopt
      common/lcbe2/eii2(6*NT0**2),bu2(6*NT0*NT0,2,2),nxy,
     1ibe(3,6*NT0**2)
      character*1 as(3)
      data as/'x','y','z'/
      real*8 ropt,wlbtol
      common/opt/ropt(100)
      common/lop/lopt(300)
      equivalence (wlbtol,ropt(5)),(lcxy,lopt(26))
c
      SFACR=0.02342179d0
      amu=1.0d0/SFACR**2
      CM=219470.0d0
      nat=N/3
      call w36('Local Cartesian Normal Mode Calculations')
      write(6,4003)wlbtol
      write(3,4003)wlbtol
4003  format(' Cutoff for diagonal mode frequencies:',f10.2,' cm-1')
c
c     determine normal mode frequencies:
c     read cartesian force field:
      open(21,file='FILE.FC')
      call READFF(NT3,N,FCAR)
c     read isotopic substitutions if available:
      inquire(file='FTRY.INP',exist=lex)
      if(lex)then
       call w36('Masses read from FTRY.INP')
       open(21,file='FTRY.INP')
       read(21,*)
       read(21,*)nosc
       do 1 i=1,nosc
1      read(21,*)
       read(21,*)(AM(i),i=1,nat)
       read(21,*)
       read(21,*)(AM(1+3*(i-1)),i=1,nat)
       do i=1,nat
        AM(2+3*(i-1))=AM(1+3*(i-1))
        AM(3+3*(i-1))=AM(1+3*(i-1))
       enddo
       close(21)
      endif
c
      do 15 i=1,N
      do 15 j=1,N
15    FCAR(i,j)=FCAR(i,j)/dsqrt(AM(i)*AM(j)*amu*amu)
      call w36('FF transformed into mass-weighed coordinates')
c
      call w36('Atom Coord  Mass(g/mol)  Freq (cm-1)')
      do 2 ia=1,nat
      do 2 ix=1,3
      i=ix+3*(ia-1)
      eii(i)=dsqrt(dabs(FCAR(i,i)))
      live(i)=eii(i)*CM.gt.wlbtol
      if(live(i))then
       write(3,6001)ia,as(ix),AM(i),eii(i)*CM,' live'
6001   format(i5,a1,2f10.2,a5)
       write(6,6001)ia,as(ix),AM(i),eii(i)*CM,' live'
      else
       write(3,6001)ia,as(ix),AM(i),eii(i)*CM,' dead'
       write(6,6001)ia,as(ix),AM(i),eii(i)*CM,' dead'
       FCAR(i,i)=0.0d0
       eii(i)=wlbtol/CM
      endif
2     continue
c
c     New coordinates X'_ia_a'=X_ia_a su(a,a')
c     New FF F'_a'_b' = su(a,a') F_a_b su(b,b')  ... diagonal
      do 13 ia=1,nat
      do 13 ix=1,3
      do 14 jx=1,3
14    bu(ia,ix,jx)=0.0d0
13    bu(ia,ix,ix)=1.0d0
c     ---------------------------------------------------------------
      if(lxdia)then
      call w36('Diagonal atomic oscillators:')
      call w36('Atom Osc  Mass(g/mol)  Freq (cm-1)')
c
      do 4 ia=1,nat
      do 5 ix=1,3
      do 5 jx=1,3
5     u(ix,jx)=FCAR(ix+3*(ia-1),jx+3*(ia-1))
      call TRED123(3,u,su,au,2,ierr)
c     save transformation matrix
      do 6 ix=1,3
      do 6 jx=1,3
6     bu(ia,ix,jx)=su(ix,jx)
      do 4 ix=1,3
      i=ix+3*(ia-1)
      eii(i)=dsqrt(dabs(au(ix   )))
      live(i)=eii(i)*CM.gt.wlbtol
      if(live(i))then
       write(3,6002)ia,ix,AM(i),eii(i)*CM,' live'
6002   format(i5,'_',i1,2f10.2,a5)
       write(6,6002)ia,ix,AM(i),eii(i)*CM,' live'
      else
       write(3,6002)ia,ix,AM(i),eii(i)*CM,' dead'
       write(6,6002)ia,ix,AM(i),eii(i)*CM,' dead'
       eii(i)=wlbtol/CM
      endif
4     continue
c
      inquire(file='LCB.PAR',exist=lex)
      if(lex)then
       open(88,file='LCB.PAR')
       call w36('Energies replaced by those from LCB.PAR:')
       do 16 ia=1,N/3
       do 16 ix=1,3
       j=ix+3*(ia-1)
       read(88,*)eii(j)
       if(live(j))then
        write(3,6002)ia,ix,AM(j),eii(j),' live'
        write(6,6002)ia,ix,AM(j),eii(j),' live'
       else
        if(eii(j).lt.wlbtol)eii(j)=wlbtol
        write(3,6002)ia,ix,AM(j),eii(j),' dead'
        write(6,6002)ia,ix,AM(j),eii(j),' dead'
       endif
16     eii(j)=eii(j)/CM
      endif
c
c     transform the force field
      do 7 ia=1,nat
      do 7 ix=1,3
      i=ix+3*(ia-1)
      do 7 j=1,N
      s(i,j)=0.0d0
      do 7 ixp=1,3
7     s(i,j)=s(i,j)+FCAR(ixp+3*(ia-1),j)*bu(ia,ixp,ix)
      do 11 i=1,N
      do 11 ja=1,nat
      do 11 jx=1,3
      j=jx+3*(ja-1)
      FCAR(i,j)=0.0d0
      do 11 jxp=1,3
11    FCAR(i,j)=FCAR(i,j)+s(i,jxp+3*(ja-1))*bu(ja,jxp,jx)
      call w36('FF transformed into local normal mode coordinates')
      open(21,file='TRAN.FC')
      CALL WRITEFF(NT3,N,FCAR)
      close(21)
      endif
c     ---------------------------------------------------------------
c     ---------------------------------------------------------------
      if(lcxy)then
      call w36('Non-orthogonal Pair Complementory Basis')
      call w36('Pair Osc  Mass(g/mol)  Freq (cm-1)')
c     loop over all pairs in each xyz direction
c
      nxy=0
      do 41 ia=1,nat
      do 41 ja=ia+1,nat
      do 41 ix=1,3
      u(1,1)=FCAR(ix+3*(ia-1),ix+3*(ia-1))
      u(2,2)=FCAR(ix+3*(ja-1),ix+3*(ja-1))
      u(2,1)=FCAR(ix+3*(ia-1),ix+3*(ja-1))
      u(1,2)=FCAR(ix+3*(ja-1),ix+3*(ia-1))
      call TRED12(3,2,u,su,au,2,ierr,BUFF)
      do 41 iu=1,2
      i=iu+2*(ix-1)+6*(ja+nat*(ia-1)-1)
c     12          13
c     x   y   z
c     q1q2q1q2q1q2
      eii2i=dsqrt(dabs(au(iu   )))
      if(eii2i*CM.gt.wlbtol)then
       nxy=nxy+1
       eii2(nxy)=eii2i
       ibe(1,nxy)=ia
       ibe(2,nxy)=ja
       ibe(3,nxy)=ix
c      save transformation matrix
       bu2(nxy,1,1)=su(1,1)
       bu2(nxy,1,2)=su(1,2)
       bu2(nxy,2,1)=su(2,1)
       bu2(nxy,2,2)=su(2,2)
       write(3,6003)ia,ja,as(ix),iu,eii2i*CM,' live'
6003   format(2i5,' _',a1,i1,f10.2,a5)
       write(6,6003)ia,ja,as(ix),iu,eii2i*CM,' live'
      else
       write(3,6003)ia,ja,as(ix),iu,eii2i*CM,' dead'
       write(6,6003)ia,ja,as(ix),iu,eii2i*CM,' dead'
      endif
41    continue
      endif
c     ---------------------------------------------------------------
c
      do 12 i=1,N
      do 12 j=1,N
12    s(i,j)=0.0d0
      do 3 ia=1,N/3
      do 3 ix=1,3
      i=ix+3*(ia-1)
      do 3 jx=1,3
      j=jx+3*(ia-1)
3     s(i,j)=bu(ia,ix,jx)
c
c     produce basis set
c     call setstatex(N)
      call setstatex1(N)
c
c     complement by 2-coordinate basis
      if(lcxy) call setstatex2
c
      if(lcopt)then
       call w36('Optimizing the frequencies')
       nvar=0
       do 20 i=1,N
20     var(i)=0.0d0
       do 17 i=1,N
       if(live(i))then
        ic=0
        do 18 j=1,nvar
        if(dabs(var(j)-eii(i)).lt.1.0d-8)then
         ic=ic+1
         ivar(i)=j
        endif
18      continue
        if(ic.eq.0)then
         nvar=nvar+1
         var(nvar)=eii(i)
         ivar(i)=nvar
        endif
       endif
17     continue
       write(3,*)nvar,' variables'
       write(6,*)nvar,' variables'
       N33=0
       N44=0
       call amoeba(nvar,var,N,ivar)

       call w36('Optimized frequencies')
       do 19 i=1,N
       ia=(i+2)/3
       if(live(i))then
        eii(i)=var(ivar(i))
        write(3,6002)ia,ix,AM(i),eii(i)*CM,' live'
        write(6,6002)ia,ix,AM(i),eii(i)*CM,' live'
       else
        write(3,6002)ia,ix,AM(i),eii(i)*CM,' dead'
        write(6,6002)ia,ix,AM(i),eii(i)*CM,' dead'
       endif
19     continue
      endif

      OPEN(2,FILE='SMAT.SCR',FORM='UNFORMATTED')
      write(2)N/3,(eii(I),I=1,N),((s(I,J),J=1,N),I=1,N)
      CLOSE(2)
      OPEN(2,FILE='BU.SCR',FORM='UNFORMATTED')
      write(2)(((bu(ia,ix,jx),ia=1,nat),ix=1,3),jx=1,3)
      CLOSE(2)
c
c     load sparse projected cartesian cubics
      call spcc(N,YLIM,LP3,bu)
c
c     load sparse projected cartesian quartic
      call spcd(N,IP4,XLIM,LP4,bu)
c
c     make hamiltonian
      if(lcxy) call report('not yet implemented')
c     if(lcxy) call dohimx2(N,NHBIG)
      if(lcda)then
c      damped anharmonic potential:
       call dohimxd(N,NHBIG)
      else
       call dohimx(N,NHBIG)
      endif
c
c     diagonalize
      call dohbigx(NHBIG,N,IRQR)
c
c     transform intensity tensors
      call dotenix(N,bu)


      return
      end

      subroutine spcc(N,YLIM,LP3,bu)
      implicit none
      integer*4 i,j,k,NXX,L,ip,jp,kp,N,ia,ja,ka,
     1ix,jx,kx,ixp,jxp,kxp,is
      include 'dimensions.h'
      parameter (NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6)
      real*8 C111,C211,C311,A(NT3,NT3),
     1YLIM,co,eii,AM,SFACR,amu,bu(NT0,3,3)
      real*8,allocatable:: c(:,:,:),ct(:,:,:)
c     c(NT3,NT3,NT3) ct(NT3,NT3,NT3)
      logical HW,lex,LP3
      logical live
      common/lcbe/eii(NT3),live(NT3)
      common/MASS/AM(NT3)
      real*8 FCAR,cx,dx
      integer*4 icx,idx,N33,N44
      COMMON/dia3/FCAR(NT3,NT3),cx(NXX),dx(NXX),
     1icx(3,NXX),idx(4,NXX),N33,N44

      SFACR=0.02342179d0
      amu=1.0d0/SFACR**2
      inquire(file='XX3P.SCR.TXT',exist=lex)
      if(lex)then
       N33=0
       open(21,file='XX3P.SCR.TXT',form='unformatted')
111    read(21,*,end=112,err=112)i,j,k,co
       N33=N33+1
       if(N33.gt.NXX)call report('too many cubics in XX3P')
       cx(N33)=co
       icx(1,N33)=i
       icx(2,N33)=j
       icx(3,N33)=k
       goto 111
112    close(21)
       write(3,301)N33
       write(6,301)N33
301    format(I10,' Projected cubics read from XX3P.SCR.TXT')
       return
      endif

      allocate(c(1:N,1:N,1:N),ct(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate c and ct')

      HW=.false.
      do 1 i=1,N
      do 1 j=1,N
      do 1 k=1,N
1     c(i,j,k)=0.0d0
      N33=0
      OPEN(4,FILE='SCR.33')
82    READ(4,*,END=83)I,J,K,c(I,J,K)
      c(J,I,K)=c(I,J,K)
      c(K,J,I)=c(I,J,K)
      c(I,K,J)=c(I,J,K)
      c(K,I,J)=c(I,J,K)
      c(J,K,I)=c(I,J,K)
      N33=N33+1
      GOTO 82
83    CLOSE(4)
      WRITE(3,*)N33,' sparse cartesian cubics loaded.'
      WRITE(6,*)N33,' sparse cartesian cubics loaded.'
C
      C111=0.0d0
      C211=0.0d0
      C311=0.0d0
      DO 43 L=1,N/3
      C111=C111+C(3*L-2,1,1)
      C211=C211+C(3*L-1,1,1)
43    C311=C311+C(3*L  ,1,1)
      WRITE(3,333)C111,C211,C311
      WRITE(6,333)C111,C211,C311
333   FORMAT(' Sum rule for cubics',3F15.10)
C
      IF(LP3)THEN
       call w36('Projecting zero-vibrations from cubics.')
       CALL DOMA(A,NT3,N,HW)
       do 2 i=1,N
       do 2 j=1,N
       do 2 k=1,N
       ct(i,j,k)=0.0d0
       do 2 ip=1,N
2      ct(i,j,k)=ct(i,j,k)+c(ip,j,k)*A(i,ip)
       do 3 i=1,N
       do 3 j=1,N
       do 3 k=1,N
       c(i,j,k)=0.0d0
       do 3 jp=1,N
3      c(i,j,k)=c(i,j,k)+ct(i,jp,k)*A(j,jp)
       do 4 i=1,N
       do 4 j=1,N
       do 4 k=1,N
       ct(i,j,k)=0.0d0
       do 4 kp=1,N
4      ct(i,j,k)=ct(i,j,k)+c(i,j,kp)*A(k,kp)
       do 5 i=1,N
       do 5 j=1,N
       do 5 k=1,N
5      c(i,j,k)=ct(i,j,k)
       C111=0.0d0
       C211=0.0d0
       C311=0.0d0
       DO 44 L=1,N/3
       C111=C111+C(3*L-2,1,1)
       C211=C211+C(3*L-1,1,1)
44     C311=C311+C(3*L  ,1,1)
       WRITE(3,333)C111,C211,C311
       WRITE(6,333)C111,C211,C311
      endif

      call w36('Transforming cubics to local diagonal coordinates')
      do 7 ia=1,N/3
      do 7 ix=1,3
      do 7 j=1,N
      do 7 k=1,N
      i=ix+3*(ia-1)
      ct(i,j,k)=0.0d0
      do 7 ixp=1,3
      ip=ixp+3*(ia-1)
7     ct(i,j,k)=ct(i,j,k)+c(ip,j,k)*bu(ia,ixp,ix)
      do 8 i=1,N
      do 8 ja=1,N/3
      do 8 jx=1,3
      j=jx+3*(ja-1)
      do 8 k=1,N
      c(i,j,k)=0.0d0
      do 8 jxp=1,3
      jp=jxp+3*(ja-1)
8     c(i,j,k)=c(i,j,k)+ct(i,jp,k)*bu(ja,jxp,jx)
      do 9 i=1,N
      do 9 j=1,N
      do 9 ka=1,N/3
      do 9 kx=1,3
      k=kx+3*(ka-1)
      ct(i,j,k)=0.0d0
      do 9 kxp=1,3
      kp=kxp+3*(ka-1)
9     ct(i,j,k)=ct(i,j,k)+c(i,j,kp)*bu(ka,kxp,kx)
      do 10 i=1,N
      do 10 j=1,N
      do 10 k=1,N
10    c(i,j,k)=ct(i,j,k)

      N33=0
      open(21,file='XX3P.SCR.TXT')
      do 6 k=1,N
      do 6 j=1,k
      do 6 i=1,j
c     i=<j<=k
      if(dabs(c(i,j,k)).gt.YLIM)then
       N33=N33+1
       if(N33.gt.NXX)call report('too many cubics to XX3P')
c      derivatives in dimensionless normal mode coordinates
       cx(N33)=c(i,j,k)/dsqrt(eii(i)*eii(j)*eii(k)
     1 *AM(i)*AM(j)*AM(k)*amu**3)
       icx(1,N33)=i
       icx(2,N33)=j
       icx(3,N33)=k
       write(21,2121)i,j,k,cx(N33)
2121   format(3i6,G16.8)
      endif
6     continue
      close(21)
      write(3,300)N33
      write(6,300)N33
300   format(I10,' Final cubics written into XX3P.SCR.TXT')
      deallocate(c,ct)
      RETURN
      END
c     ======================================================
      subroutine spcd(N,IP4,XLIM,LP4,bu)
      implicit none
      integer*4 NXX,i,j,k,N,L,A,B,C,D,IC,II,
     1IOP,IP4,JJ,KK,ix,jx,kx,ja,ka,ina,inx,ip,ipx,jna,jnx,kna,knx,is
      include 'dimensions.h'
      parameter (NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6)
      real*8 C111,C211,C311,U(NT3,NT3),
     1CON,S1,S2,S3,S4,AJII,AKII,ALII,AIJJ,AJJJ,bu(NT0,3,3),
     1AKJJ,ALJJ,SKL,SJL,SJK,SIL,SIK,SIJ,AIAJB,
     1AIAJC,AIAJD,AIBJA,AIB,AIBJC,AIBJD,AICJA,AICJB,AIDJA,AIDJB,
     1AIII,AIA,AIC,AICJD,AID,AIDJC,DIFF,SLA,
     1SLB,SLC,SLD,XLIM,co,eii,AM,SFACR,amu,fucktor
      real*8,allocatable:: CX4(:,:,:),CQ4(:,:,:),DJKL(:,:,:)
c     CX4(NT3,NT3,NT3),CQ4(NT3,NT3,NT3),DJKL(NT3,NT3,NT3)
      logical HW,lex,LP4,live
      common/lcbe/eii(NT3),live(NT3)
      common/MASS/AM(NT3)
      real*8 FCAR,cx,dx
      integer*4 icx,idx,N33,N44
      COMMON/dia3/FCAR(NT3,NT3),cx(NXX),dx(NXX),
     1icx(3,NXX),idx(4,NXX),N33,N44

      SFACR=0.02342179d0
      amu=1.0d0/SFACR**2
      inquire(file='XX4P.SCR.TXT',exist=lex)
      if(lex)then
       N44=0
       open(21,file='XX4P.SCR.TXT')
222    read(21,*,err=221,end=221)i,i,j,k,co
       N44=N44+1
       if(N44.gt.NXX)call report('too many quartics to XX4P')
       dx(N44)=co
       idx(1,N44)=i
       idx(2,N44)=i
       idx(3,N44)=j
       idx(4,N44)=k
       goto 222
221    close(21)
       write(3,330)N44
       write(6,330)N44
330    format(I10,' Final quartics read from XX4P.SCR.TXT')
       return
      endif

      allocate(CX4(1:N,1:N,1:N),CQ4(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX4 and CQ4')

      HW=.false.
      DO 1 I=1,N
      DO 1 J=1,N
      DO 1 K=1,N
1     CX4(I,J,K)=0.0d0

      N44=0
      OPEN(4,FILE='SCR.44')
28    READ(4,*,END=38,err=38)I,J,K,CON
      N44=N44+1
      CX4(i,j,k)=CON
      CX4(i,k,j)=CON
      if(j.eq.k)CX4(j,i,i)=CON
      goto 28
38    close(4)
      WRITE(3,4400)N44
      WRITE(6,4400)N44
4400  format(i10,' cartesian quartics read from SCR.44')
C
C     Check translational symmetry:
      C111=0.0d0
      C211=0.0d0
      C311=0.0d0
      DO 43 L=1,N/3
      C111=C111+CX4(1,1,3*L-2)
      C211=C211+CX4(1,1,3*L-1)
43    C311=C311+CX4(1,1,3*L  )
      WRITE(3,333)C111,C211,C311
      WRITE(6,333)C111,C211,C311
333   FORMAT(' Sum rule for quartics',3F15.10)
C
Ciijk=Ciikj=Cikij=Cijik=Cijki=Cikji=Cjiik=Ckiij=Cjiki=Ckiji=Cjkii=Ckjii
C both for normal and cartesians, i the double index
C
C     Project-out rotational and translational components:
      IF(LP4)THEN
       WRITE(6,600)IP4
       WRITE(3,600)IP4
       CALL DOMA(U,NT3,N,HW)
600    format('Projecting zero vib. from quartics (',I4,'times).')
C
C      Write quartic ff on the disk, to save computer memory, i<=j<=k<=l:
       OPEN(55,FILE='OLD.SCR',FORM='UNFORMATTED')
       OPEN(5,FILE='TEQ.SCR',FORM='UNFORMATTED')
       IF(IP4.EQ.0)GOTO 444
       IC=1
3333   REWIND 5
       DO 52 I=1,N
       WRITE(6,*)I,' of ',N
C
C      Calculate cubic block I(JKL), write temporarily into CQ4
       DO 53 J=I,N
       DO 53 K=J,N
       DO 53 L=K,N
C
C      Contribution of old ("Exact") quartics, S1-S4:
       S1=0.0d0
       S2=0.0d0
       S3=0.0d0
       S4=0.0d0
       DO 552 II=1,N
       AIII=U(I,II)
       AJII=U(J,II)
       AKII=U(K,II)
       ALII=U(L,II)
C      iiii:
       S1=S1+AIII*AJII*AKII*ALII*CX4(II,II,II)
       DO 552 JJ=II+1,N
       AIJJ=U(I,JJ)
       AJJJ=U(J,JJ)
       AKJJ=U(K,JJ)
       ALJJ=U(L,JJ)
C      iijj=jiij=ijij (and i>j):
       S2=S2+CX4(II,JJ,JJ)*
     1 (AIII*(AJII*AKJJ*ALJJ+AJJJ*(AKJJ*ALII+AKII*ALJJ))+
     2  AIJJ*(AJII*AKII*ALJJ+(AJJJ*AKII+AJII*AKJJ)*ALII))
C      iiij=iiji=ijii=jiii (and i>j):
       S3=S3+CX4(II,II,JJ)*(
     1 AIII*(AJII*(AKII*ALJJ+AKJJ*ALII))+
     2      ((AIII*AJJJ+AIJJ*AJII)*AKII)*ALII)
     3     +CX4(JJ,JJ,II)*(
     4 AIJJ*(AJJJ*(AKJJ*ALII+AKII*ALJJ))+
     5      ((AIJJ*AJII+AIII*AJJJ)*AKJJ)*ALJJ)
       SKL=AKII*ALJJ+AKJJ*ALII
       SJL=AJII*ALJJ+AJJJ*ALII
       SJK=AJII*AKJJ+AJJJ*AKII
       SIL=AIII*ALJJ+AIJJ*ALII
       SIK=AIII*AKJJ+AIJJ*AKII
       SIJ=AIII*AJJJ+AIJJ*AJII
       DO 553 KK=1,N
       IF(KK.EQ.II.OR.KK.EQ.JJ)GOTO 553
C      kkij=kikj=kijk=ikkj=ikjk=ijkk and i>j:
       S4=S4+CX4(KK,II,JJ)*(
     1 U(I,KK)*U(J,KK)*SKL+U(I,KK)*U(K,KK)*SJL+U(I,KK)*U(L,KK)*SJK+
     2 U(J,KK)*U(K,KK)*SIL+U(J,KK)*U(L,KK)*SIK+U(K,KK)*U(L,KK)*SIJ)
553    CONTINUE
552    CONTINUE
53     CQ4(J,K,L)=S1+S2+S3+S4
C
C      For higher iterations pick the new off-dia
C      i<j<k<l 4!=24 combinations
       IF(IC.GT.1)THEN
        REWIND 55
        allocate(DJKL(1:N,1:N,1:N),stat=A)
        if(A.ne.0)call report('DJKL cannot be allocated')
        DO 532 A=1,N
C
        READ(55)(((DJKL(B,C,D),D=C,N),C=B,N),B=A,N)
        AIA=U(I,A)
        DO 532 B=A+1,N
        AIB=U(I,B)
        DO 532 C=B+1,N
        AIC=U(I,C)
        DO 532 D=C+1,N
        AID=U(I,D)
        DO 532 J=I,N
        CON=DJKL(B,C,D)
        AIAJB=CON*AIA*U(J,B)
        AIAJC=CON*AIA*U(J,C)
        AIAJD=CON*AIA*U(J,D)
        AIBJA=CON*AIB*U(J,A)
        AIBJC=CON*AIB*U(J,C)
        AIBJD=CON*AIB*U(J,D)
        AICJA=CON*AIC*U(J,A)
        AICJB=CON*AIC*U(J,B)
        AICJD=CON*AIC*U(J,D)
        AIDJA=CON*AID*U(J,A)
        AIDJB=CON*AID*U(J,B)
        AIDJC=CON*AID*U(J,C)
        DO 532 K=J,N
        SLA=(AICJD+AIDJC)*U(K,B)+
     1      (AIBJD+AIDJB)*U(K,C)+(AIBJC+AICJB)*U(K,D)
        SLB=(AIAJD+AIDJA)*U(K,C)+
     1      (AIAJC+AICJA)*U(K,D)+(AIDJC+AICJD)*U(K,A)
        SLC=(AIAJB+AIBJA)*U(K,D)+
     1      (AIBJD+AIDJB)*U(K,A)+(AIAJD+AIDJA)*U(K,B)
        SLD=(AICJB+AIBJC)*U(K,A)+
     1      (AIAJC+AICJA)*U(K,B)+(AIBJA+AIAJB)*U(K,C)
        DO 532 L=K,N
532     CQ4(J,K,L)=CQ4(J,K,L)+
     1   SLA*U(L,A)+SLB*U(L,B)+SLC*U(L,C)+SLD*U(L,D)
        deallocate(DJKL)
       ENDIF
52     WRITE(5)(((CQ4(J,K,L),L=K,N),K=J,N),J=I,N)
C
C      Calculate difference from old diagonals:
       IOP=1
       CALL PICK(CQ4,CX4,DIFF,IOP,NT3,N)
C
C      Go back, if IP4>IC
       IF(IC.LT.IP4)THEN
        IC=IC+1
        WRITE(6,*)' Projection repeated (#',IC,'):'
        WRITE(3,*)' Projection repeated (#',IC,'):'
        GOTO 3333
       ENDIF
C
C      Take new diagonals:
444    IOP=0
       CALL PICK(CQ4,CX4,DIFF,IOP,NT3,N)
       CLOSE(5)
       CLOSE(55)
C
C      Check translational symmetry:
       C111=0.0d0
       C211=0.0d0
       C311=0.0d0
       DO 431 L=1,N/3
       C111=C111+CX4(1,1,3*L-2)
       C211=C211+CX4(1,1,3*L-1)
431    C311=C311+CX4(1,1,3*L  )
       WRITE(3,333)C111,C211,C311
       WRITE(6,333)C111,C211,C311

      ENDIF

      call w36('Transforming quartics to local diagonal coordinates')
c
c     IIjk = AIi AIi' ii'jk
      write(6,*)'transforming DQ into normal modes'
      WRITE(6,*)' first (double) index'
      do 521 I=1,n
      ina=(I+2)/3
      inx=I-3*(ina-1)
      do 521 jj=1,n
      ja=(jj+2)/3
      jx=jj-3*(ja-1)
      do 521 kk=1,n
      ka=(kk+2)/3
      kx=kk-3*(ka-1)
      CQ4(I,jj,kk)=0.0d0
      do 521 ix=1,3
      ii=ix+3*(ina-1)
      do 521 ipx=1,3
      ip=ipx+3*(ina-1)
      fucktor=bu(ina,ix,inx)*bu(ina,ipx,inx)
      if(ii.eq.ip)then
       CQ4(I,jj,kk)=CQ4(I,jj,kk)+fucktor*CX4(ii,jj,kk)
      else
       if(ii.eq.jj)then
        CQ4(I,jj,kk)=CQ4(I,jj,kk)+fucktor*CX4(ii,ip,kk)
       else
        if(ii.eq.kk)then
         CQ4(I,jj,kk)=CQ4(I,jj,kk)+fucktor*CX4(ii,ip,jj)
        else
         if(ip.eq.jj)then
          CQ4(I,jj,kk)=CQ4(I,jj,kk)+fucktor*CX4(jj,ii,kk)
         else
          if(ip.eq.kk)then
           CQ4(I,jj,kk)=CQ4(I,jj,kk)+fucktor*CX4(ip,ii,jj)
          else
           if(jj.eq.kk)CQ4(I,jj,kk)=CQ4(I,jj,kk)+fucktor*CX4(jj,ii,ip)
          endif
         endif
        endif
       endif
      endif
521   continue
c
c     second index: IJk, gather in cx IJK = SjJ Ijk
      do 2001 I=1,n
      do 2001 jna=1,n/3
      do 2001 jnx=1,3
      J=jnx+3*(jna-1)
      do 2001 kk=1,n
      CX4(I,J,kk)=0.0d0
      do 2001 jx=1,3
      jj=jx+3*(jna-1)
2001  CX4(I,J,kk)=CX4(I,J,kk)+CQ4(I,jj,kk)*bu(jna,jx,jnx)
c
c     third index: IJK=skK IJk
      do 3001 I=1,n
      do 3001 J=1,n
      do 3001 kna=1,n/3
      do 3001 knx=1,3
      K=knx+3*(kna-1)
      CQ4(I,J,K)=0.0d0
      do 3001 kx=1,3
      kk=kx+3*(kna-1)
3001  CQ4(I,J,K)=CQ4(I,J,K)+CX4(I,J,kk)*bu(kna,kx,knx)

      do 4001 I=1,n
      do 4001 J=1,n
      do 4001 K=1,n
4001  CX4(I,J,K)=CQ4(I,J,K)
c
      N44=0
      open(21,file='XX4P.SCR.TXT',form='unformatted')
      do 6 i=1,N
      do 6 k=1,N
      do 6 j=1,k
c     j<=k
      if(dabs(CX4(i,j,k)).gt.XLIM)then
       N44=N44+1
       if(N44.gt.NXX)call report('too many quartics to XX4P')
c      derivatives in dimensionless normal mode coordinates
       dx(N44)=CX4(i,j,k)/dsqrt(eii(i)*eii(i)*eii(j)*eii(k)
     1 *AM(i)*AM(i)*AM(j)*AM(k)*amu**4)
       idx(1,N44)=i
       idx(2,N44)=i
       idx(3,N44)=j
       idx(4,N44)=k
       write(21,2121)i,j,k,dx(N44)
2121   format(3i6,G16.8)
      endif
6     continue
      close(21)
      write(3,300)N44
      write(6,300)N44
300   format(I10,' Final quartics written into XX4P.SCR.TXT')
C
      deallocate(CX4,CQ4)

      RETURN
      END
c     ================================================================
      SUBROUTINE amoeba(nvar,ANG,N,ivar)
C     This is a Fortran version of Petr Malon's subroutine Amoeba
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      include 'dimensions.h'
      PARAMETER (nvar0=NT3)
      DIMENSION ANG(*),P(4,nvar0),Y(4),PBAR(nvar0),PR(nvar0),
     1PRR(nvar0),ivar(*)

      FTOL=1.0d-7
      ITMAX=500
      if(nvar.gt.nvar0)call report('too many variables in amoeba')
      DO 1 I=1,nvar
      PRR(I)=ANG(I)
1     P(1,I)=ANG(I)
      Y(1)=FUx(ivar,N,ANG)
      ANG(1)=0.80d0*ANG(1)
      DO 2 I=1,nvar
2     P(2,I)=ANG(I)
      Y(2)=FUx(ivar,N,ANG)
      DO 18 I=1,nvar
18    ANG(I)=ANG(I)*(100.0d0-dble(I)/dble(nvar)*10.0d0)/100.0d0
      DO 3 I=1,nvar
3     P(3,I)=ANG(I)
      Y(3)=FUx(ivar,N,ANG)
      DO 33 I=1,nvar
33    ANG(I)=ANG(I)*(10.0d0+dble(nvar-I)**2/dble(nvar**2))/10.0d0
      DO 4 I=1,nvar
4     P(4,I)=ANG(I)
      Y(4)=FUx(ivar,N,ANG)
      ITER=0
99999 ILO=1
      IF(Y(1).GT.Y(2))THEN
       IHI=1
       INHI=2
      ELSE
       IHI=2
       INHI=1
      ENDIF
      DO 5 I=1,4
      IF(Y(I).LT.Y(ILO))ILO=I
      IF(Y(I).GT.Y(IHI))THEN
       INHI=IHI
       IHI=I
      ELSE
       IF(Y(I).GT.Y(INHI))THEN
        IF(I.NE.IHI)INHI=I
       ENDIF
      ENDIF
5     CONTINUE
      IF(ABS(Y(IHI))+ABS(Y(ILO)).LT.1.0d-10)THEN
       RTOL=0.0d0
      ELSE
       RTOL=ABS(Y(IHI)-Y(ILO))/(ABS(Y(IHI))+ABS(Y(ILO)))*2.0d0
      ENDIF
      IF(RTOL.LT.FTOL)then
       RETURN
      endif

      CM=219470.0d0
      write(6,6000)ITER,RTOL,FTOL,Y(IHI)
6000  format(' Iteration',i4,' tol ',g10.4,' lim ',g10.2,' err',f15.2)
      write(6,6001)(PRR(I)*CM,I=1,nvar)
6001  format(8f10.2)

      IF(ITER.EQ.ITMAX)THEN
       call w36(' Max. number of iterations exceeded')
       RETURN
      ENDIF
      ITER=ITER+1
      DO 55 I=1,nvar
55    PBAR(I)=0.0d0
      DO 6 I=1,4
      IF(I.NE.IHI)THEN
       DO 7 J=1,nvar
7      PBAR(J)=PBAR(J)+P(I,J)
      ENDIF
6     CONTINUE
      DO 8 J=1,nvar
      PBAR(J)=PBAR(J)/3.0d0
8     PR(J)=2.0d0*PBAR(J)-P(IHI,J)
      YPR=FUx(ivar,N,PR)
      IF(YPR.LE.Y(ILO))THEN
       DO 9 J=1,nvar
9      PRR(J)=2.0d0*PR(J)-PBAR(J)
       YPRR=FUx(ivar,N,PRR)
       IF(YPRR.LT.Y(ILO))THEN
        DO 10 J=1,nvar
10      P(IHI,J)=PRR(J)
        Y(IHI)=YPRR
       ELSE
        DO 11 J=1,nvar
11      P(IHI,J)=PR(J)
        Y(IHI)=YPR
       ENDIF
      ELSE
       IF(YPR.GE.Y(INHI))THEN
        IF(YPR.LT.Y(IHI))THEN
         DO 12 J=1,nvar
12       P(IHI,J)=PR(J)
         Y(IHI)=YPR
        ENDIF
        DO 13 J=1,nvar
13      PRR(J)=0.5d0*P(IHI,J)+0.5d0*PBAR(J)
        YPRR=FUx(ivar,N,PRR)
        IF(YPRR.LT.Y(IHI))THEN
         DO 14 J=1,nvar
14       P(IHI,J)=PRR(J)
         Y(IHI)=YPRR
        ELSE
         DO 15 I=1,4
         IF(I.NE.ILO)THEN
          DO 16 J=1,nvar
          PR(J)=0.5d0*(P(I,J)+P(ILO,J))
16        P(I,J)=PR(J)
          Y(I)=FUx(ivar,N,PR)
         ENDIF
15       CONTINUE
        ENDIF
       ELSE
        DO 17 J=1,nvar
17      P(IHI,J)=PR(J)
        Y(IHI)=YPR
       ENDIF
      ENDIF
      GOTO 99999
      END

      function FUx(ivar,N,var)
      implicit none
      integer*4 N,i,ivar(*),NHBIG
      include 'dimensions.h'
      real*8 eii,FUx,var(*),E1
      logical live
      common/lcbe/eii(NT3),live(NT3)
      do 1 i=1,N
1     if(live(i))eii(i)=var(ivar(i))
      open(44,file='1A2.SCR')
      close(44,STATUS='DELETE')
      call dohimx(N,NHBIG)
      call dohbigx1(NHBIG,E1)
      FUx=E1
      return
      end
c
