      SUBROUTINE start_logging()
      include 'common.h'
      character*100 log_fname,verbose_string
      logical GVIB_VERBOSE,lopt
      common/lop/lopt(300)
      equivalence (GVIB_VERBOSE,lopt(16))

      log_fname = 'VSCF.LOG'
      log_fd    = get_fd()
      open(log_fd,file=log_fname,access='append')

      verbose = GVIB_VERBOSE
      end




      SUBROUTINE stop_logging()
      include 'common.h'
      
      call close_and_free_fd(log_fd)
      end





      SUBROUTINE init_fdpool()
      include 'common.h'
      integer i
      do i=1,maxfd
	    fdpool(i)=0
      end do
      end


      

      FUNCTION get_fd()
      include 'common.h'
      integer i
     
      get_fd = 10
      do i=10,maxfd
	    if (fdpool(i).eq.0) then
		  fdpool(i) = 1
		  get_fd    = i
		  !write(*,*)'fd ',i,'taken'
		  return
	    end if
      end do

      write(*,*)'Too many file descriptors in use!'
      call exit_nicely()
      end



      SUBROUTINE exit_nicely()
      call exit(1)
      end



      SUBROUTINE close_and_free_fd(fd)
      include 'common.h'
      integer fd
      close(fd)
      call free_fd(fd)
      end


      SUBROUTINE free_fd(fd)
      include 'common.h'
      integer fd
      fdpool(fd) = 0
      !write(*,*)'fd ',fd,'freed'
      end


      
