      SUBROUTINE MITINX(N,M,NE,ELMAX,D,IERR,MV,J1,s1,MVTOT,IEMAX)
C
C     by Petr Bour, Prague 1994
C
C     This subroutine finds few of lowest eigenvectors for a
C     very large matrix, written on the disk (s1//A2.SCR)
C     Diagonal terms are already divided by two in s1//.SCR.
C     M is the dimension of the subspace where direct diagonalization is done
C     NE is number of eigenvectors to be found
C     MV is the number of eigenvectors found
C     MVTOT is the number of eigenvectors found in all symmetry blocks
C
C     For details look at
C     Alexander V. Mitin, J.Comp.Chem., Vol. 15, No.7, (1994), 747-751
C     (Warning: The paper is full of missprints; the recommended procedure
C      is modified here.)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      PARAMETER (NSS=10)
      DIMENSION X(NM0*NSS),E(NSS),F(NSS,NSS),mm(NM0),nn(NM0),BUFF(NSS),
     1D(*),AXV(NM0*NSS),Z(NSS,NSS),Y(NM0),YNEW(NM0),j33(NM0),a33(NM0),
     1SNS(NSS),nstart(nproc0),nend(nproc0),sar(nproc0),nstartt(nproc0),
     1nendt(nproc0)
      COMMON/MACHINE/AMACH
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,lto,
     1LSPARSE,LH40,ldisk,lopt,l12,ldiskev
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      COMMON/PPP/GRADCONV,OLIMIT
      character*1 s1
      common/lop/lopt(300)
      common/iop/iopt(300)
      common/opt/ropt(100)
      equivalence (etlim,ropt(17)),(etal,ropt(18)),(det,ropt(19)),
     1(iopt(14),nproc),(iopt(19),MAXIT),(lto,lopt(40))
      integer*4 OMP_GET_MAX_THREADS,OMP_GET_NUM_PROCS,
     1OMP_GET_THREAD_NUM
c
      real*8,allocatable:: abb(:),evs(:)
c     abb(nbuff)
      integer*4,allocatable:: jbb(:)
c     jbb(nbuff)
c
      call w36('mitinx')
      it0=mclock()
      ELAST=-1.0d9
      GRADOLD=-1.0d9
      MSAVE=M
      IERR=0
      ANORM=0.0d0
      DIAG=0.0d0

c     set up parallel parameters:
      if(nproc.gt.omp_get_num_procs())then
       write(6,*)nproc,omp_get_num_procs()
       call report('not enough processors')
      endif
      if(nproc.gt.omp_get_max_threads())
     1write(6,*)'Number of threads will increase'
      call omp_set_num_threads(nproc)
      call omp_set_dynamic(0)
      call omp_set_nested(0)
      if(nproc.gt.nproc0)call report('too many processors requested')

c
c     precalculate parallel distributions for "non-parralezable" loops:
      call ppd(nproc,nproc0,nstart,nend,N)
      do i=1,nproc
       write(6,*)i,nstart(i),nend(i)
      enddo
c

c
      ndone=0
      OPEN(45,FILE='CFI.SCR',FORM='UNFORMATTED')
c     previous block:
      do 2002 I=1,J1-1
      ndone=ndone+1
2002  READ(45)
c     current block:
      IERM=0
2001  READ(45,END=2004)
      ndone=ndone+1
      IERM=IERM+1
      goto 2001
2004  write(3,3400)ndone,IERM
      write(6,3400)ndone,IERM
3400  format(i5,' eigenvectors found in CFI.SCR,',i5,' in this block')

      inquire(FILE=s1//'A2.SCR',exist=l12)
      if(l12)then
       OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       adf=1.0d0
      else
       OPEN(2,FILE=s1//'A.SCR',FORM='UNFORMATTED')
       adf=2.0d0
      endif
      read(2)
      write(6,*)N
      iel=0
      DO 222 I=1,N
      READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
      DO 222 ii=1,nn(I)
      iel=iel+1
      if(j33(ii).eq.I)DIAG=DIAG+DABS(a33(ii))*adf
222   ANORM=ANORM+ABS(a33(ii))
      close(2)

      write(6,4001)iel
      write(3,4001)iel
4001  format(i10,' elements')
      allocate(jbb(1:iel),abb(1:iel),stat=i)
      if(i.eq.0)then
       iel=0
       if(lto)then
        call w36('Empirical Hamiltonian scaling')
        write(3,2966)etlim,det,etal
        write(6,2966)etlim,det,etal
2966    format(' Elim = ',f8.1,' cm-1',/,
     1         ' dE   = ',f8.1,' cm-1',/,
     2         ' sf   = ',f8.1)
       endif
       if(l12)then
        OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       else
        OPEN(2,FILE=s1//'A.SCR',FORM='UNFORMATTED')
       endif
       read(2)
       DO 223 I=1,N
       READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
       if(lto.and.j33(nn(I)).eq.I)then
        if(adf*a33(nn(I)).gt.etlim)then
         a33(nn(I))=a33(nn(I))*
     1   (etal+(1.0d0-etal)*exp(-(adf*a33(nn(I))-etlim)**2/det**2))
        endif
       endif
       mm(i)=iel
       DO 223 ii=1,nn(I)
       iel=iel+1
       jbb(iel)=j33(ii)
223    abb(iel)=a33(ii)
       close(2)
       ldisk=.false.
       write(6,4900)int((dble(iel)*2.5d0+dble(N)*2.0d0)/250.0d0)
       write(3,4900)int((dble(iel)*2.5d0+dble(N)*2.0d0)/250.0d0)
c      write(3,4900)(iel*8+iel*4+N*8)/1000
4900   format(' Matrix loaded into memory',i12,' kb')
      else
       call w36('disk-based route')
       ldisk=.true.
      endif

      allocate(evs(MG0*N),stat=i)
      ldiskev=i.ne.0
      ldiskev=.true.
      if(ldiskev)then
       call w36(' Eigenvectors on disk')
      else
       write(6,4901)MG0,(MG0*N/1000*8),IERM,J1
       write(3,4901)MG0,(MG0*N/1000*8),IERM,J1
4901   format(I8,' possible eigenvalues in memory',i12,' kb',/,
     1 I8,' loaded now, J1 = ',I8)
       REWIND 45
       DO 1005 IN=1,J1-1
1005   READ(45)
       DO 1007 IN=1,IERM
1007   READ(45)(evs(I+N*(IN-1)),I=1,N)
      endif

      IF(N.LT.M)THEN
       WRITE(6,*)' Sub-space dimension must be =< N !',N,M
       WRITE(3,*)' Sub-space dimension must be =< N !',N,M
       IERR=2
       GOTO 6666
      ENDIF
      ANORM=2.0d0*ANORM/(DBLE(N*(N-1)))
      DIAG=DIAG/DBLE(N)*2.0d0
      ALCONV=GRADCONV*MAX(DIAG,ANORM)*DBLE(N)
      WRITE(3,3003)ANORM,DIAG, ALCONV,OLIMIT,MAXIT,N,M,IERM+1,J1,s1,
     1MVTOT,ELMAX,IEMAX
      WRITE(6,3003)ANORM,DIAG, ALCONV,OLIMIT,MAXIT,N,M,IERM+1,J1,s1,
     1MVTOT,ELMAX,IEMAX,nproc
3003  FORMAT(' Average magnitude of matrix el. :',F20.10,/,
     1       ' Average diagonal element        :',F20.10,/,
     2       ' Convergence criterium           :',F20.10,/,
     3       ' Cut-off norm for subspace       :',F20.10,/,
     4       ' Maximum number of iterations    :',I20,/,
     5       ' Dimension of the matrix space   :',I20,/,
     6       ' Dimension of the iterative space:',I20,/,
     7       ' Restart eigenvalue              :',I20,/,
     8       ' Total eigenvalue                :',I20,/,
     8       ' Symmetry block                  :',19x,a1,/,
     8       ' Total eigenvalues done          :',I20,/,
     9       ' Maximal eigenvalue              :',F20.2,/,
     9       ' Maximal number of eigenvalues   :',I20,/,
     9       ' Number of processors            :',I20,/,/)
c
      OPEN(4,FILE=s1//'E.SCR',FORM='UNFORMATTED')
      READ(4,END=444)(D(IEE),IEE=1,IERM)
444   CLOSE(4)
      WRITE(6,6008)IERM+1
      WRITE(3,6008)IERM+1
6008  FORMAT(' Calculation started from eigenvalue number ',I4)
c
C     Starting dimension of the subspace:
      MSTART=M
C
      DO 5555 IE=IERM+1,MIN(N,NE)
C     Estimate starting eigenvalue:
      EL=0.0d0
      IF(IE.GT.1)EL=D(IE-1)
C     Estimate starting eigenvector as unit vector:
      AF=1.0d0/DSQRT(DBLE(N))
      DO 29 I=1,N
29    X(I)=AF
c     For higher vectors, take that from previous interaction
      if(IE.GT.IERM+1)then
       EL=E(2)
C$OMP  PARALLEL DO PRIVATE(I,J)  DEFAULT(SHARED)
       DO 131 I=1,N
       YNEW(I)=0.0d0
       DO 131 J=1,M
131    YNEW(I)=YNEW(I)+Z(J,2)*X(I+N*(J-1))
C$OMP  PARALLEL DO PRIVATE(I)  DEFAULT(SHARED)
       DO 241 I=1,N
241    X(I)=YNEW(I)
      endif
C     Orthonormalize to previous eigenvectors Y1..YIE-1 in this block:
      if(ldiskev)then
       REWIND 45
       DO 1001 IN=1,J1-1
1001   READ(45)
       DO 71 IN=1,IE-1
       READ(45)(Y(I),I=1,N)
       SN=0.0d0
       DO 61 I=1,N
61     SN=SN+Y(I)*X(I)
       DO 71 I=1,N
71     X(I)=X(I)-SN*Y(I)
      else
       DO 711 IN=1,IE-1
       SN=0.0d0
       DO 611 I=1,N
611    SN=SN+evs(I+N*(IN-1))*X(I)
       DO 711 I=1,N
711    X(I)=X(I)-SN*evs(I+N*(IN-1))
      endif
      call normvc(X,1,N,nstartt,nendt,nproc,sar)
      ITER=0
      DELL=0.0d0
      M=MSTART
C
C     Start of the iterative cycle: ..............................
C
9999  ITER=ITER+1
      IF(ITER.GT.MAXIT)THEN
       WRITE(3,*)' Maximum number of iterations exceeded'
       WRITE(6,*)' Maximum number of iterations exceeded'
       IERR=8888
       GOTO 8888
      ENDIF
      IF(M+IE-1.GT.N)THEN
       WRITE(3,*)' Subspace-dimension has to be decreased'
       M=N-IE+1
       IF(M.LT.1)THEN
        WRITE(3,*)'  No subspace for the eigenvector left !'
        WRITE(3,*)' Try to increase the subspace-dimension.'
        GOTO 6666
       ENDIF
      ENDIF
C     Form gradient vectors Xk,k=2..M, new basis: {X1,..,Xk}
C     Xk+1=AXk-ELXk  (Xk,K>1 generated by X1)
C$OMP PARALLEL DO PRIVATE(I)  DEFAULT(SHARED)
      DO 209 I=1,N*M
209   AXV(I)=0.0d0

      DO 3 K=2,M
      if(ldisk)then
       if(l12)then
        OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
       else
        OPEN(2,FILE=s1//'A.SCR',FORM='UNFORMATTED')
       endif
       read(2)
       DO 20 I=1,N
       READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
       if(lto.and.j33(nn(I)).eq.I)then
        if(adf*a33(nn(I)).gt.etlim)a33(nn(I))=a33(nn(I))*
     1  (etal+(1.0d0-etal)*exp(-(adf*a33(nn(I))-etlim)**2/det**2))
       endif
       if(l12)then
        DO 201 ii=1,nn(I)
        J=j33(ii)
201     AXV(I+N*(K-2))=AXV(I+N*(K-2))+a33(ii)*X(J+N*(K-2))
       else
        DO 202 ii=1,nn(I)
        J=j33(ii)
        AXV(J+N*(K-2))=AXV(J+N*(K-2))+a33(ii)*X(I+N*(K-2))
202     AXV(I+N*(K-2))=AXV(I+N*(K-2))+a33(ii)*X(J+N*(K-2))
       endif
20     continue
       close(2)
      else
       if(l12)then
        NK2=N*(K-2)
C$OMP   PARALLEL DO PRIVATE(I,ii,J,s1r)  DEFAULT(SHARED)
        DO 203 I=1,N
        s1r=0.0d0
        DO 20311 ii=1,nn(I)
        J=mm(I)+ii
20311   s1r=s1r+abb(J)*X(jbb(J)+NK2)
203     AXV(I+NK2)=s1r
       else
        DO 204 I=1,N
        DO 204 ii=1,nn(I)
        J=jbb(mm(I)+ii)
        AXV(J+N*(K-2))=AXV(J+N*(K-2))+abb(mm(i)+ii)*X(I+N*(K-2))
204     AXV(I+N*(K-2))=AXV(I+N*(K-2))+abb(mm(I)+ii)*X(J+N*(K-2))
       endif
      endif
C     Gradient vector K:
      NK1=N*(K-1)
      NK2=N*(K-2)
C$OMP PARALLEL DO PRIVATE(I)  DEFAULT(SHARED)
      DO 2031 I=1,N
2031  X(I+NK1)=AXV(I+NK2)-EL*X(I+NK2)
C     Orthogonalize vector XK to previous gradient vectors:
C$OMP PARALLEL DO PRIVATE(I,IN,SN,NIN)  DEFAULT(SHARED)
      DO 74 IN=1,K-1
      SN=0.0d0
      NIN=N*(IN-1)
      DO 741 I=1,N
741   SN=SN+X(I+NIN)*X(I+NK1)
74    SNS(IN)=SN

C$OMP PARALLEL DO PRIVATE(I,IN)  DEFAULT(SHARED)
      DO 7 I=1,N
      DO 7 IN=1,K-1
7     X(I+NK1)=X(I+NK1)-SNS(IN)*X(I+N*(IN-1))

C     Orthogonalize vector XK to previous eigenvectors Xin, in=1..IE-1
      if(ldiskev)then
       REWIND 45
       DO 1002 IN=1,J1-1
1002   READ(45)
       DO 72 IN=1,IE-1
       READ(45)(Y(I),I=1,N)
       SN=0.0d0
       DO 62 I=1,N
62     SN=SN+Y(I)*X(I+NK1)
       DO 72  I=1,N
72     X(I+NK1)=X(I+NK1)-SN*Y(I)
      else
C$OMP  PARALLEL DO PRIVATE(I,IN,SN,NIN)  DEFAULT(SHARED)
       DO 1008 IN=1,IE-1
       SN=0.0d0
       NIN=N*(IN-1)
       DO 1009 I=1,N
1009   SN=SN+evs(I+NIN)*X(I+NK1)
1008   SNS(IN)=SN
C$OMP  PARALLEL DO PRIVATE(I,IN)  DEFAULT(SHARED)
       DO 722 I=1,N
       DO 722 IN=1,IE-1
722    X(I+NK1)=X(I+NK1)-SNS(IN)*evs(I+N*(IN-1))
      endif
C     Normalize vector K:

C$OMP PARALLEL DEFAULT(SHARED) PRIVATE(ipr,j,s1r)
      ipr=OMP_GET_THREAD_NUM()+1
      s1r=0.0d0
      do 110 j=nstart(ipr),nend(ipr)
110   s1r=s1r+X(j+NK1)**2
      sar(ipr)=s1r
C$OMP END PARALLEL
      ANORM=0.0d0
      DO 10 I=1,nproc
10    ANORM=ANORM+sar(I)

C     (Check on convergence on gradient for the last:)
      IF(K.EQ.2)THEN
       CONV=ANORM
       IF(ABS(CONV).LT.ALCONV)GOTO 8888
      ENDIF
      ANORM=1.0d0/DSQRT(ANORM)
C$OMP PARALLEL DO PRIVATE(I)  DEFAULT(SHARED)
      DO 5 I=1,N
5     X(I+NK1)=X(I+NK1)*ANORM
3     CONTINUE
c     end of K -loop of gradient vectors

      if(ldisk)then
       if(l12)then
        OPEN(2,FILE=s1//'A2.SCR',FORM='UNFORMATTED')
        read(2)
        DO 205 I=1,N
        READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
        DO 205 ii=1,nn(I)
        j=j33(ii)
205     AXV(I+N*(M-1))=AXV(I+N*(M-1))+a33(ii)*X(J+N*(M-1))
       else
        OPEN(2,FILE=s1//'A.SCR',FORM='UNFORMATTED')
        read(2)
        DO 206 I=1,N
        READ(2)nn(I),(j33(ii),ii=1,nn(I)),(a33(ii),ii=1,nn(I))
        DO 206 ii=1,nn(I)
        j=j33(ii)
        AXV(J+N*(M-1))=AXV(J+N*(M-1))+a33(ii)*X(I+N*(M-1))
206     AXV(I+N*(M-1))=AXV(I+N*(M-1))+a33(ii)*X(J+N*(M-1))
       endif
       close(2)
      else
       if(l12)then
        NM1=N*(M-1)
C$OMP   PARALLEL DO PRIVATE(I,ii,j,s1r)  DEFAULT(SHARED)
        DO 207 I=1,N
        s1r=0.0d0
        DO 2071 ii=1,nn(I)
        J=mm(I)+ii
2071    s1r=s1r+abb(J)*X(jbb(J)+NM1)
207     AXV(I+NM1)=s1r
       else
        DO 208 I=1,N
        DO 208 ii=1,nn(I)
        J=jbb(mm(I)+ii)
        AXV(J+N*(M-1))=AXV(J+N*(M-1))+abb(mm(i)+ii)*X(I+N*(M-1))
208     AXV(I+N*(M-1))=AXV(I+N*(M-1))+abb(mm(I)+ii)*X(J+N*(M-1))
       endif
      endif
C     Now looking for new eigenvector in the subspace of {Xk}
C     Form the sub-space matrix F=X.A.X:
C$OMP PARALLEL DO PRIVATE(ii,jj,i)  DEFAULT(SHARED)
      DO 21 II=1,M
      DO 21 JJ=1,II
      F(II,JJ)=0.0d0
      DO 21 I=1,N
21    F(II,JJ)=F(II,JJ)+AXV(I+N*(II-1))*X(I+N*(JJ-1))
C     Diagonalize the sub-space directly:
      CALL TRED12(NSS,M,F,Z,E,2,IERR,BUFF)
C     Take the lowest eigenvalue:
      EL=E(1)
      if(HW)WRITE(6,6007)ITER,EL,CONV,M
6007  FORMAT(' It=',I4,' Lambda=',F20.10,' Grad=',F20.10,' M=',I3)
      DELL=ABS(ELAST-EL)
      ELAST=EL
C     New approximation to the eigenvector:
C$OMP PARALLEL DO PRIVATE(j,i)  DEFAULT(SHARED)
      DO 13 I=1,N
      YNEW(I)=0.0d0
      DO 13 J=1,M
13    YNEW(I)=YNEW(I)+Z(J,1)*X(I+N*(J-1))
      DO 24 I=1,N
24    X(I)=YNEW(I)
C     Check occasional fault of direct diagonalization:
      ANORM=0.0d0
      DO 224 I=1,N
224   ANORM=ANORM+ X(I)*X(I)
      IF(ANORM.LT.AMACH)THEN
C$OMP  PARALLEL DO PRIVATE(i)  DEFAULT(SHARED)
       DO 225 I=1,N
       X(I)=1.0d0/DSQRT(DBLE(N))
225    YNEW(I)=X(I)
      ENDIF
      IF(M.EQ.1)THEN
       WRITE(3,*)'Last eigenvector left'
       GOTO 8888
      ENDIF
C     Check if the sub-space is not redundant:
      MNEW=M
      DO 50 J=M,4,-1
      FF=Z(J,1)*Z(J,1)
      IF(FF.GT.OLIMIT)GOTO 4444
50    MNEW=J-1
4444  M=MAX(MNEW,3)
C
C     Check if the sub-space should be increased:
      FF=Z(M,1)*Z(M,1)
      IF(FF.GT.OLIMIT)M=MIN(M+1,NSS)
      IF(ITER.GT.1)THEN
       IF(CONV.GE.GRADOLD)M=MIN(M+1,NSS)
      ENDIF
C
      GRADOLD=CONV
      GOTO 9999
8888  WRITE(3,6000)IE,ITER-1,CONV,EL,ALCONV,DELL,MNEW
     1,dble(mclock()-it0)/100.0d0
      WRITE(6,6000)IE,ITER-1,CONV,EL,ALCONV,DELL,MNEW
     1,dble(mclock()-it0)/100.0d0
6000  Format(
     1' *************** The ',I3,'. eigenvalue ******************',/,
     2' Iter',I6,' Gradient   : ',F20.10,' Lambda  : ',F20.10,/,
     3'     ',6X,' Limit grad.: ',F20.10,' Del Lam.: ',F20.10,/,
     4' Final sub-space dim.  : ',   I20,' t (sec) : ',f20.2,/,/)
      D(IE)=EL
C     Save values & vectors into scratch-files:
      REWIND 45
      DO 10031 J=1,J1-1
10031 READ(45)
      DO 1003 J=1,IE-1
1003  READ(45)
      WRITE(45)(YNEW(I),I=1,N)
      if(.not.ldiskev)then
       if(MG0.lt.IE)call report('Too many eigenvectors')
       do 1010 I=1,N
1010   evs(I+N*(IE-1))=YNEW(I) 
      endif
      OPEN(4,FILE=s1//'E.SCR',FORM='UNFORMATTED')
      WRITE(4)(D(IEE),IEE=1,IE)
      CLOSE(4)
      IF(HW)THEN
       WRITE(3,*)' The eigenvector:'
       WRITE(3,3004)(YNEW(J),J=1,N)
3004   FORMAT(7F10.5)
      ENDIF
      IF(EL.GT.ELMAX.OR.IE.GE.IEMAX) GOTO 6666
5555  CONTINUE
6666  M=MSAVE
      MV=MIN(IE,NE)
      CLOSE(2)
      CLOSE(45)
      if(.not.ldisk)deallocate(jbb,abb)
      if(.not.ldiskev)deallocate(evs)
      RETURN
      END
