      SUBROUTINE prepc(N,HW,N7)
c
c     prepare the calculation of Hamiltonian in cartesian cosinus
c     basis:
c      1) load in masses and change into atomic units
c      2) load in fij,cijk,diijk from scratch files
c      3) project space coord and save in common ccc and quit
c
c     COFF - cage offset (atoms vibrates within +/- COFF A
c
c     final hamiltonian:
c     H=-(1/2m)d^2/dx^2 + c0
c                      + sum(i)               c1i    xi
c                      + sum(i)               c2ii   xi^2
c                      + sum(i)               c3iii  xi^3
c                      + sum(i)               c4iiii xi^4
c                      + sum(i< j)            c2ij   xi   xj
c                      + sum(i<>j)            c3iij  xi^2 xj
c                      + sum(i<>j)            c4iiij xi^3 xj
c                      + sum(i< j)            c4iijj xi^2 xj^2
c                      + sum(i<j<k)           c3ijk  xi   xj   xk
c                      + sum(i,j<k,j<>i,k<>i) c4iijk xi^2 xj   xk
c
c
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      LOGICAL HW,lex
      include 'dimensions.h'
      COMMON/ccc/c1i(NT3),c2ii(NT3),c2ij(NT3**2),
     1c3iii(NT3),c3iij(NT3**2),c3ijk(NT3**3),
     1c4iiii(NT3),c4iiij(NT3*NT3),c4iijj(NT3*NT3),c4iijk(NT3**3),
     1ac(NT3),eground,amc(NT3),f0(NT3,NT3),A(NT3,NT3),cq(NT3**3),
     1fx(NT3**2),cx(NT3*NT3*NT3),dx(NT3*NT3*NT3),rx(NT3),
     1xi(3),xa(3),xt(NT3)
      common/opt/ropt(100)
      equivalence (ropt(1),COFF)
      character CHX(3)
      data CHX/'X','Y','Z'/
c     large arrays:

c
      call w36('prepc called')
c
      N2=N*N
c
c     load projected harmonic FC:
      open(21,file='P.FC')
      call READFF(NT3,N,f0)
      close(21)
      do 3 i=1,N
      do 3 j=1,N
3     fx(i+(j-1)*N)=f0(i,j)
c
      CALL DOMA(A,NT3,N,HW)
c
c     load cubic, if exist, use the projected ones
      inquire(file='CP.SCR',exist=lex)
      open(21,file='CP.SCR',form='unformatted')
      if(lex)then
       read(21)(cx(i),i=1,N**3)
      else
       call vz(cx,0.0d0,N2*N)
c      read-in sparse constants
       OPEN(4,FILE='SCR.33',status='old')
       ic=0
1      READ(4,*,END=5333)I,J,K,cx(i+(j-1)*N+(k-1)*N2)
       ic=ic+1
       goto 1
5333   continue
       close(4)
       write(6,*)ic,' cx cartesians read in'
       write(3,*)ic,' cx cartesians read in'
c
       do 90 i=1,N
       do 90 j=1,i
       do 90 k=1,j
       t=(cx(i+(j-1)*N+(k-1)*N2)+cx(i+(k-1)*N+(j-1)*N2)
     1   +cx(j+(i-1)*N+(k-1)*N2)+cx(j+(k-1)*N+(i-1)*N2)
     1   +cx(k+(i-1)*N+(j-1)*N2)+cx(k+(j-1)*N+(i-1)*N2))/6.0d0
       cx(i+(j-1)*N+(k-1)*N2)=t
       cx(i+(k-1)*N+(j-1)*N2)=t
       cx(j+(k-1)*N+(i-1)*N2)=t
       cx(j+(i-1)*N+(k-1)*N2)=t
       cx(k+(i-1)*N+(j-1)*N2)=t
90     cx(k+(j-1)*N+(i-1)*N2)=t
       write(6,*)'cx symmetrized'
       write(3,*)'cx symmetrized'
c
       DO 52 JJ=1,N
       DO 52 KK=1,N
       INDJK=(JJ-1)*N+(KK-1)*N2
       DO 52 I=1,N
       SUM=0.0d0
       DO 53 II=1,N
53     SUM=SUM+A(I,II)*cx(II+INDJK)
52     dx(I+INDJK)=SUM
       DO 54 I=1,N
       DO 54 KK=1,N
       INDIK=I+(KK-1)*N2
       DO 54 J=1,N
       SUM=0.0d0
       DO 55 JJ=1,N
55     SUM=SUM+A(J,JJ)*dx((JJ-1)*N+INDIK)
54     cx((J-1)*N+INDIK)=SUM
       DO 56 I=1,N
       DO 56 J=1,N
       INDIJ=I+(J-1)*N
       DO 56 K=1,N
       SUM=0.0d0
       DO 57 KK=1,N
57     SUM=SUM+A(K,KK)*cx((KK-1)*N2+INDIJ)
56     dx((K-1)*N2+INDIJ)=SUM
       do 58 i=1,N**3
58     cx(i)=dx(i)
       write(21)(cx(i),i=1,N**3)
       write(6,*)' cx space-projected and saved to CP.SCR'
      endif
      close(21)
c
c     load quartics, if exist, use the projected ones
      inquire(file='QP.SCR',exist=lex)
      open(21,file='QP.SCR',form='unformatted')
      if(lex)then
       read(21)(dx(i),i=1,N**3)
      else
       call vz(dx,0.0d0,N2*N)
c      read-in sparse constants
       OPEN(4,FILE='SCR.44',status='old')
       ic=0
2      READ(4,*,END=6333)I,J,K,dx(i+(j-1)*N+(k-1)*N2)
       ic=ic+1
       goto 2
6333   continue
       write(6,*)ic,' dx cartesians read in'
       write(3,*)ic,' dx cartesians read in'
       close(4)
c
       do 91 i=1,N
       do 91 j=i,N
       t=0.5d0*(dx(i+(j-1)*N+(j-1)*N2)+dx(j+(i-1)*N+(i-1)*N2))
       dx(i+(j-1)*N+(j-1)*N2)=t
91     dx(j+(i-1)*N+(i-1)*N2)=t
       do 92 i=1,N
       do 92 j=1,N
       do 92 k=j,N
       t=0.5d0*(dx(i+(j-1)*N+(k-1)*N2)+dx(i+(k-1)*N+(j-1)*N2))
       dx(i+(k-1)*N+(j-1)*N2)=t
92     dx(i+(j-1)*N+(k-1)*N2)=t
       write(6,*)'dx symmetrized'
       write(3,*)'dx symmetrized'
c
       WRITE(6,*)' projecting space coordinates'
       do 59 jj=1,n
       do 59 kk=1,n
       jk=(jj-1)*n+(kk-1)*n2
       do 59 I=1,n
       sum=0.0d0
       do 531 ii=1,n
       do 531 ip=1,n
c
c      all non-zero ii ip jj kk
       if(ii.eq.ip)then
        sum=sum+A(I,ii)*A(I,ii)*dx(ii+jk)
       else
        if(ii.eq.jj)then
         sum=sum+A(I,jj)*A(I,ip)*dx(jj+(ip-1)*n+(kk-1)*n2)
        else
         if(ii.eq.kk)then
          sum=sum+A(I,kk)*A(I,ip)*dx(kk+(ip-1)*n+(jj-1)*n2)
         else
          if(ip.eq.jj)then
           sum=sum+A(I,ii)*A(I,jj)*dx(jj+(ii-1)*n+(kk-1)*n2)
          else
           if(ip.eq.kk)then
            sum=sum+A(I,ii)*A(I,kk)*dx(kk+(ii-1)*n+(jj-1)*n2)
           else
            if(jj.eq.kk)then
             sum=sum+A(I,ii)*A(I,ip)*dx(kk+(ii-1)*n+(ip-1)*n2)
            endif
           endif
          endif
         endif
        endif
       endif
531    continue
59     cq(I+jk)=sum
       do 60 I=1,n
       do 60 kk=1,n
       IK=I+(kk-1)*n2
       do 60 J=1,n
       sum=0.0d0
       do 61 jj=1,n
61     sum=sum+A(J,jj)*cq((jj-1)*n+IK)
60     dx((J-1)*n+IK)=sum
       do 62 I=1,n
       do 62 J=1,n
       InDIJ=I+(J-1)*n
       do 62 K=1,n
       sum=0.0d0
       do 63 kk=1,n
63     sum=sum+A(K,kk)*dx((kk-1)*n2+InDIJ)
62     cq((K-1)*n2+InDIJ)=sum
       do 64 i=1,n**3
64     dx(i)=cq(i)
       write(6,*)' space coordinates projected from dx'
       write(3,*)' space coordinates projected from dx'
       write(21)(dx(i),i=1,N**3)
      endif
      close(21)
c
c     read in masses and transform to atomic units
      open(21,file='ZIM.SCR',form='unformatted',status='old')
      read(21)(amc(i),i=1,N)
      close(21)
      do 65 i=1,N
65    amc(i)=amc(i)*1822.8880d0
c
c     coordinates
      open(21,file='FILE.X',status='old')
      read(21,*)
      read(21,*) nat
      do 67 i=1,nat
67    read(21,*)idumm,(rx((i-1)*3+j),j=1,3)
      close(21)
c
c     find cage:
      do 69 ix=1,3
      xi(ix)=rx(ix)
      xa(ix)=rx(ix)
      do 69 ia=2,nat
      if(rx((ia-1)*3+ix).lt.xi(ix))xi(ix)=rx(3*(ia-1)+ix)
69    if(rx((ia-1)*3+ix).gt.xa(ix))xa(ix)=rx(3*(ia-1)+ix)
      if(COFF.lt.0)then
       write(3,*)'local waves'
       write(6,*)'local waves'
       write(3,3001)2.0d0*abs(COFF),2.0d0*abs(COFF)/0.529177d0
3001   format('Cage: ',F5.2,' A = ',F5.2,' au')
       do 82 i=1,N
       rx(i)=abs(COFF)
82     ac(i)=2.0d0*abs(COFF)
      else
       write(3,*)'global waves'
       write(6,*)'global waves'
       do 68 ix=1,3
       do 70 ia=1,nat
       rx((ia-1)*3+ix)=rx((ia-1)*3+ix)-xi(ix)+COFF
70     ac((ia-1)*3+ix)=xa(ix)-xi(ix)+COFF+COFF
       write(3,3000)CHX(ix),ac(ix),ac(ix)/0.529177d0
68     write(3,3000)CHX(ix),ac(ix),ac(ix)/0.529177d0
3000   format('Cage ',A1,': ',F5.2,' A = ',F5.2,' au')
      endif
c
c     lengths to au:
      do 66 i=1,N
      rx(i)=rx(i)/0.529177d0
66    ac(i)=ac(i)/0.529177d0
c
c     now Hamiltonian is in atomic units
c     H=-(1/2)/m*d^2/dx^2+(1/2)fx_ij(x-rx_i)(x-rx_j)+(1/6)cx_ijk ...etc
c
c     test:
      do 89 i=1,N
89    xt(i)=sin(dble(i))+cos(dble(2*i))
      vt=0.0d0
      do 85 i=1,N
      ri=xt(i)-rx(i)
      do 85 j=1,N
      xj=xt(j)-rx(j)
      ij=i+(j-1)*N
      vt=vt+0.5d0*fx(ij)*ri*xj
      do 85 k=1,N
      xk=xt(k)-rx(k)
      vt=vt+cx(ij+(k-1)*N2)/6.0d0*ri*xj*xk
85    vt=vt+dx(ij+(k-1)*N2)/4.0d0*ri*ri*xj*xk
c
      c0=0.0d0
      do 71 i=1,N
      do 71 j=1,N
      c0=c0+0.5d0*fx(i+(j-1)*N)*rx(i)*rx(j)
      do 71 k=1,N
71    c0=c0-cx(i+(j-1)*N+(k-1)*N2)*rx(i)*rx(j)*rx(k)/6.0d0
     1     +0.25d0*dx(i+(j-1)*N+(K-1)*N2)*rx(i)*rx(i)*rx(j)*rx(k)
c
      do 72 i=1,N
      sum1i=0.0d0
      sum2ii=0.5d0*fx(i+(i-1)*N)
      sum3iii=cx(i+(i-1)*N+(i-1)*N2)/6.0d0
     1-0.5d0*dx(i+(i-1)*N+(i-1)*N2)*rx(i)
      do 73 j=1,N
      sum1i=sum1i-fx(i+(j-1)*N)*rx(j)
      sum2ii=sum2ii-0.5d0*cx(i+(i-1)*N+(j-1)*N2)*rx(j)
     1             +dx(j+(i-1)*N+(i-1)*N2)*rx(j)*rx(j)/4.0d0
     1             +dx(i+(i-1)*N+(j-1)*N2)*rx(j)*rx(i)
      sum3iii=sum3iii-0.5d0*dx(i+(j-1)*N+(i-1)*N2)*rx(j)
      do 73 k=1,N
      sum2ii=sum2ii+dx(i+(j-1)*N+(k-1)*N2)*rx(j)*rx(k)/4.0d0
73    sum1i=sum1i+0.5d0*cx(i+(j-1)*N+(k-1)*N2)*rx(j)*rx(k)
     1       -0.5d0*dx(k+(i-1)*N+(j-1)*N2)*rx(j)*rx(k)*rx(k)
     1       -0.5d0*dx(i+(j-1)*N+(k-1)*N2)*rx(i)*rx(j)*rx(k)
      c4iiii(i)=dx(i+(i-1)*N+(i-1)*N2)/4.0d0
      c3iii(i)=sum3iii
      c2ii(i)=sum2ii
72    c1i(i)=sum1i
c
      do 74 i=1,N
      do 74 j=1,N
      ij=i+(j-1)*N
      sum2ij=fx(ij)
      do 75 k=1,N
75    sum2ij=sum2ij-cx(ij+(k-1)*N2)*rx(k)
     1+0.5d0*dx(k+(i-1)*N+(j-1)*N2)*rx(k)*rx(k)
     1+(dx(ij+(k-1)*N2)*rx(i)+dx(j+(i-1)*N+(k-1)*N2)*rx(j))*rx(k)
74    c2ij(i+(j-1)*N)=sum2ij
c
      do 76 i=1,N
      do 76 j=1,N
      sum3iij=0.5d0*cx(i+(i-1)*N+(j-1)*N2)
     1-0.5d0*dx(i+(j-1)*N+(j-1)*N2)*rx(j)
     1-      dx(i+(i-1)*N+(j-1)*N2)*rx(i)
      do 78 k=1,N
78    sum3iij=sum3iij-0.5d0*dx(i+(k-1)*N+(j-1)*N2)*rx(k)
76    c3iij(i+(j-1)*N)=sum3iij
c
      do 79 i=1,N
      do 79 j=1,N
      do 79 k=1,N
      ijk=i+(j-1)*N+(k-1)*N2
79    c3ijk(ijk)=cx(ijk)
     1       -dx(ijk)*rx(i)
     1       -dx(j+(i-1)*N+(k-1)*N2)*rx(j)
     1       -dx(k+(i-1)*N+(j-1)*N2)*rx(k)
c
      do 80 i=1,N
      do 80 j=1,N
      c4iijj(i+(j-1)*N)=0.5d0*dx(i+(j-1)*N+(j-1)*N2)
80    c4iiij(i+(j-1)*N)=0.5d0*dx(i+(i-1)*N+(j-1)*N2)
c
      do 81 i=1,N
      do 81 j=1,N
      ij=i+(j-1)*N
      do 81 k=1,N
81    c4iijk(ij+(k-1)*N2)=0.5d0*dx(ij+(k-1)*N2)
c
c     numerical test
      vt2=c0
      do 86 i=1,N
      ri=xt(i)
      r2=ri*ri
      vt2=vt2+c1i(i)*ri+c2ii(i)*r2+c3iii(i)*ri*r2+c4iiii(i)*r2*r2
      do 86 j=1,N
      if(j.ne.i)then
       xj=xt(j)
       ij=i+(j-1)*N
       vt2=vt2+c3iij(ij)*r2*xj+c4iiij(ij)*ri*r2*xj
       if(j.lt.i)then
        vt2=vt2+c2ij(ij)*ri*xj+c4iijj(ij)*r2*xj*xj
        do 87 k=1,j-1
        ijk=ij+(k-1)*N2
87      vt2=vt2+c3ijk(ijk)*ri*xj*xt(k)
       endif
       do 88 k=1,j-1
88     if(k.ne.i)vt2=vt2+c4iijk(ij+(k-1)*N2)*r2*xj*xt(k)
      endif
86    continue
      write(6,*)'test of V: ',vt2,vt
      write(3,*)'test of V: ',vt2,vt
c
c     energy of ground state
      eground=c0
      do 94 i=1,N
      eground=eground+ac(i)**4/5.0d0*c4iiii(i)
     1               +ac(i)**3/4.0d0*c3iii(i)
     1               +ac(i)**2/3.0d0*c2ii(i)
     2               +ac(i)   /2.0d0*c1i(i)
      do 95 j=1,N
      if(i.eq.j)goto 95
      ij=i+(j-1)*N
      eground=eground+c3iij(ij)*ac(i)**2*ac(j)/6.0d0
     1              +c4iiij(ij)*ac(i)**3*ac(j)/8.0d0
      do 97 k=1,j-1
97    if(k.ne.i)eground=eground+c4iijk(ij+(k-1)*N2)*
     1ac(i)**2*ac(j)*ac(k)/12.0d0
      if(j.gt.i)goto 95
      eground=eground+c2ij(ij)*ac(i)*ac(j)/4.0d0
     1               +c4iijj(ij)*ac(i)**2*ac(j)**2/9.0d0
      do 96 k=1,j-1
96    eground=eground+c3ijk(ij+(k-1)*N2)*ac(i)*ac(j)*ac(k)/8.0d0
95    continue
94    continue
      write(6,*)'eground',eground
c
      N7=1
c
      return
      end
