      subroutine prodert(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
c     primite temperature dependence from second property derivatives
c     and harmonic force field
      implicit none
      integer*4 N7,N,nprop,j,idumm,nprop0,ip,iq,N71,jq,
     1NTEM,i,is,ICS,NCSP,NXX,IC,II,JJ,Iw,Jw,Kw,NTEM0
      include 'dimensions.h'
      parameter (nprop0=NT0*NT0,NTEM0=10,
     1NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6 )
      character*20 labprop(nprop0)
      logical lex,lprop,QUARTIC,LSPARSE,L4,LH40,HW
      character*80 st,s80
      real*8 prop(nprop0),tems(NTEM0),CM,dsum,E(*),ecm,b,csum,ASL,esum,
     1cot2,C,CS
      common/tlist/tems,NTEM
      COMMON/DIA2A/C(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      real*8,allocatable:: propq(:,:),pt(:)
c     propq(nprop0,NT3*2)

      CM=219470.0d0

      call w36(' ')
      call w36('Prodert')
      call w36('^^^^^^')

      inquire(file='PROP.TXT.SCR',exist=lex)
      if(lex)then
       call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
       open(9,file='PROP.TXT.SCR')
       read(9,*)N71,N
       if(N71.gt.N7)call report('N71>N7')
       if(N.gt.NT3)call report('N exceeded in proder')
24     read(9,*,end=9999,err=9999)lprop
       read(9,9003)st
9003   format(a80)
       read(9,*)nprop
       if(nprop.gt.nprop0)call report('too many properties')
       allocate(propq(1:nprop,1:N**2),stat=is)
       if(is.ne.0)call report('cannot allocate propq')
       allocate(pt(1:nprop),stat=is)
       if(is.ne.0)call report('cannot allocate pt')

c      equilibrium property:
       do 25 ip=1,nprop
       read(9,9003)s80
       labprop(ip)=s80(1:20)
25     read(s80(21:80),*)prop(ip)
c
c      property derivatives:
       do 26 ip=1,nprop
       do 261 j=N71,N
       read(9,9003)s80
261    read(s80(21:80),*)idumm,propq(ip,j),propq(ip,N+j)
26     continue
c
       if(lprop)then
        call w36(st)
        call w36(' Equilibrium property:                P_Eq')
        call w36(' Classical temperature correction  :  d_Class')
        call w36(' Quantum temperature correction II:   d_ii')
        call w36(' Quantum temperature correction I:    d_i')
        call w36(' p_Eq + d_ii + d_i               :    P_t')
        call w36(' Change from the first temperature:  dP_t')
        do 1 i=1,NTEM
        write(6,6001)tems(i)
        write(3,6001)tems(i)
6001    format('Temperature: ',f5.1,' K:')

        call w36(
     1  '           Property          P_Eq       d_Class   '//
     2  '        d_ii          d_i           P_t          dP_t')
        do 29 ip=1,nprop
c       classical sum:
        csum=0.0d0
c       quantum sum:
        dsum=0.0d0
        esum=0.0d0
c       cubic FF corrected quantum sum
        if(LSPARSE)then
         do 21 IC=1,NCSP
         Iw=ICS(1,IC)
         Jw=ICS(2,IC)
         Kw=ICS(3,IC)
C        Term ijk, i<j<k skipped
         IF(Iw.LT.Jw.AND.Jw.LT.Kw)goto 21
C        TERM   ijk, i=j<k IIJ
         IF(Iw.EQ.Jw.AND.Jw.LT.Kw)THEN
          JJ=Iw
          II=Kw
         ELSE
C         TERM   ijk, i<j=k IJJ
          IF(Iw.LT.Jw.AND.Jw.EQ.Kw)THEN
           JJ=Jw
           II=Iw
          else
c          TERM iii
           IF(Iw.ne.Jw.or.Jw.ne.Kw)call report('error in prodert')
           II=Jw
           JJ=Iw
          endif
         ENDIF
         b=E(JJ)*CM/(0.69502d0*tems(i))
         esum=esum-0.25d0*propq(ip,II)*CS(IC)*cot2(b)/E(II)
c        if(II.lt.9.and.JJ.lt.9)write(6,*)II,JJ,JJ,b,CS(IC)
21       continue
        ENDIF
        do 2 iq=N7,N
        ecm=E(iq)*CM
c       beta=b=E/kT
        b=ecm/(0.69502d0*tems(i))
        csum=csum+0.25d0/b*propq(ip,N+iq)
        dsum=dsum+0.25d0*propq(ip,N+iq)*cot2(b)
        if(.not.LSPARSE)then
         do 22 jq=N7,N
         b=E(jq)*CM/(0.69502d0*tems(i))
c        if(Iq.lt.9.and.Jq.lt.9)write(6,*)Iq,Jq,Jq,b,c(iq,jq,jq)
22       esum=esum-0.25d0*propq(ip,iq)*C(iq,jq,jq)*cot2(b)/E(iq)
        endif
2       continue
c       stop
        if(i.eq.1)pt(ip)=dsum+esum
        write(3,3009)labprop(ip),prop(ip),csum,dsum,esum,
     1  prop(ip)+dsum+esum,dsum+esum-pt(ip)
29      write(6,3009)labprop(ip),prop(ip),csum,dsum,esum,
     1  prop(ip)+dsum+esum,dsum+esum-pt(ip)
3009    format(a20,6g14.5)
1       continue
       endif

       goto 24
9999   if(lex)close(9)
       deallocate(propq,pt)
      endif

      call w36('Prodert-ok')
      return
      end
c     ============================================================
      function cot2(b)
      implicit none
      real*8 a,b,cot2
      a=exp(-b)
      cot2=(a+1.0d0)/(1.0d0-a)
      return
      end
