       SUBROUTINE READARCASTEP(IC,
     1N0,N,F,P,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,ajm,
     2sigma,loptrot,lnmr,ljj,lff,lpolar,ldip,x,iz)
c
c     read force field and other properties from CASTEP
c
      IMPLICIT INTEGER*4 (I-N)
      IMPLICIT REAL*8 (A-H,O-Z)
      include 'dimensions.h'
      DIMENSION F(N0,N),P(NT0,3,3),ALPHA(3,3,NT3),
     1AAT(NT0,3,3),dip(3),polar(3,3),GG(3,3,NT3),AA(3,3,3,NT3),
     1gten(3,3),aten(3,3,3),sigma(*),ajm(NT0,NT0),
     1e(NT3),s(NT3,NT3),zmass(NT0),x(NT0,3),iz(NT0)
      CHARACTER*80 st
      CHARACTER*10 s10
      LOGICAL lapt,laat,lttt,lfc,lx,lten,lfcd,
     1lpolar,ljj,lnmr,loptrot,lff,ldip,
     1l,lfrac
c
      ldip=.false.
      lfrac=.false.
      ljj=.false.
      lff=.false.
      lnmr=.false.
      loptrot=.false.
      lpolar=.false.
      NAT=N/3
C
c     try to read in FF:
      write(s10,10)IC
10    format(I10)
      do 1 istart=1,len(s10)
1     if(s10(istart:istart).ne.' ')goto 2
2     inquire(file='CASTEP/'//s10(istart:len(s10))//'/c1.phonon',
     1exist=l)
      if(l)then
       open(88,file='CASTEP/'//s10(istart:len(s10))//'/c1.phonon')
3      read(88,400,end=499,err=499)st
400    format(a80)

       if(st(1:11).eq.' Fractional')then
        lfrac=.true.
        do 203 i=1,nat
203     read(88,881)idum,(adum,j=1,3),zmass(i)
881     format(i6,1x,3f12.6,5x,f17.6)
        write(3,*)'masses read'
       endif

       if(st(6:10).eq.'q-pt=')then
        read(st(17:47),*)z1,z2,z3
        if(z1.ne.0.0d0.or.z2.ne.0.0d0.or.z3.ne.0.0d0)
     1  call report('Non-Gamma branch')
        do 206 i=1,N
206     read(88,*)idum,e(i)
        read(88,*)
        read(88,*)
        do 207 j=1,N
        do 207 i=1,nat
c       ignore imaginary parts (adum):
207     read(88,*)idum,idum,s(3*(i-1)+1,j),adum,s(3*(i-1)+2,j),adum,
     1  s(3*(i-1)+3,j)

        open(49,file='CASTEP/'//s10(istart:len(s10))//'/FILE.X')
        write(49,*)'CASTEP geometry'
        write(49,*)nat
        do 2081 i=1,nat
2081    write(49,9901)iz(i),(x(i,j),j=1,3)
9901    format(i4,3f10.5,' 0 0 0 0 0 0 0 0.0')
        close(49)

        open(99,file='CASTEP/'//s10(istart:len(s10))//'/F.INP')
        write(99,991)N,N,nat
991     format(3i5)
        do 208 i=1,nat
208     write(99,990)iz(i),(x(i,j),j=1,3)
990     format(i4,3f10.5)
        write(99,*)' Atom Mode X-disp y-disp z-disp'
        do 210 i=1,nat
        do 210 j=1,N
210     write(99,993)i,j,(s(3*(i-1)+k,j),k=1,3)
993     format(2i5,3f12.6)
        write(99,*)N
        write(99,992)(e(j),j=1,N)
992     format(6f12.3)
        close(99)

        lff=.true.
        c1=1302.828d0
        do 211 i=1,N
        do 211 j=1,N
        F(i,j)=0.0d0
        do 211 ii=1,N
        w2=(e(ii)/c1)**2
        if(e(ii).lt.0.0d0)w2=-w2
211     F(i,j)=F(i,j)+s(i,ii)*w2*s(j,ii)
        CONSTS=4.359828d0/0.5291772d0/0.5291772d0
        if(.not.lfrac)call report('unknown masses')
        do 212 i=1,N
        do 212 j=1,N
212     F(i,j)=F(i,j)*dsqrt(zmass((i+2)/3)*zmass((j+2)/3))/CONSTS

        open(21,file='CASTEP/'//s10(istart:len(s10))//'/FILE.FC')
        CALL WRITEFF(NT3,N,F)
        close(21)

        if(.not.lfc)then
         lfc=.true.
         if(.not.lfcd)then
          open(21,file='FILE.FC')
          CALL WRITEFF(NT3,N,F)
          close(21)
          call w36(' Force field written into FILE.FC')
         else
          call w36(' FILE.FC left on disk unchanged')
         endif
        endif
       endif
       goto 3
499    close(88)
      else
       call w36('FF not found')
      endif

c     Chemical Shifts:
      inquire(file='CASTEP/'//s10(istart:len(s10))//'/c2.magres',
     1exist=l)
      if(l)then
       lnmr=.true.
       open(88,file='CASTEP/'//s10(istart:len(s10))//'/c2.magres')
       do 5 i=1,nat
       do 6 j=1,18
6      read(88,*)
       read(88,400)st
       read(st(23:35),*)sigma(i)
       read(88,400)st
       read(st(23:35),*)sigma(i+nat)
       read(88,*)
5      read(88,*)
       call w36('NMR read')
       close(88)
      endif

      return
      end
