      SUBROUTINE READCASTEPi(NAT,N,FCAR0,S,
     1AM,N7,R,step,tol4,tol3,NCAN,ICAN)
c     reads both CASTEP and CP2K
      IMPLICIT none
      integer*4 NAT,N,N7,i,j,k,l,ix,II,ndif,nml,
     1IA,IC,ij,NINDC,imax,jmax,kmax,imx,jmx,kmx,
     1NQ,NQT,ltot,ind,ind1,ind2,nstep,JJ,
     1ic1,ic2,ic3,ic4,is
      include 'dimensions.h'
      CHARACTER*2 atsym
      integer*4 iz(NT0),NCAN,ICAN(*)
      real*8 FCAR0(NT3,NT3),FCAR(NT3,NT3),AM(NT3),R(NT0,3),APT(NT0,3,3),
     1AAT(NT0,3,3),ALPHA(3,3,NT3),APT0(NT0,3,3),aptn(2*NT3,3),
     1AAT0(NT0,3,3),ALPHA0(3,3,NT3),dip(3),dip0(3),polar(3,3),
     1polar0(3,3),alphan(3,3,2*NT3),S(NT3,NT3),FQ(NT3,NT3),
     1ALPHAA(NT3**2,9),GG(3,3,NT3),AA(3,3,3,NT3),APTQ(NT3,3),
     1GGA(NT3**2,9),AAA(NT3**2,27),AATQ(NT3,3),amave,
     1GG0(3,3,NT3),AA0(3,3,3,NT3),A0Q(3,3,3,NT3),
     1AAQ(3,3,3,NT3),ALPHAQ(3,3,NT3),ALPHA0Q(3,3,NT3),
     1rc(NT0,3),APT0Q(NT3,3),AAT0Q(NT3,3),
     1GQ(3,3,NT3),G0Q(3,3,NT3),gten(3,3),gten0(3,3),
     1aten(3,3,3),aten0(3,3,3),ajm(NT0,NT0),sigma(NT0*2),
     1sigmaq(2*NT3,NT0*2),steptol,
     1ajm0(NT0,NT0),sigma0(NT0*2),optrot,optrot0,optrotq(2*NT3),
     1aptaq(2*NT3**2,3),aataq(NT3**2,3),bohr,cm,SFACR,f1,f2,E,tol4,
     1tol3,step,ASS,ff,ei,ej,dd,dm,c0,cqau,cqcn,cqcm,stepstr(NT3)
c     large arrays:
      real*8,allocatable:: CX3(:,:,:),CX4(:,:,:),ajmq(:,:,:)
c     CX3(NT3,NT3,NT3) third energy derivatives
c     CX4(NT3,NT3,NT3) fourth energy derivatives
c     ajmq(2*NT3,NT0,NT0) spin-spin constant derivatives

      LOGICAL lex,lttt,lfc,lx,lff,ldip,lcastep,lcp2k,
     1lapt,laat,lten,lfcd,lnmr,ljj,loptrot,lpolar
      COMMON/CEM/E(NT3)
      common/cnmd/ndif,nml(NT3)
      logical lharm,lopt
      common/lop/lopt(300)
      equivalence (lharm,lopt(9))
C
      call w36('        ')
      call w36('Readcastepi')
      call w36('^^^^^^^^^^^')
      call w36('        ')

      steptol=0.0005d0
      bohr=0.529177d0
      cm=219470.0d0
      SFACR=0.02342179d0
c           =1/sqrt(amu), to transfer S into atomic units
c
c     Unit explanation:
c     -----------------
c     dX ... Cartesian coordinate displacement
c     dQ ... normal mode coordinate
c     dX = S.dQ
c     S ... S-matrix written into FILE.INP
c     St.M.S=1, M is the mass matrix in g/mol
c     s=SFACR.S, s is then in atomic units, is written in SMAT.SCR
c     si.FF.sj=delta(i,j)*ei^2, ei is the normal mode energy in a.u.
c     q ... dimensionless normal mode coordinate, qi=sqrt(ei) Qi
c

      INQUIRE(FILE='CASTEP',EXIST=lcastep)
      INQUIRE(FILE='CP2K',EXIST=lcp2k)
      if(lcastep.and.lcp2k)
     1call report(' Both CASTEP and CP2K found, cannot decide')

      if(.not.lcastep.and..not.lcp2k)
     1call report(' Neither CASTEP or CP2K found')

      inquire(file='FILE.TEN',exist=lten)
      inquire(file='FILE.FC',exist=lfcd)
C
c     Zero geometry
      if(lcastep)call ggeo(0,iz,r,nat,NT0)
      if(lcp2k)call ggeop(0,iz,r,nat,NT0)

      do 34 l=1,nat
34    write(3,4000)iz(l),(r(l,i),i=1,3)
4000  format(I3,3F15.10)

c     assign default mass only if not defined previously:
      do 55 ia=1,nat
      atsym='??'
      ASS=amave(iz(IA),atsym)
      if(am(3*(IA-1)+1).lt.0.0d0)then
       DO 551 I=1,3
551    AM(3*IA-3+I)=ASS
      endif
55    continue
      WRITE(3,*)' Atomic masses:'
      WRITE(3,1113)(AM(i),i=1,3*nat)
1113  FORMAT(4F15.8)
c
      N7=4
      call w36('N7 set to 4 for CASTEP')
      N=3*nat
C
      inquire(file='CQQ.SCR.TXT',exist=lex)
      if(lex)then
       call w36('CQQ.SCR.TXT found on disk, rest of read skipped')
       close(2)
       return
      endif
c
      NSTEP=1+2*ndif
      write(3,*)nstep,' harmonic force fields expected'
      write(6,*)nstep,' harmonic force fields expected'

c     read-in zero point:
      lapt=.false.
      laat=.false.
      lttt=.false.
      lx=.false.
      lfc=.false.
      lff=.false.
      ltot=0
c
c     zero-out the tensors
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
c
c     read current point from the output
      if(lcastep)call readarCASTEP(0,
     1NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,optrot0,
     1ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,ldip,r,iz)
      if(lcp2k)call readarCP2K(0,
     1NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,optrot0,
     1ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,ldip,r,iz)
      call w36('zero point finished')

      if(lapt)write(6,*)'APT found'
      if(laat)write(6,*)'AAT found'
      if(lttt)write(6,*)'TTT found'
      if(lfc)write(6,*)'FF found'
      if(lx)write(6,*)'X found'
      if(ldip)then
       write(3,3700)(dip0(i),i=1,3)
       write(6,3700)(dip0(i),i=1,3)
3700   format(' Dipole         ',3F10.4)
      endif
      if(lpolar)then
       write(3,3705)((polar0(i,j),i=1,3),j=1,3)
       write(6,3705)((polar0(i,j),i=1,3),j=1,3)
3705   format(' Polarizability ',3F10.4,/,
     1        '                ',3F10.4,/,
     1        '                ',3F10.4)
      endif
      if(ljj)then
       call w36('Spin-Spin Coupling')
       call WRITEM(3,NT0,N/3,ajm0)
       call WRITEM(6,NT0,N/3,ajm0)
      endif
      if(lnmr)then
       call w36('Chemical Shifts  Anisotropies')
       do 3701 I=1,N/3
       write(3,3702)I,sigma0(I),sigma0(I+N/3)
3701   write(6,3702)I,sigma0(I),sigma0(I+N/3)
3702   format(i4,2f15.6)
      endif
      if(loptrot)then
       call w36('Optical Rotation')
       write(3,3703)optrot0
       write(6,3703)optrot0
3703   format(f10.2)
      endif
c
c     load only harmonic ff if requested (debug option):
      if(lharm)then
       close(2)
       write(6,*)'lharm option called'
       write(3,*)'lharm option called'
       return
      endif
c
c     transform Cartesian FF into normal modes:
      call trafoq(FCAR0,FQ,S,N)
c
c     transform dipole derivatives into normal modes
      call trafopq(APT0,AAT0,APT0Q,AAT0Q,S,N)
c     write(6,*)N,APT0Q(N,1),APT0Q(N,2),APT0Q(N,3)
c     call report('debug')
c
c     transform polarizability derivatives into normal modes
      call trafoaq(ALPHA0,GG0,AA0,ALPHA0Q,G0Q,A0Q,S,N)
c
      is=0
      allocate(CX3(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX3')
      allocate(CX4(1:N,1:N,1:N),stat=is)
      if(is.ne.0)call report('cannot allocate CX4')
      allocate(ajmq(1:2*N,1:NAT,1:NAT),stat=is)
      if(is.ne.0)call report('cannot allocate ajmq')

c     zero-out/initialize anharmonic variables:
      DO 1 I=1,N
      DO 1 J=1,N
      DO 1 K=1,N
      CX3(I,J,K)=0.0d0
1     CX4(I,J,K)=0.0d0

c
      if(lapt.or.laat)then
       DO 541 II=1,N
       DO 541 JJ=1,N
       DO 541 K=1,3
       aataq(     II+(JJ-1)*N,K)=0.0d0
       aptaq(N**2+II+(JJ-1)*N,K)=0.0d0
541    aptaq(     II+(JJ-1)*N,K)=0.0d0
      endif
c
      if(lttt)then
       DO 542 II=1,N**2
       DO 542 J=1,9
       ALPHAA(II,J)=0.0d0
542    GGA(II,J)=0.0d0
       DO 5421 II=1,N**2
       DO 5421 J=1,27
5421   AAA(II,J)=0.0d0
      endif

      do 547 i=1,N
      do 547 k=1,3
      aptn(i+N,k)=-2.0d0*dip0(k)
547   aptn(i,k)=0.0d0
      do 552 i=1,N
      do 552 k=1,3
      do 552 l=1,3
      alphan(k,l,i+N)=-2.0d0*polar0(k,l)
552   alphan(k,l,i)=0.0d0
c
c     first derivatives and diagonal second dervs:
      if(loptrot)then
       do 554 i=1,N*2
554    optrotq(i)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(lnmr)then
       do 555 i=1,N*2
       do 555 j=1,2*N/3
c      sigma - holds both isotropic and anisotropic part
555    sigmaq(i,j)=0.0d0
      endif
c
c     first derivatives and diagonal second dervs:
      if(ljj)then
       do 556 i=1,N*2
       do 556 j=1,N/3
       do 556 k=1,N/3
556    ajmq(i,j,k)=0.0d0
      endif

c     initialize second derivatives    222222222222222222222222
      DO ii=1,ndif
      I=nml(ii)
      DO 11 J=1,N
      DO 11 K=1,N
11    CX4(I,J,K)=-2.0d0*FQ(J,K)
      if(lapt.or.laat)then
       DO 5411 J=1,N
       DO 5411 K=1,3
5411   aptaq(N**2+I+(J-1)*N,K)=-2.0d0*APT0Q(J,K)
      endif
      if(loptrot)optrotq(N+I)=-2.0d0*optrot0
      if(lnmr)then
       do 5551 j=1,2*N/3
5551   sigmaq(N+I,j)=-2.0d0*sigma0(j)
      endif
      if(ljj)then
       do 5561 j=1,N/3
       do 5561 k=1,N/3
5561   ajmq(N+I,j,k)=-2.0d0*ajm0(j,k)
      endif
      ENDDO
c     initialize second derivatives    222222222222222222222222
c
c
c     start to read the shifted geometries:
      step=0.0d0
      do 3333 IC=1,2*ndif
      I=IC
      if(IC.GT.ndif)I=IC-ndif
      write(6,*)'Point',IC,'(',I,'):',nml(I)
      write(3,*)'Point',IC,'(',I,'):',nml(I)
      if(IC.le.ndif)then
       ff=1.0d0
      else
       ff=-1.0d0
      endif
c
c     check, that we are at the right point, eventually extract step:
      call chkgeosCASTEP(IC,r,nat,step,S,rc,nml(I),iz,lcastep,lcp2k)
      step=dabs(step)
      if(step.lt.1.0d-9)call report('Diff. step too small!')
      if(IC.le.ndif)then
       stepstr(IC)=step
      else
       if(dabs(step-stepstr(I)).gt.steptol)then
        write(6,*)I,IC,stepstr(I),step,steptol
        call report('different forward and backward steps')
       else
        stepstr(I)=0.5d0*(stepstr(I)+step)
       endif
      endif
      step=0.0d0
c
c     zero-out variables:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c
c     read-in current values:
      if(lcastep)call readarCASTEP(IC,
     1NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,
     1ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,ldip,rc,iz)
      if(lcp2k)call readarCP2K(IC,
     1NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,optrot,
     1ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,ldip,rc,iz)
      if(ldip)write(3,3700)(dip(j),j=1,3)
      if(lpolar)write(3,3705)((polar(k,j),k=1,3),j=1,3)
      if(ljj)then
       write(3,*)'Spin-Spin Coupling'
       call WRITEM(3,NT0,N/3,ajm)
      endif
      if(lnmr)then
       write(3,*)'Chemical Shifts Anisotropies'
       do 3704 j=1,N/3
3704   write(3,3702)j,sigma(j),sigma(j+N/3)
      endif
      if(loptrot)then
       write(3,*)'Optical Rotation'
       write(3,3703)optrot
      endif
c
c     transform Cartesian derivatives to normal modes:
      call trafoq(FCAR,FQ,S,N)
      call trafopq(APT,AAT,APTQ,AATQ,S,N)
      call trafoaq(ALPHA,GG,AA,ALPHAQ,GQ,AAQ,S,N)
c
c     do the numerical differentiations:
      DO 3 J=1,N
      DO 3 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)+FQ(J,K)*ff
3     CX4(nml(I),J,K)=CX4(nml(I),J,K)+FQ(J,K)
c
      do 548 j=1,3
      aptn(nml(I)+N,j)=aptn(nml(I)+N,j)+dip(j)
548   aptn(nml(I),j)=aptn(nml(I),j)+ff*dip(j)
      do 553 j=1,3
      do 553 k=1,3
      alphan(j,k,nml(I)+N)=alphan(j,k,nml(I)+N)+polar(j,k)
553   alphan(j,k,nml(I))=alphan(j,k,nml(I))+ff*polar(j,k)
c
      if(lapt.or.laat)then
       DO 543 II=1,N
       DO 543 K=1,3
       ind=nml(I)+N*(II-1)
       aptaq(N**2+ind,K)=aptaq(N**2+ind,K)+APTQ(II,K)
       aptaq(ind,K)=aptaq(ind,K)+APTQ(II,K)*ff
543    aataq(ind,K)=aataq(ind,K)+AATQ(II,K)*ff
c      aataq - nml(I) index goes to coordinate, II is momentum
      endif
c
      if(lttt)then
       DO 544 II=1,N
       ind1=nml(I)+N*(II-1)
       DO 544 J=1,3
       DO 544 K=1,3
       ind2=J+3*(K-1)
       GGA(   ind1,ind2)=GGA(   ind1,ind2)+GQ(    J,K,II)*ff
       ALPHAA(ind1,ind2)=ALPHAA(ind1,ind2)+ALPHAQ(J,K,II)*ff
       DO 544 L=1,3
       ind2=J+3*(K-1)+9*(L-1)
544    AAA(   ind1,ind2)=AAA(   ind1,ind2)+AAQ(J ,K,L,II)*ff
      endif
c
      if(lnmr)then
       DO 545 II=1,2*N/3
       sigmaq(N+nml(I),II)=sigmaq(N+nml(I),II)+sigma(II)
545    sigmaq(nml(I),II)=sigmaq(nml(I),II)+sigma(II)*ff
      endif
c
      if(ljj)then
       DO 546 II=1,N/3
       DO 546 JJ=1,N/3
       ajmq(N+nml(I),II,JJ)=ajmq(N+nml(I),II,JJ)+ajm(II,JJ)
546    ajmq(nml(I),II,JJ)=ajmq(nml(I),II,JJ)+ajm(II,JJ)*ff
      endif
c
      if(loptrot)then
       optrotq(nml(I))=optrotq(nml(I))+optrot*ff
       optrotq(N+nml(I))=optrotq(N+nml(I))+optrot
      endif
c
3333  continue
c
c     dQ(in au)=step(current)/(bohr*SFAC)
c     CX4=[FF(+Q)+FF(-Q)-2FF]/dQ**2     CX3=[FF(+Q)-FF(-Q)]/(2dQ)
      DO 15 I=1,ndif
      step=stepstr(I)
      f1=0.5d0* SFACR*bohr/step
      f2=1.0d0*(SFACR*bohr/step)**2
      DO 15 J=1,N
      DO 15 K=1,N
      CX3(nml(I),J,K)=CX3(nml(I),J,K)*f1
15    CX4(nml(I),J,K)=CX4(nml(I),J,K)*f2

      DO 161 I=ndif,1,-1
      ei=sqrt(E(nml(I)))
      step=stepstr(I)
      f1=0.5d0* SFACR*bohr/step
      f2=1.0d0*(SFACR*bohr/step)**2
      do 161 j=1,3
      aptn(nml(I),j)=aptn(nml(I),j)*f1/ei
      aptn(nml(I)+N,j)=aptn(nml(I)+N,j)*f2/ei/ei
      APT0Q(nml(I),j)=APT0Q(nml(I),j)/ei
161   AAT0Q(nml(I),j)=AAT0Q(nml(I),j)*ei
c
c     for tensor properties, write the derivatives (au) with respect to q:
      inquire(file='TENQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENQ.TXT.SCR found on disk, unchanged')
      else
       if(.not.lapt)then
c       if no analytical derivatives, then use numerical:
        DO 162 I=ndif,1,-1
        do 162 j=1,3
162     APT0Q(nml(I),j)=aptn(nml(I),j)
       endif
       call wrten1q(dip0,ndif,lapt,aptn,APT0Q,NT3,AAT0Q,nml,N)
      endif
c
      DO 18 I=ndif,1,-1
      step=stepstr(I)
      f1=0.5d0* SFACR*bohr/step
      f2=1.0d0*(SFACR*bohr/step)**2
      ei=sqrt(E(nml(I)))
      DO 18 J=ndif,1,-1
      ej=sqrt(E(nml(J)))
      ind=nml(I)+N*(nml(J)-1)
      do 18 k=1,3
      aptaq(ind,k)=aptaq(ind,k)/ei/ej*f1
c
c     third dipolar derivatives uiij = u(N**2+i+(j-1)N)
      aptaq(N**2+ind,k)=aptaq(N**2+ind,k)/ei/ei/ej*f2
18    aataq(ind,k)=aataq(ind,k)/ei*ej*f1
c     aataq = i-index coordinate, J -momentum

      inquire(file='TENAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TENAQ.TXT.SCR found on disk, unchanged')
      else
       call wrtenq(ndif,N,aptaq,aataq,NT3,nml)
      endif
c
      DO 19 I=1,ndif
      ei=sqrt(E(nml(I)))
      step=stepstr(I)
      f1=0.5d0* SFACR*bohr/step
      f2=1.0d0*(SFACR*bohr/step)**2
      do 19 j=1,3
      do 19 k=1,3
      G0Q(j,k,nml(I))=G0Q(j,k,nml(I))/ei
      ALPHA0Q(j,k,nml(I))=ALPHA0Q(j,k,nml(I))/ei
      alphan(j,k,nml(I))=alphan(j,k,nml(I))*f1/ei
      do 19 l=1,3
19    A0Q(j,k,l,nml(I))=A0Q(j,k,l,nml(I))/ei

      call wrttq(polar0,ndif,nml,ALPHA0Q,alphan,gten0,aten0,
     1G0Q,A0Q,NT3)


      do 23 i=1,ndif
      ei=sqrt(E(nml(i)))
      step=stepstr(I)
      f1=0.5d0* SFACR*bohr/step
      do 23 j=i,ndif
      ej=sqrt(E(nml(j)))
      ind1=nml(I)+N*(nml(J)-1)
      ind2=nml(J)+N*(nml(I)-1)
      do 22 ix=1,9
      GGA(ind1,ix)   =0.5d0*(GGA(ind1,ix)   +GGA(ind2,ix)   )/ei/ej*f1
      GGA(ind2,ix)=GGA(ind1,ix)
      ALPHAA(ind1,ix)=0.5d0*(ALPHAA(ind1,ix)+ALPHAA(ind2,ix))/ei/ej*f1
22    ALPHAA(ind2,ix)=ALPHAA(ind1,ix)
      do 26 ix=1,27
      AAA(ind1,ix)   =0.5d0*(AAA(ind1,ix)   +AAA(ind2,ix)   )/ei/ej*f1
26    AAA(ind2,ix)=AAA(ind1,ix)
23    continue

      inquire(file='TTTAQ.TXT.SCR',exist=lex)
      if(lex)then
       call w36('TTTAQ.TXT.SCR found on disk, unchanged')
      else
       call wrttqaq(ndif,nml,N,NT3,ALPHAA,GGA,AAA)
      endif


      inquire(file='PROP.TXT.SCR',exist=lex)
      if(lex)then
       call w36('PROP.TXT.SCR exists, now overwritten')
      else
       open(21,file='PROP.TXT.SCR')
       write(21,*)N7,N
c
       if(loptrot)then
        do 271 I=1,ndif
        step=stepstr(I)
        f1=0.5d0* SFACR*bohr/step
        f2=1.0d0*(SFACR*bohr/step)**2
        optrotq(nml(i))=optrotq(nml(i))*f1
271     optrotq(nml(i)+N)=optrotq(nml(i)+N)*f2
        write(21,*)loptrot
        write(21,2125)1,optrot0
2125    format('Optical rotation:',/,i5,/,20x,f10.2)
        do 27 i=N7,N
        if(e(i).le.0.0d0)then
         write(21,2126)i,0.0d0,0.0d0
        else
         write(21,2126)i,optrotq(i)/dsqrt(e(i)),optrotq(N+i)/e(i)
        endif
27      continue
2126    format(20x,i5,2g15.5)
       endif
c
       if(lpolar)then
        do 272 i=1,3
        do 272 j=1,3
        do 272 k=1,ndif
        step=stepstr(k)
        f1=0.5d0* SFACR*bohr/step
        f2=1.0d0*(SFACR*bohr/step)**2
        alphan(i,j,nml(k))=alphan(i,j,nml(k))*f1
272     alphan(i,j,N+nml(k))=alphan(i,j,N+nml(k))*f2
        write(21,*)lpolar
        write(21,2132)9
2132    format('Polarizability:',/,i5)
        do 32 i=1,3
        do 32 j=1,3
32      write(21,21281)i,j,polar0(i,j)
        do 33 i=1,3
        do 33 j=1,3
        do 33 k=N7,N
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,alphan(i,j,k)/dsqrt(e(k)),
     1   alphan(i,j,N+k)/e(k)
        endif
33      continue
       endif
c
       if(lnmr)then
        do 273 i=1,N/3
        do 273 k=1,ndif
        step=stepstr(k)
        f1=0.5d0* SFACR*bohr/step
        f2=1.0d0*(SFACR*bohr/step)**2
        sigmaq(nml(k),i)=sigmaq(nml(k),i)*f1
        sigmaq(N+nml(k),i)=sigmaq(N+nml(k),i)*f2
        sigmaq(nml(k),i+N/3)=sigmaq(nml(k),i+N/3)*f1
273     sigmaq(N+nml(k),i+N/3)=sigmaq(N+nml(k),i+N/3)*f2
        write(21,*)lnmr
        write(21,2127)N/3
2127    format('Chemical shifts:',/,i5)
        do 28 i=1,N/3
28      write(21,2131)i,sigma0(i)
2131    format(i20,2g15.5)
        do 29 i=1,N/3
        do 29 j=N7,N
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
2128     format(i20,i5,4g15.5)
        else
         write(21,2128)i,j,sigmaq(j,i)/dsqrt(e(j)),sigmaq(N+j,i)/e(j)
        endif
29      continue

        write(21,*)lnmr
        write(21,2133)N/3
2133    format('Shift Anisotropies:',/,i5)
        do 281 i=1,N/3
281     write(21,2131)i,sigma0(i+N/3)
        do 291 i=1,N/3
        do 291 j=N7,N
        if(e(j).le.0.0d0)then
         write(21,2128)i,j,0.0d0,0.0d0
        else
         write(21,2128)i,j,sigmaq(j,i+N/3)/dsqrt(e(j)),
     1   sigmaq(N+j,i+N/3)/e(j)
        endif
291     continue
       endif
c
       if(ljj)then
        do 274 i=1,N/3
        do 274 j=1,N/3
        do 274 k=1,ndif
        step=stepstr(k)
        f1=0.5d0* SFACR*bohr/step
        f2=1.0d0*(SFACR*bohr/step)**2
        ajmq(nml(k),i,j)=ajmq(nml(k),i,j)*f1
274     ajmq(N+nml(k),i,j)=ajmq(N+nml(k),i,j)*f2
        write(21,*)ljj
        write(21,2129)N/3*N/3
2129    format('Spin-Spin Couplings:',/,i5)
        do 30 i=1,N/3
        do 30 j=1,N/3
30      write(21,21281)i,j,ajm0(i,j)
21281   format(2i10,g15.5)
        do 31 i=1,N/3
        do 31 j=1,N/3
        do 31 k=N7,N
        if(e(k).le.0.0d0)then
         write(21,2130)i,j,k,0.0d0,0.0d0
        else
         write(21,2130)i,j,k,ajmq(k,j,i)/dsqrt(e(k)),ajmq(N+k,j,i)
     1   /e(k)
        endif
31      continue
2130    format(2i10,i5,2g15.5)
       endif

       close(21)
       call w36('PROP.TXT.SCR')
      endif
c

      if(.not.lff)call report('force field not found')
c
      call w36(' ')
      call w36('Symmetrizing cubics')
      NINDC=0
      imax=0
      jmax=0
      kmax=0
      imx=0
      jmx=0
      kmx=0
      dd=0.0d0
      dm=0.0d0
      DO 152 I=N7,N
      DO 152 J=I,N
      DO 152 K=J,N
      c0=CX3(I,J,K)
      CX3(I,J,K)=(CX3(I,J,K)+CX3(I,K,J)+CX3(J,I,K)
     1+           CX3(J,K,I)+CX3(K,I,J)+CX3(K,J,I))/6.0d0
      if(dabs(c0-CX3(I,J,K)).gt.dd)then
       dd=dabs(c0-CX3(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
152   NINDC=NINDC+1
      write(6,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
      write(3,8989)imax,jmax,kmax,CX3(imax,jmax,kmax),dd
8989  format(' Largest assymetry:',3i3,' c =',g12.4,' dc =',g12.4)
      write(6,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
      write(3,1989)imx,jmx,kmx,CX3(imx,jmx,kmx)
1989  format(' Largest constant :',3i3,' c =',g12.4)
c
c     list cubics into text file
      open(23,file='CQQ.SCR.TXT')
      NQ=0
      nqt=0
      do 62 i=N7,N
      do 62 j=i,N
      do 62 k=j,N

c     skip if no differentiation:
      ic1=0
      ic2=0
      ic3=0
      do 622 ii=1,ndif
      if(nml(ii).eq.i)ic1=ic1+1
      if(nml(ii).eq.j)ic2=ic2+1
622   if(nml(ii).eq.k)ic3=ic3+1
      if(ic1.ne.1.or.ic2.ne.1.or.ic3.ne.1)goto 62

c     skip if mode blocked:
      do 4001 l=1,NCAN
4001  if(I-N7+1.eq.ICAN(l).or.J-N7+1.eq.ICAN(l).or.K-N7+1.eq.ICAN(l))
     1goto 62
c
c     skip for negative frequencies:
      if(e(i).le.0.0d0.or.e(j).le.0.0d0.or.e(k).le.0.0d0)goto 62

      cqau=CX3(I,J,K)
      cqcn=cqau/dsqrt(abs(e(i)*e(j)*e(k)))
      cqcm=cqcn*cm
c
c     skip small constants:
      if(abs(cqcm).lt.tol3)goto 62
c
      write(23,2423)I,J,K,cqcn,cqcm
2423  format(3I5,G16.8,' ',F9.1)
      nq=nq+1
62    nqt=nqt+1
      close(23)
      write(6,6000)nqt,nq,tol3
      write(3,6000)nqt,nq,tol3
6000  format('Number of normal cubics ',I10,/,
     1       'Selected                ',I10,/,
     1       'Limit                   ',F10.7,/,
     1       'Writen in CQQ.SCR.TXT',/)

      call w36(' ')
      call w36('Symmetrizing quartics')
      imax=0
      jmax=0
      kmax=0
      dd=0.0d0
      imx=0
      jmx=0
      kmx=0
      dm=0.0d0
      DO 153 I=N7,N
      DO 153 J=N7,N
      DO 153 K=J,N
      c0=CX4(I,J,K)
      if(j.eq.i)then
c      iii
       if(k.eq.i)then
c       iiii
       else
c       iiik iiki
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       endif
      else
c      iij
       if(k.eq.i)then
c       iiji iiji
        CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
        CX4(I,K,J)=CX4(I,J,K)
       else
        if(k.eq.j)then
c        iijj jjii
         CX4(I,J,K)=(CX4(I,J,K)+CX4(J,I,I))/2.0d0
         CX4(J,I,I)=CX4(I,J,K)
        else
c        iijk iikj
         CX4(I,J,K)=(CX4(I,J,K)+CX4(I,K,J))/2.0d0
         CX4(I,K,J)=CX4(I,J,K)
        endif
       endif
      endif
      if(dabs(c0-CX4(I,J,K)).gt.dd)then
       dd=dabs(c0-CX4(I,J,K))
       imax=i
       jmax=j
       kmax=k
      endif
      if(dabs(c0).gt.dm)then
       dm=dabs(c0)
       imx=i
       jmx=j
       kmx=k
      endif
153   continue
      write(6,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
      write(3,8985)imax,imax,jmax,kmax,CX4(imax,jmax,kmax),dd
8985  format(' Largest assymetry:',4i3,' d =',g12.4,' dd =',g12.4)

      write(6,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
      write(3,2989)imx,imx,jmx,kmx,CX4(imx,jmx,kmx)
2989  format(' Largest constant :',4i3,' d =',g12.4)
c
c     zero if no differentiation:
      do 621 i=n7,n
      do 621 j=n7,n
      do 621 k=j,n
      ic1=0
      ic2=0
      ic3=0
      ic4=0
      do 623 ii=1,ndif
      if(nml(ii).eq.i)ic1=ic1+1
      if(nml(ii).eq.i)ic2=ic2+1
      if(nml(ii).eq.j)ic3=ic3+1
623   if(nml(ii).eq.k)ic4=ic4+1
621   if(ic1.ne.1.or.ic2.ne.1.or.ic3.ne.1.or.ic4.ne.1)CX4(i,j,k)=0.0d0
c     write sparse quartics
      call write4(CX4,N7,N,NCAN,ICAN,E,tol4)
c
      deallocate(CX3)
      deallocate(CX4)
      deallocate(ajmq)
c
      RETURN
      END
c     ============================================================
      subroutine chkgeosCASTEP(ID,r,nat,step,S,rc,ireq,iz,lcastep,lcp2k)
      implicit none
      integer*4 nat,l,ic,ix,iq,ii,ireq,ID,iz(*),IDD
      include 'dimensions.h'
      real*8 r(NT0,3),step,rc(NT0,3),dq,S(NT3,NT3),cm,E,AM,
     1SFACR,bohr,ropt,geotol,dc(NT0,3)
      COMMON/CEM/E(NT3)
      common/MASS/AM(NT3)
      common/opt/ropt(100)
      equivalence (geotol,ropt(20))
      logical lcastep,lcp2k
c
      cm=219470.0d0
      SFACR=0.02342179d0
      bohr=0.529177d0
c
c     read current geometry
      IDD=ID
      if (lcastep)call ggeo(IDD,iz,rc,nat,NT0)
      if (lcp2k)call ggeop(IDD,iz,rc,nat,NT0)
      ic=0
c
c     Cartesian displacements from equilibrium
      DO 2 l=1,nat
      DO 2 ix=1,3
2     dc(l,ix)=rc(l,ix)-r(l,ix)
c
c     normal mode displacements
      do 3 iq=1,3*nat
      dq=0.0d0
      do 4 l=1,nat
      do 4 ix=1,3
      ii=3*(l-1)+ix
4     dq=dq+AM(ii)*S(ii,iq)*dc(l,ix)
c
c     adapt to the strange pmz units dq=dq/SFACR:
      dq=dq/SFACR
      if(dabs(dq).gt.geotol)then
       write(6,6000)iq,e(iq)*cm,dq,dq*SFACR/bohr
6000   format(' Mode',i4,f10.2,' cm-1',' dQ =',f10.4,' au:',f10.4)
       if(ireq.ne.iq)call report('errorneous mode numbering')
       ic=ic+1
       call chksti(dq,step)
      endif
3     continue

      if(ic.ne.1)then
       write(3,*)ic
       write(6,*)ic
       call report('deffective differentiation')
      endif
      return
      end
c     ============================================================
      subroutine ggeo(ic,iz,r,nat,NT0)
      implicit none
      integer*4 iz(*),NT0,nat,ic,istart,i,j
      logical l,lu
      real*8 r(NT0,3),uv(3,3),a,b,c,ab,ac,bc,alpha,beta,gamma,
     1ca,cb,sb,cg,sg,car,sar,o11,o12,o13,o22,o23,o33,pi,x,y,z
      character*10 s10
      character*80 s80
      integer*4 MENDELEV
      parameter (MENDELEV=89)
      CHARACTER*2 atsy(MENDELEV)
      data atsy/' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     3'Na','Mg','Al','Si',' P',' S','Cl','Ar',
     4' K','Ca','Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     4          'Ga','Ge','As','Se','Br','Kr',
     5'Rb','Sr',' Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
     5          'In','Sn','Sb','Te',' I','Xe',
     6'Cs','Ba','La',
     6               'Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho',
     6               'Er','Tm','Yb','Lu',
     6'Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
     6          'Tl','Pb','Bi','Po','At','Rn',
     7'Fr','Ra','Ac'/
      pi=4.0d0*atan(1.0d0)
      write(s10,10)ic
10    format(I10)
      do 1 istart=1,len(s10)
1     if(s10(istart:istart).ne.' ')goto 2
2     inquire(file='CASTEP/'//s10(istart:len(s10))//'/c.cell',exist=l)
      if(.not.l)call
     1report('CASTEP/'//s10(istart:len(s10))//'/c.cell'//' not found')
      open(40,file='CASTEP/'//s10(istart:len(s10))//'/c.cell')
      lu=.false.
3     read(40,100,end=4,err=4)s10
100   format(A10)
      if(s10.eq.'%BLOCK LAT')then
       lu=.true.
       do 201 i=1,3
201    read(40,*)(uv(i,j),j=1,3)
       write(3,*)'unit cell read'
       a=dsqrt(uv(1,1)**2+uv(1,2)**2+uv(1,3)**2)
       b=dsqrt(uv(2,1)**2+uv(2,2)**2+uv(2,3)**2)
       c=dsqrt(uv(3,1)**2+uv(3,2)**2+uv(3,3)**2)
       ab=uv(1,1)*uv(2,1)+uv(1,2)*uv(2,2)+uv(1,3)*uv(2,3)
       ac=uv(1,1)*uv(3,1)+uv(1,2)*uv(3,2)+uv(1,3)*uv(3,3)
       bc=uv(2,1)*uv(3,1)+uv(2,2)*uv(3,2)+uv(2,3)*uv(3,3)
       alpha=180.0d0/pi*acos(bc/b/c)
       beta=180.0d0/pi*acos(ac/a/c)
       gamma=180.0d0/pi*acos(ab/b/a)
       if(ic.eq.0)then
        write(6,*)'unit cell read'
        write(6,600)alpha,a,beta,b,gamma,c
        write(3,600)alpha,a,beta,b,gamma,c
600     format(/,' Crystall cell parameters:',/,/,
     1           '   alpha: ',f10.2,'   a: ',f10.4,/,
     1           '    beta: ',f10.2,'   b: ',f10.4,/,
     1           '   gamma: ',f10.2,'   c: ',f10.4,/,/)
       endif
       ca=cos(pi*alpha/180.0d0)
c      sa=sin(pi*alpha/180.0d0)
       cb=cos(pi*beta /180.0d0)
       sb=sin(pi*beta /180.0d0)
       cg=cos(pi*gamma/180.0d0)
       sg=sin(pi*gamma/180.0d0)
       car=(cb*cg-ca)/(sb*sg)
       sar=dsqrt(1.0d0-car*car)
       o11=a
       o12=b*cg
       o13=c*cb
       o22=b*sg
       o23=-c*sb*car
       o33=c*sb*sar
      endif
      if(s10.eq.'%BLOCK POS')then
       if(.not.lu)call report('Unit cell not found')
       nat=0
5      read(40,400)s80
400    format(a80)
       if(s80(1:1).eq.'%')then
        write(3,404)nat
404     format(I10,' atoms')
        return
       else
        nat=nat+1
        if(nat.gt.NT0)call report('Too many atoms')
        read(s80(5:len(s80)),*)x,y,z
        r(nat,1)=x*o11+y*o12+z*o13
        r(nat,2)=      y*o22+z*o23
        r(nat,3)=            z*o33
        iz(nat)=0
        do 204 j=1,MENDELEV
204     if(atsy(j).eq.s80(2:3))iz(nat)=j
        if(iz(nat).eq.0)call report('Atom symbol not recognized')
        goto 5
       endif
      endif
      goto 3
4     call report('Geometry not found')
      end
c     ============================================================
      subroutine ggeop(ic,iz,r,nat,NT0)
      implicit none
      integer*4 iz(*),NT0,nat,ic,istart,i
      logical l
      real*8 r(NT0,3)
      character*10 s10
      character*80 st

      nat=0

      write(s10,10)ic
10    format(I10)
      do 1 istart=1,len(s10)
1     if(s10(istart:istart).ne.' ')goto 2
2     continue

c     temporary adaptation:
      istart=8
      if(s10(8:8).eq.' ')s10(8:8)='0'
      if(s10(9:9).eq.' ')s10(9:9)='0'

      inquire(file='CP2K/'//s10(istart:len(s10))//'/c.out',exist=l)
      if(.not.l)call
     1report('CP2K/'//s10(istart:len(s10))//'/c.out'//' not found')
      open(40,file='CP2K/'//s10(istart:len(s10))//'/c.out')

3     read(40,880,end=4,err=4)st
880   format(A80)

      if(st(29:38).eq.' - Atoms: ')then
       read(st(61:80),*)nat
       if(nat.gt.NT0)call report('Too many atoms')
      endif

      if(st(1:21).eq.'  Atom  Kind  Element')then
       if(nat.eq.0)call report('No atoms')
       read(40,880)st
       do 9 i=1,nat
       read(40,880)st
       read(st(19:21),*)iz(i)
c      read(st(68:80),*)zmass(i)
       read(st(22:33),*)r(i,1)
       read(st(34:45),*)r(i,2)
9      read(st(46:57),*)r(i,3)
       close(40)
       return
      endif

      goto 3
4     close(40)
      call report('Geometry not found')
      end
