      SUBROUTINE READG98SI(NAT,N,R,XLIM,step,im,tol3,N7,S)
c
c     reads displaced geometries and calculated property second
c     derivatives as
c                 p_ij = (p_i+d j+d - p_i+d j-d -p_i-d j+d +p_i-d j-d)/(2d)^2
c
c     im=0   Cartesian
c     im=1   Normal Modes
c
      IMPLICIT none
      integer*4 i,j,k,N,nat,l,ix,ist,jst,Ju,ie,im,
     1ntot,N7,IA,ji,jk,jm,kj,kl,lk,is
      include 'dimensions.h'
      integer*4 ig98,idum,ltot,ii,ic,n44,n44t,id,jd,
     1ja,ij,jx,kx,JuK,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14,
     2i15,i16,i17,i18,i19,i20,i21,i22,i23,i24,im1
      CHARACTER*50 S50
c     N^4 and N^3 arrays:
      real*8,allocatable:: CX4(:),ajmq(:,:,:),sigmaq(:,:),AATA(:,:,:,:),
     1alphaa(:,:,:,:),APTA(:,:,:,:),G(:)
c     CX4(NT3**4) fourth energy Cartesian derivatives
c     ajmq(NT3**2,NT0,NT0) second derivatives of spin-spin constants
c     sigmaq(NT3**2,NT0) second derivatives of shielding
c     AATA(NT3**2,NT0,3,3) atomix axial tensor derivs.
c     APTA(NT3**2,NT0,3,3) atomic polar tensor derivs.
c     alphaa(NT3**2,3,3,NT3) polarizability derivs

c     rest of arrays:
      real*8 FCAR0(NT3,NT3),FCAR(NT3,NT3),CM,cqau,cqcn,cqcm,
     2R(NT0,3),APT(NT0,3,3),S(NT3,NT3),XLIM,FQ(NT3,NT3),AATQ(NT3,3),
     1AAT(NT0,3,3),ALPHA(3,3,NT3),APT0(NT0,3,3),APTQ(NT3,3),SFACR,
     1AAT0(NT0,3,3),ALPHA0(3,3,NT3),dip(3),dip0(3),polar(3,3),
     1polar0(3,3),GG(3,3,NT3),GG0(3,3,NT3),ALPHAQ(3,3,NT3),GQ(3,3,NT3),
     1gten(3,3),aten(3,3,3),gten0(3,3),aten0(3,3,3),AAQ(3,3,3,NT3),
     1sigma(2*NT0),sigma0(NT0),ajm(NT0,NT0),ajm0(NT0,NT0),
     1optrot,optrotq(NT3**2),
     1AA(3,3,3,NT3),AA0(3,3,3,NT3),bohr,step,optrot0,ff,f2,
     1tol3
      LOGICAL lex,lttt,lfc,lx,lff,lx4,lgr,
     1OPT,lapt,laat,lten,lfcd,lnmr,ljj,loptrot
      logical lzmat,lharm,lopt,lpolar
      common/lop/lopt(300)
      equivalence (lharm,lopt(9)),(lzmat,lopt(10))
      character*1 lb(2),la(3)
      data lb/'+','-'/,la/'x','y','z'/
      integer*4 nmd,nml
      common/cnmd/nmd,nml(NT3)
      real*8 E
      COMMON/CEM/E(NT3)
C
      INQUIRE(FILE='G2.OUT',EXIST=OPT)
      if(.not.OPT)then
       CALL w36('File G2.OUT with second property derivs not found.')
       return
      else
       CALL w36(' ')
       CALL w36('File G2.OUT with second property derivs found.')
      endif
C
      bohr=0.529177d0
      inquire(FILE='FILE.TEN',exist=lten)
      inquire(FILE='FILE.FC',exist=lfcd)
C
      OPEN(2,FILE='G2.OUT')
      write(6,*)' Looking for geometry'
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       write(6,1111)S50
       write(3,1111)S50
       DO 41 I=1,4
41     READ(2,*)
       l=0
5      READ(2,1111)s50
       IF(s50(2:4).NE.'---')THEN
        l=l+1
        BACKSPACE 2
        if(ig98.eq.0)then
         READ(2,*)idum,idum,(r(l,i),i=1,3)
        else
         READ(2,*)idum,idum,idum,(r(l,i),i=1,3)
        endif
        GOTO 5
       ENDIF
       nat=l
       goto 203
      ENDIF
      goto 201
202   call report('Geometry not found')
203   write(6,*)nat,' atoms'
      write(3,*)nat,' atoms'
      N=3*nat
      allocate(G(N))
c
      IF(step.gt.1.0d-9)then
       write(3,3000)step*bohr,step
       write(6,3000)step*bohr,step
3000   format('Step defined as ',F10.5,'A (',F10.5,'au)')
      endif
c
c     read-in zero point:
      lapt=.false.
      laat=.false.
      lttt=.false.
      lx=.false.
      lfc=.false.
      ltot=0
      call readar0(NT3,N,FCAR0,APT0,AAT0,ALPHA0,dip0,polar0,GG0,AA0,
     1gten0,aten0,optrot0,ajm0,sigma0)
      call readar(NT3,N,FCAR0,APT0,AAT0,ALPHA0,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip0,ltot,polar0,GG0,AA0,gten0,aten0,
     1optrot0,ajm0,sigma0,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(3,3009)loptrot,lnmr,ljj,lff,lfc
      write(6,3009)loptrot,lnmr,ljj,lff,lfc
3009  format('Loptrot Lnmr Ljj Lff Lfc: ',5L3)
      write(3,3700)(dip0(i),i=1,3)
      write(6,3700)(dip0(i),i=1,3)
3700  format(' Dipole         ',3F10.4)
      open(22,file='DIPOLE.TXT.SCR')
      write(22,3699)(dip0(i),i=1,3)
3699  format(3F15.7,' dipole (au)')
      write(22,3698)optrot0
3698  format(F15.7,' optrot')
      write(22,3697)
3697  format('Chemical shifts (ppm):')
      do 558 i=1,nat
558   write(22,3696)i,sigma0(i)
3696  format(i5,F15.7)
      write(22,3695)
3695  format('Spin spin coupling:')
      do 559 i=1,nat
      do 559 j=1,nat
559   write(22,3694)i,j,ajm0(i,j)
3694  format(2i5,F15.7)
      close(22)
      write(3,3701)((polar0(i,j),i=1,3),j=1,3)
      write(6,3701)((polar0(i,j),i=1,3),j=1,3)
3701  format(' Polarizability ',3F10.4,/,
     1       '                ',3F10.4,/,
     1       '                ',3F10.4)
      write(6,*)'zero point read'
      write(3,*)'zero point read'
C
      if(im.eq.0)then
       ntot=N+N
      else
       ntot=nmd+nmd
      endif
      write(3,*)ntot**2,' geometries expected'
      write(6,*)ntot**2,' geometries expected'
c
      allocate(AATA(1:N**2,1:NAT,1:3,1:3),stat=is)
      if(is.ne.0)call report('Cannot allocate memory for AATA')
      allocate(APTA(1:N**2,1:NAT,1:3,1:3),stat=is)
      if(is.ne.0)call report('Cannot allocate memory for APTA')
      allocate(alphaa(1:N**2,1:3,1:3,1:N),stat=is)
      if(is.ne.0)call report('Cannot allocate memory for alphaa')
      allocate(sigmaq(1:N**2,1:NAT),stat=is)
      if(is.ne.0)call report('Cannot allocate memory for sigmaq')
      allocate(ajmq(1:N**2,1:NAT,1:NAT),stat=is)
      if(is.ne.0)call report('Cannot allocate memory for ajmq')
      DO 54 I=1,N
      DO 54 J=1,N
      II=I+N*(J-1)
c     third polarizability derivatives
      DO 542 IJ=1,N
      DO 542 JX=1,3
      DO 542 KX=1,3
542   alphaa(II,JX,KX,IJ)=0.0d0
c     second optical rotation derivatives
      optrotq(II)=0.0d0
      DO 54 IA=1,NAT
c     second NMR shift derivatives
      sigmaq(II,IA)=0.0d0
      DO 541 JX=1,3
      DO 541 KX=1,3
c     third dipolar derivatives
      AATA(II,IA,JX,KX)=0.0d0
541   APTA(II,IA,JX,KX)=0.0d0
      DO 54  JA=1,NAT
54    ajmq(II,IA,JA)=0.0d0

      allocate(CX4(1:N**4),stat=is)
      lx4=is.eq.0
c     selected fourth energy derivatives - small molecules only
      if(lx4)then
       DO 55 I=1,NT3**4
55     CX4(I)=0.0d0
      else
       call w36('Cannot allocate memory - Dijkl ommited')
      endif
c
      ix=0
      jx=1
      i=1
      j=1
      ist=1
      jst=1
      im1=0
      jm=1
c     ==================================================================
      do 3333 IC=1,ntot**2
      IF(im.eq.0)THEN
       ix=ix+1
       if(ix.gt.3)then
        ix=1
        i=i+1
        if(i.gt.nat)then
         i=1
         jx=jx+1
         if(jx.gt.3)then
          jx=1
          j=j+1
          if(j.gt.nat)then
           j=1
           ist=ist+1
           if(ist.gt.2)then
            ist=1
            jst=jst+1
           endif
          endif
         endif
        endif
       endif
       write(3,3001)i,ix,ist,j,jx,jst
3001   format('Expected: ia ix ist ja jx jst:',2(i4,i2,i2))
      ELSE
       im1=im1+1
       if(im1.gt.nmd)then
        im1=1
        jm=jm+1
        if(jm.gt.nmd)then
         jm=1
         ist=ist+1
         if(ist.gt.2)then
          ist=1
          jst=jst+1
         endif
        endif
       endif
       write(3,3002)im1,nml(im1),lb(ist),jm,nml(jm),lb(jst)
3002   format('Expected: i ist j jst:',2(i4,'(',i4,') ',a1))
      ENDIF
c     read geometry and check the diff. step:
      if(im.eq.0)then
       call chkgeo2(r,NT0,nat,lzmat,step,id,jd,ff)
      else
       call chkgeo2s(r,nat,lzmat,step,S,id,jd,ff)
      endif
      if(ist.ne.jst)then
       ff=-1.0d0
      else
       ff=1.0d0
      endif
      if(im.eq.0)then
       write(3,3008)i,la(ix),lb(ist),j,la(jx),lb(jst),lb((3-int(ff))/2)
       write(6,3008)i,la(ix),lb(ist),j,la(jx),lb(jst),lb((3-int(ff))/2)
3008   format(I4,2a1,I5,2a1,2h (,a1,1h))
       id=ix+3*(i-1)
       jd=jx+3*(j-1)
       IE=id+N*(jd-1)
      else
       write(3,3010)im1,lb(ist),jm,lb(jst),lb((3-int(ff))/2)
       write(6,3010)im1,lb(ist),jm,lb(jst),lb((3-int(ff))/2)
3010   format(I4,a1,I5,a1,2h (,a1,1h))
       id=im1
       jd=jm
       IE=nml(id)+N*(nml(jd)-1)
      endif
c     initialize archive reading:
      call readar0(NT3,N,FCAR,APT,AAT,ALPHA,dip,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma)
c     read gaussian archive:
      call readar(NT3,N,FCAR,APT,AAT,ALPHA,lapt,laat,lttt,lfc,lx,
     1lten,lfcd,dip,ltot,polar,GG,AA,gten,aten,
     1optrot,ajm,sigma,loptrot,lnmr,ljj,lff,lpolar,G,lgr)
      write(3,3700)(dip(ju),ju=1,3)
      write(3,3701)((polar(k,ju),k=1,3),ju=1,3)
      if(lnmr)write(3,*)'NMR shifts found'
c
      if(im.eq.1)then
c      transform Cartesian derivatives to normal modes:
       call trafoq(FCAR,FQ,S,N)
       call trafopq(APT,AAT,APTQ,AATQ,S,N)
       call trafoaq(ALPHA,GG,AA,ALPHAQ,GQ,AAQ,S,N)
       DO 6 Ju=1,N
       DO 6 K=1,N
6      FCAR(Ju,K)=FQ(Ju,K)
       DO 5431 II=1,NAT
       DO 5431 Ju=1,3
       DO 5431 K=1,3
c      now for normal modes AAT as an arbitrary double index
       AAT(II,Ju,K)=AATQ(Ju+3*(II-1),K)*ff
5431   APT(II,Ju,K)=APTQ(Ju+3*(II-1),K)*ff
       DO 5441 II=1,N
       DO 5441 Ju=1,3
       DO 5441 K=1,3
       GG(Ju,K,II)=GQ(Ju,K,II)
       ALPHA(Ju,K,II)=ALPHAQ(Ju,K,II)
       DO 5441 L=1,3
5441   AA(L,Ju,K,II)=AAQ(L,Ju,K,II)
      endif

      if(lx4)then
       DO 3 Ju=1,N
       DO 3 K=1,N
       JuK=IE+N**2*(Ju-1+N*(K-1))
       if(dabs(FCAR(Ju,K)).gt.100.0d0)then
        write(6,*)'Defect ',IE,id,jd,Ju,K,FCAR(Ju,K)
        write(3,*)'Defect ',IE,id,jd,Ju,K,FCAR(Ju,K)
        call report('Defective force field')
       endif
3      CX4(JuK)=CX4(JuK)+FCAR(Ju,K)*ff
      endif
      if(lapt.or.laat)then
       DO 543 II=1,NAT
       DO 543 Ju=1,3
       DO 543 K=1,3
       AATA(IE,II,Ju,K)=AATA(IE,II,Ju,K)+AAT(II,Ju,K)*ff
543    APTA(IE,II,Ju,K)=APTA(IE,II,Ju,K)+APT(II,Ju,K)*ff
      endif
      if(ljj.or.lnmr.or.loptrot)then
       optrotq(IE)=optrotq(IE)+optrot*ff
       DO 556 II=1,NAT
       sigmaq(IE,II)=sigmaq(IE,II)+sigma(II)*ff
       DO 556 Ju=1,NAT
556    ajmq(IE,II,Ju)=ajmq(IE,II,Ju)+ajm(II,Ju)*ff
      endif
      if(lttt)then
       DO 544 II=1,N
       DO 544 Ju=1,3
       DO 544 K=1,3
544    alphaa(IE,Ju,K,II)=alphaa(IE,Ju,K,II)+alpha(Ju,K,II)*ff
      endif
3333  continue
c     ==================================================================
c
      close(2)
C
      if(step.lt.1.0d-9)call report('Diff. step too small!')
c
      SFACR=0.02342179d0
      if(im.eq.0)then
       f2=1.0d0/(2.0d0*step)**2
      else
       f2=(SFACR*bohr/(2.0d0*step))**2
      endif
      if(lx4.and.lfc)then
       DO 15 I=1,N**4
15     CX4(I)=CX4(I)*f2
      endif
      if(lttt)then
       DO 545 I=1,N
       DO 545 K=1,3
       DO 545 J=1,3
       DO 545 II=1,N**2
545    alphaa(II,J,K,I)=alphaa(II,J,K,I)*f2
       if(im.eq.0)then
        open(15,file='TTT2.SCR',form='unformatted')
       else
        open(15,file='TTT2Q.SCR',form='unformatted')
       endif
       write(15)((((alphaa(i,j,k,l),i=1,N**2),j=1,3),k=1,3),l=1,N)
       close(15)
      endif
c
      if(lapt.or.laat)then
       DO 546 I=1,N**2
       DO 546 II=1,NAT
       DO 546 J=1,3
       DO 546 K=1,3
       AATA(I,II,J,K)=AATA(I,II,J,K)*f2
546    APTA(I,II,J,K)=APTA(I,II,J,K)*f2
       if(im.eq.0)then
        open(15,file='TEN2.SCR',form='unformatted')
       else
        open(15,file='TEN2Q.SCR',form='unformatted')
       endif
       write(15)((((APTA(i,j,k,l),i=1,N**2),j=1,nat),k=1,3),l=1,3)
       write(15)((((AATA(i,j,k,l),i=1,N**2),j=1,nat),k=1,3),l=1,3)
       close(15)
      endif
c
      if(ljj.or.lnmr.or.loptrot)then
       if(im.eq.0)then
        open(15,file='JJ2.C.SCR')
       else
        open(15,file='JJ2.CQ.SCR')
       endif
       DO 557 I=1,N**2
       optrotq(I)=optrotq(I)*f2
       DO 557 II=1,NAT
       sigmaq(I,II)=sigmaq(I,II)*f2
       DO 557 J=1,NAT
       ajmq(I,II,J)=ajmq(I,II,J)*f2
557    write(15,5571)II,J,I,ajmq(I,II,J)
5571   format(3i4,f15.5)
       close(15)
       if(im.eq.0)then
        inquire(file='NMR2.SCR',exist=lex)
        if(lex)then
         call w36('NMR2.SCR found on disk, not overwritten')
        else
         open(15,file='NMR2.SCR',form='unformatted')
         write(15)optrot0
         write(15)(optrotq(I),I=1,N**2),loptrot
         write(15)(sigma0(II),II=1,NAT)
         write(15)((sigmaq(I,II),I=1,N**2),II=1,NAT),lnmr
         write(15)((ajm0(II,J),II=1,NAT),J=1,NAT)
         write(15)(((ajmq(I,II,J),I=1,N**2),II=1,NAT),J=1,NAT),ljj
         close(15)
         call w36('NMR2.SCR written')
        endif
       else
        open(21,file='PROP2.TXT.SCR')
331     read(21,*,end=6334,err=6334)
        goto 331
6334    write(21,*)N7,N
        write(21,*)loptrot
        write(21,2125)1,optrot0
2125    format('Optical rotation:',/,i5,/,20x,f10.2)
        do 271 i=N7,N
        do 271 j= i,N
        ij=i+N*(j-1)
        ji=j+N*(i-1)
271     write(21,21261)i,j,optrotq(ij)/dsqrt(e(i)*e(j)),
     1  optrotq(ji)/dsqrt(e(i)*e(j))
21261   format(20x,2i5,2g15.5)
        write(21,*)lnmr
        write(21,2127)N/3
2127    format('Chemical shifts:',/,i5)
        do 281 i=1,N/3
281     write(21,2131)i,sigma0(i)
2131    format(i20,g15.5)
        do 291 i=1,N/3
        do 291 j=N7,N
        do 291 k=j,N
        jk=j+N*(k-1)
        kj=k+N*(j-1)
291     write(21,21282)i,j,k,sigmaq(jk,i)/dsqrt(e(j)*e(k)),
     1  sigmaq(kj,i)/dsqrt(e(j)*e(k))
21282   format(i20,2i5,2g15.5)
        write(21,*)ljj
        write(21,2129)N/3*N/3
2129    format('Spin-Spin Couplings:',/,i5)
        do 301 i=1,N/3
        do 301 j=1,N/3
301     write(21,21281)i,j,ajm0(i,j)
21281   format(2i10,g15.5)
        do 311 i=1,N/3
        do 311 j=1,N/3
        do 311 k=N7,N
        do 311 l=k,N
        lk=l+N*(k-1)
        kl=k+N*(l-1)
311     write(21,21301)i,j,k,l,ajmq(kl,j,i)/dsqrt(e(k)*e(l)),
     1  ajmq(lk,j,i)/dsqrt(e(k)*e(l))
21301   format(2i10,2i5,2g15.5)
        close(21)
        call w36('PROP2.TXT.SCR made')
       endif
      endif
c
      if(lfc.and.lx4)then
       do 84 i=1,N
       do 84 j=i,N
       do 84 k=j,N
       do 84 l=k,N
       i1 =i+N*(j-1+N*(k-1+N*(l-1)))
       i2 =i+N*(j-1+N*(l-1+N*(k-1)))
       i3 =i+N*(k-1+N*(j-1+N*(l-1)))
       i4 =i+N*(k-1+N*(l-1+N*(j-1)))
       i5 =i+N*(l-1+N*(j-1+N*(k-1)))
       i6 =i+N*(l-1+N*(k-1+N*(j-1)))
       i7 =j+N*(i-1+N*(k-1+N*(l-1)))
       i8 =j+N*(i-1+N*(l-1+N*(k-1)))
       i9 =j+N*(k-1+N*(i-1+N*(l-1)))
       i10=j+N*(k-1+N*(l-1+N*(i-1)))
       i11=j+N*(l-1+N*(i-1+N*(k-1)))
       i12=j+N*(l-1+N*(k-1+N*(i-1)))
       i13=k+N*(i-1+N*(j-1+N*(l-1)))
       i14=k+N*(i-1+N*(l-1+N*(j-1)))
       i15=k+N*(j-1+N*(i-1+N*(l-1)))
       i16=k+N*(j-1+N*(l-1+N*(i-1)))
       i17=k+N*(l-1+N*(i-1+N*(j-1)))
       i18=k+N*(l-1+N*(j-1+N*(i-1)))
       i19=l+N*(i-1+N*(j-1+N*(k-1)))
       i20=l+N*(i-1+N*(k-1+N*(j-1)))
       i21=l+N*(j-1+N*(i-1+N*(k-1)))
       i22=l+N*(j-1+N*(k-1+N*(i-1)))
       i23=l+N*(k-1+N*(i-1+N*(j-1)))
       i24=l+N*(k-1+N*(j-1+N*(i-1)))
c      if(i.eq.1.and.j.eq.1.and.k.eq.5.and.l.eq.13)
c    1 write(6,60000)i,j,k,l,
c    1 CX4(i1 ),CX4(i2 ),CX4(i3 ),CX4(i4 ),CX4(i5 ),CX4(i6 ),
c    1 CX4(i7 ),CX4(i8 ),CX4(i9 ),CX4(i10),CX4(i11),CX4(i12),
c    1 CX4(i13),CX4(i14),CX4(i15),CX4(i16),CX4(i17),CX4(i18),
c    1 CX4(i19),CX4(i20),CX4(i21),CX4(i22),CX4(i23),CX4(i24)
c0000  format(4i5,4(6f12.6,/))
84     CX4(i1 )=(
     1 CX4(i1 )+CX4(i2 )+CX4(i3 )+CX4(i4 )+CX4(i5 )+CX4(i6 )+
     1 CX4(i7 )+CX4(i8 )+CX4(i9 )+CX4(i10)+CX4(i11)+CX4(i12)+
     1 CX4(i13)+CX4(i14)+CX4(i15)+CX4(i16)+CX4(i17)+CX4(i18)+
     1 CX4(i19)+CX4(i20)+CX4(i21)+CX4(i22)+CX4(i23)+CX4(i24))/24.0d0
       call w36('CX4 were symmetrized')
       N44=0
       N44T=0
       if(im.eq.0)then
        OPEN(4,FILE='D42C.SCR',FORM='UNFORMATTED')
        DO 85 i=1,N
        DO 85 j=i,N
        DO 85 k=j,N
        DO 85 l=k,N
        N44T=N44T+1
        i1 =i+N*(j-1+N*(k-1+N*(l-1)))
        IF(DABS(CX4(i1)).GE.XLIM)THEN
         N44=N44+1
         WRITE(4)i,j,k,l,CX4(i1)
        ENDIF
85      CONTINUE
        write(6,6001)N44T,N44,'C',XLIM
        write(3,6001)N44T,N44,'C',XLIM
       else
        OPEN(4,FILE='D42Q.SCR',FORM='UNFORMATTED')
        CM=219470.0d0
        DO 83 i=N7,N
        DO 83 j=i,N
        DO 83 k=j,N
        DO 83 l=k,N
        N44T=N44T+1
        cqau=CX4(i+N*(j-1+N*(k-1+N*(l-1))))
        cqcn=cqau/dsqrt(dabs(e(i)*e(j)*e(k)*e(l)))
        cqcm=cqcn*cm
        IF(dabs(cqcm).GE.tol3)THEN
         N44=N44+1
         WRITE(4)i,j,k,l,cqcn
        ENDIF
83      CONTINUE
        write(6,6001)N44T,N44,'Q',tol3
        write(3,6001)N44T,N44,'Q',tol3
       endif
       CLOSE(4)
6001   format(i20,' constants,',/,
     1 i20,' selected into D42',a1,'.SCR, TOL:',f10.5)
      endif

      deallocate(AATA)
      deallocate(APTA)
      deallocate(alphaa)
      deallocate(ajmq)
      deallocate(sigmaq)
      if(lx4)deallocate(CX4)
c
      RETURN
      END

      subroutine chkgeo2s(r,nat,lzmat,step0,S,id,jd,ff)
      implicit none
      integer*4 nat,ig98,I,l,ic,ix,iq,ii,id,jd
      include 'dimensions.h'
      real*8 r(NT0,3),tol,rc(NT0,3),dq,S(NT3,NT3),cm,E,AM,
     1SFACR,bohr,step(2),ff,step0
      COMMON/CEM/E(NT3)
      common/MASS/AM(NT3)
      character*50 S50
      logical lzmat
c
      cm=219470.0d0
      SFACR=0.02342179d0
      bohr=0.529177d0
c
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       DO 41 I=1,4
41     READ(2,*)
       tol=1.0d-4
c
c      how many coordinates are different than in zero geometry:ic
c      which coordinates these are: id,jd
       ic=0
       id=0
       jd=0
       step(1)=0.0d0
       step(2)=0.0d0
c
c      read current geometry
       DO 1 l=1,nat
       if(ig98.eq.0)then
        READ(2,*)I,I,(rc(l,ix),ix=1,3)
       else
        READ(2,*)I,I,I,(rc(l,ix),ix=1,3)
       endif
1      continue
c
c      Cartesian displacements from equilibrium
       DO 2 l=1,nat
       DO 2 ix=1,3
2      rc(l,ix)=rc(l,ix)-r(l,ix)
c
c      normal mode displacements
       do 3 iq=1,3*nat
       dq=0.0d0
       do 4 l=1,nat
       do 4 ix=1,3
       ii=3*(l-1)+ix
4      dq=dq+AM(ii)*S(ii,iq)*rc(l,ix)
c
c      adapt to the strange pmz units dq=dq/SFACR:
       dq=dq/SFACR
       if(dabs(dq).gt.tol)then
        write(3,6000)iq,e(iq)*cm,dq,dq*SFACR/bohr
6000    format(/,'Mode',i4,f10.2,' cm-1',' dQ =',f10.4,' au:',f10.4)
        ic=ic+1
        if(ic.gt.2)call report('defective differentiation')
        if(ic.eq.1)then
         id=iq
        else
         jd=iq
        endif
        step(ic)=dq
       endif
3      continue

       if(ic.eq.1)then
        jd=id
        step(1)=step(1)/2.0d0
        step(2)=step(1)
       endif
c
       if(step0.lt.1.0d-8)then
        step0=dabs(step(1))
        write(3,3000)step0
        write(6,3000)step0
3000    format('Step set on the fly as ',F10.5)
       endif
c
       if(dabs(step(1)).lt.tol.or.dabs(step(2)).lt.tol)then
        ff=1.0d0
       else
        if(step(1)*step(2).gt.0.0d0)then
         ff=1.0d0
        else
         ff=-1.0d0
        endif
       endif

       write(3,3001)id,step(1),jd,step(2),ff
       write(6,3001)id,step(1),jd,step(2),ff
3001   format('Mode',I4,F8.4,' Mode',I4,F8.4,', sign: ',f3.0,$)
       return
      ENDIF
      goto 201
202   call report('Geometry not found')
      end
c
      subroutine chkgeo2(r,NT0,nat,lzmat,step0,id,jd,ff)
      implicit none
      integer*4 NT0,nat,ig98,I,l,ic,id,jd,ix
      real*8 r(NT0,3),x(3),tol,step(2),ff,step0,bohr
      character*50 S50
      logical lzmat
c
  201 READ(2,1111,END=202)S50
1111  FORMAT(A50)
      IF((lzmat.and.(s50(19:39).EQ.'Z-Matrix orientation:'.OR.
     1               s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1               s50(20:37).EQ.'Input orientation:'.OR.
     1               s50(27:44).EQ.'Input orientation:'))
     1    .OR.
     1    ((.not.lzmat).and.
     2              (s50(20:40).EQ.'Standard orientation:'.OR.
     2               s50(26:46).EQ.'Standard orientation:')))THEN
       ig98=0
       if(s50(26:46).EQ.'Z-Matrix orientation:'.OR.
     1    s50(27:44).EQ.'Input orientation:'.OR.
     1    s50(26:46).EQ.'Standard orientation:')ig98=1
       DO 41 I=1,4
41     READ(2,*)
       tol=1.0d-5
c
c      how many coordinates are different than in zero geometry:ic
c      which coordinates these are: id,jd
       ic=0
       id=0
       jd=0
       step(1)=0.0d0
       step(2)=0.0d0
       DO 1 l=1,nat
       if(ig98.eq.0)then
        READ(2,*)I,I,(x(ix),ix=1,3)
       else
        READ(2,*)I,I,I,(x(ix),ix=1,3)
       endif
       do 1 ix=1,3
       if(abs(x(ix)-r(l,ix)).gt.tol)then
        ic=ic+1
        if(ic.gt.2)call report('defective differentiation found')
        if(ic.eq.1)then
         id=ix+3*(l-1)
        else
         jd=ix+3*(l-1)
        endif
        step(ic)=x(ix)-r(l,ix)
       endif
1      continue
       if(ic.eq.1)then
        jd=id
        step(1)=step(1)/2.0d0
        step(2)=step(1)
       endif
       if(step0.lt.1.0d-8)then
        bohr=0.529177d0
        step0=dabs(step(1))
        write(3,3000)step0,step0/bohr
        write(6,3000)step0,step0/bohr
        step0=step0/bohr
3000    format('Step set on the fly as ',F10.5,'A (',F10.5,'au)')
       endif

       if(dabs(step(1)).lt.tol.or.dabs(step(2)).lt.tol)then
        ff=1.0d0
       else
        if(step(1)*step(2).gt.0.0d0)then
         ff=1.0d0
        else
         ff=-1.0d0
        endif
       endif
       write(3,3001)id,step(1),jd,step(2),ff
       write(6,3001)id,step(1),jd,step(2),ff
3001   format('Coord',I4,F8.4,' A  coord',I4,F8.4,' A, sign: ',f3.0,$)
       return
      ENDIF
      goto 201
202   call report('Geometry not found')
      end
