      SUBROUTINE ROTCO(R,N7,N,HW,AH4L)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      include 'dimensions.h'
      DIMENSION R(NT0,3),S(NT3,NT3),ABC(3,3),G(NT0,3,NT3),RC(3),AII(3),
     1ACM(3),U(3,3),BUFF(3)
      COMMON/MASS/AM(NT3)
      COMMON/MACHINE/AMACH
      LOGICAL HW
      data BOHR,CM,HBAR,CLIGHT,PI,AMU,CME,ANGSTROM/0.52917715d0,
     1219470.0d0,1.05457266D-34,2.99792458D8,3.141592653589d0,
     11.6605402D-27,0.01d0,1.0D-10/
c
      PI=DBLE(4)*DATAN(DBLE(1))
      CONST=CME*HBAR/(2.0d0*PI*CLIGHT*AMU*ANGSTROM*ANGSTROM*BOHR*BOHR)
      NAT=N/3
C
C     Calculate mass center:
      AMASS=0.0d0
      DO 2 I=1,3
2     ACM(I)=0.0d0
      DO 1 L=1,NAT
      AMASS=AMASS+AM(3*L)
      DO 1 I=1,3
1     ACM(I)=ACM(I)+R(L,I)*AM(3*L)
      DO 3 I=1,3
3     ACM(I)=ACM(I)/AMASS
      WRITE(3,5246)AMASS,(ACM(I),I=1,3)
      WRITE(6,5246)AMASS,(ACM(I),I=1,3)
5246  FORMAT(/,' Molecular mass: ',F12.4,/,
     1         ' Center of mass: ',3F12.7,/)
      DO 4 I=1,NAT
      DO 4 J=1,3
4     R(I,J)=R(I,J)-ACM(J)
      WRITE(3,*)' Coordinates transformed into center-of mass origin'
      DO 6 J=1,3
      ABC(J,J)=0.0d0
      DO 5 L=1,NAT
5     ABC(J,J)=ABC(J,J)+AM(L*3)*
     1  (R(L,1)**2+R(L,2)**2+R(L,3)**2-R(L,J)**2)
      DO 6 I=J+1,3
      ABC(I,J)=0.0d0
      DO 6 L=1,NAT
6     ABC(I,J)=ABC(I,J)-R(L,J)*R(L,I)*AM(L*3)
      DO 7 J=1,3
      DO 7 I=J+1,3
7     ABC(J,I)=ABC(I,J)
      DO 13 J=1,3
      DO 13 I=1,3
13    ABC(I,J)=ABC(I,J)/BOHR**2
      WRITE(3,5247)((ABC(I,J),I=1,3),J=1,3)
5247  FORMAT(' Inertia tensor (a.u.) : ',3F10.4,/,
     1     25X,3F10.4,/,25X,3F10.4,/)
      ND=3
      CALL TRED12(3,ND,ABC,U,RC,2,IERR,BUFF)
      do I=1,3
       AII(I)=RC(I)
      enddo
      DO 12 I=1,3
      RC(I)=0.0d0
12    IF(AII(I).GT.1.0d-10)RC(I)=CONST*(1.0d0/(2.0d0*AII(I)))
      WRITE(3,3005)(RC(I),I=1,3)
      WRITE(6,3005)(RC(I),I=1,3)
3005  FORMAT(/,' A = ',F12.7,' cm-1',/,
     1         ' B = ',F12.7,' cm-1',/,
     2         ' C = ',F12.7,' cm-1',/)
C
C     Make mass-weighted S-matrix
      OPEN(4,FILE='SMAT.SCR',FORM='UNFORMATTED')
      READ(4)NAT,(EIDUM,I=1,N),((S(I,J),J=1,N),I=1,N),SFAC
      CLOSE(4)
      DO 14 I=1,N
      DO 14 J=1,N
14    S(I,J)=S(I,J)/SFAC*DSQRT(AM(I))
C
C     Transform S into inertia system:
      DO 8 L=1,NAT
      DO 8 I=1,3
      DO 8 K=N7,N
      G(L,I,K)=0.0d0
      DO 8 II=1,3
8     G(L,I,K)=G(L,I,K)+U(II,I)*S(3*(L-1)+II,K)
C     Rdiag i = U (j,i) R (j)
C     Temporary S-matrix in diagonal-inertia system
C
C     File H40.SCR with the anharmonic kinetic energy terms Kklmn
C     H40 = sum(k)sum(l>k)sum(k')sum(l'>k') Kklk'l' *
C     (QkPlQk'Pl'-QkPlQl'Pk'-QlPkQk'Pl'+QlPkQl'Pk')
C
C     Kklk'l'=sum(a)sum(i)sum(i')Ba(S(i,b,k)S(i,c,l)-S(i,c,k)S(i,b,l))*
C     (S(i',b,k')S(i',c,l')-S(i',c,k')S(i',b,l'))
C
C     Ba -a-component of rot. constant, even permutation abc indices,
C
      WRITE(3,*)' H40.SCR created'
      OPEN(4,FILE='H40.SCR',FORM='UNFORMATTED')
      NOC=0
      DO 10 K=N7,N
      DO 10 L=K+1,N
      DO 10 M=N7,N
      DO 10 N1=M+1,N
      AKK=0.0d0
      DO 11 IA=1,3
      BA=RC(IA)
      IB=IA+1
      IF(IB.EQ.4)IB=1
      IC=IB+1
      IF(IC.EQ.4)IC=1
      DO 11 I=1,NAT
      S1=BA*     (G(I,IB,K)*G(I,IC,L)-G(I,IC,K)*G(I,IB,L))
      DO 11 J=1,NAT
11    AKK=AKK+S1*(G(J,IB,M)*G(J,IC,N1)-G(J,IC,M)*G(J,IB,N1))
      IF(HW.AND.ABS(AKK).GT.AMACH)WRITE(3,*)K,L,M,N1,AKK
      IF(ABS(AKK).GT.AH4L)THEN
       WRITE(4)K,L,M,N1,AKK/CM
       NOC=NOC+1
      ENDIF
10    CONTINUE
      CLOSE(4)
      WRITE(3,*)NOC,'constants written into H40.SCR'
      RETURN
      END
