      program s4
C     VERSION 2-15-1994, Prague, UOCHB AVCR, 2005
      IMPLICIT none
      include 'dimensions.h'
      integer*4 NGE0
      PARAMETER (NGE0=24)
C
C     NT0 - number of atoms
C     NSS - dimension of the iterative sub-space (SUBROUTINE  MITIN)
C     NGE0 - number of symmetry elements in a group
C
C                   Dependent dimensions:
C
C     NT3 - number of atoms * 3
C
C                   Main memory requirements - in words
C
C        (3*NAT*3*NAT*3*NAT)*6  (c,cx,d,cghost,dghost)
C
C     R in A
C
      real*8 FCAR0(NT3,NT3),S(NT3,NT3),EPHA(NT3),RCONT,SSTEP,
     2EOLD(NT3),R(NT0,3),etem(NT3),CM,AH4L,ASK,ASL,STOL,TOL3,
     1XLIM,YLIM
      integer*4 I,IAH,IDC,IGRF,IP4,IRQR,ITHREE,IZERO,J,n7old,NAT
      CHARACTER*3 SSP(NGE0)

      real*8 E
      COMMON/CEM/E(NT3)

      real*8 A
      INTEGER*4 STATE1(NT3),STATE2(NT3),N7,N
      LOGICAL L4
      COMMON/SUM/A,STATE1,STATE2,N7,N,L4

      INTEGER*4 NCAN,ICAN,NZF,IBR,IERM
      LOGICAL LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,HW,DC,QUARTIC,
     1RDST,lg98,licore,lex,lqfull
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM

      real*8 AMACH
      COMMON/MACHINE/AMACH

      real*8 AM
      COMMON/MASS/AM(NT3)

      real*8 WF,EIQ
      integer*4 IWF
      COMMON/FFF/WF(NT3),EIQ(NT3),IWF(NT3)

      real*8 VMM
      integer*4 NMM,NHAND
      COMMON/MMM/VMM,NMM,NHAND

      real*8 GRADCONV,OLIMIT
      COMMON/PPP/GRADCONV,OLIMIT

      INTEGER*4 IY,CHT(NGE0,NGE0),IG,IGG,KG,ID
      CHARACTER*3 SSTR
      COMMON/SYMCOM/IY(NT3),CHT,IG,IGG,KG,ID(NGE0),SSTR

      integer*4 iopt
      common/iop/iopt(300)
      integer*4 Iset,GVIB_VSCF_NBASE,GVIB_VSCF_MAXITER,iexc,IDIFF
      equivalence (Iset,iopt(2)),(GVIB_VSCF_NBASE,iopt(6)),
     1(GVIB_VSCF_MAXITER,iopt(7)),(iopt(11),iexc),(iopt(2),iset),
     2(IDIFF,iopt(20))

      LOGICAL MP2,LENA,LINEAR,SCALED,LPHASE,LANS,
     1LP3,LP4,LO3,LXS,lzmat,lharm,lvar,lcont,
     2lm4,LENA2,lm4only,lvscf,lena3,lcb,LENAS,L36,L37,LENAF,
     3GVIB_VERBOSE,lnm,lopt,LCIA,lprot,ldstate,LSCALED,lrv,lnm2
      common/lop/lopt(300)
      equivalence        (lvar,   lopt( 2)),
     1(lcont,  lopt( 3)),(lm4   ,lopt( 4)),(LENA2,  lopt( 5)),
     1(lm4only,lopt( 6)),(lvscf, lopt( 7)),
     1(lharm,  lopt( 9)),(lzmat, lopt(10)),(licore, lopt(11)),
     1(lg98,   lopt(12)),(lrv   ,lopt(13)),
     1(lxs,    lopt(15)),(GVIB_VERBOSE,lopt(16)),(lnm,lopt(17)),
     1(lena3,  lopt(18)),(lcb,  lopt(19)),(LENAS,  lopt(34)),
     1(L36,    lopt(36)),(lqfull,lopt(37)),(L37,lopt(38)),
     1(LCIA,   lopt(39)),(LENAF,   lopt(42)),(lprot,   lopt(44)),
     1(ldstate,lopt(47)),(LSCALED,lopt(48)),(lnm2,lopt(52))

      real*8 ropt,COFF,GVIB_VSCF_CLIMIT,tol4,OHD
      common/opt/ropt(100)
      equivalence (COFF,ropt(1)),(GVIB_VSCF_CLIMIT,ropt(2)),
     1(tol4,ropt(3)),(OHD,ropt(23))

C
      OPEN(3,FILE='S4.OUT')
      WRITE(6,6666)
      WRITE(3,6666)
6666  FORMAT(/,
     154H      VIBRATIONAL ENERGIES AND PROPERTIES OF MOLECULES,/,/,
     254H                      Petr Bour's program             ,/,/,
     354H       Institute of Organic Chemistry and Biochemistry,/,
     454H                   Academy of Sciences, Prague        ,/,
     554H                           1994-2009                  ,/,/)
c'
c     Input options:
      CALL STP(N7,GRADCONV,NHAND,OLIMIT,IZERO,ITHREE,MP2,HW,
     1LQD,LPHASE,QUARTIC,SCALED,DC,LANS,LO,LENA,LINEAR,
     2LBLOCK,LMITIN,NCAN,NZF,NMM,VMM,IWF,WF,ICAN,CM,
     3IRQR,SSTR,SSP,NGE0,L4,LSPARSE,ASL,RDST,SSTEP,IDC,LP3,LP4,IP4,
     4IBR,IERM,LO3,LH40,AH4L,XLIM,YLIM,IGRF,AM,rcont,tol3,stol,ASK)

c     calculate spectra only for VCI:
      if(lm4only)goto 9777
c
      CALL MACEPS
C
c     read the numerical differentiation outputs:
      IF(lg98)then
       if(lnm)then
        if(lnm2)then
         call readgi2(NAT,LINEAR,N,FCAR0,S,AM,N7,R,HW,sstep,tol4,tol3,
     1   NCAN,ICAN,XLIM)
        else
         call readg98i(NAT,LINEAR,N,FCAR0,S,AM,N7,R,HW,sstep,tol4,tol3,
     1   NCAN,ICAN,XLIM)
        endif
       else
        if(L36.or.L37)then
         call readg9836(NAT,LINEAR,N,FCAR0,AM,N7,R,XLIM,
     1   YLIM,sstep)
        else
         if(IDIFF.eq.0)then
          call readg98(NAT,LINEAR,N,FCAR0,AM,N7,R,XLIM,
     1    YLIM,sstep,tol3,S)
         else
          call readg98p(NAT,LINEAR,N,FCAR0,AM,N7,R,XLIM,
     1    YLIM,sstep,tol3,S)
         endif
        endif
       endif
      else
c      read basic dimensions from FILE.X
       call reads(S,N)
       call rfilex(NT0,NAT,N,N7,LINEAR,R,AM)
       call w36('Read atoms from FILE.X')
      endif
c
c     Local Cartesian basis
      if(lcb) then
       call lcbsx(N,IP4,YLIM,XLIM,LP3,LP4,IRQR,lopt(23),lopt(24),
     1 lopt(25))
       n7old=N7
       if(lm4)call m4
       open(22,file='TENQ.TXT.SCR')
       close(22,status='delete')
       N7=n7old
      endif
c
c     harmonic part xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
      if(LSCALED.and..not.lnm)CALL READS(S,N)
      call harmonic(fcar0,am,nat,S,lnm,LSCALED)
c
      if(Iset.eq.2)goto 9999
C
c     freeze normal modes
      if(lblock) call doblock(s,NCAN,ICAN,N7,N,E)
c
      IF(MP2)GOTO 5002
5002  DO 44 I=1,N
C     Save original harmonics in EOLD and etem:
      EOLD(I)=E(I)
44    etem(I)=E(I)
C
      CALL SETSYM(SSTR,IG,IGG,KG,ID,CHT,NGE0,N,N7,IY,SSP)
      WRITE(3,3008)SSTR,IG,IGG,KG
3008  FORMAT(' Symmetry: ',A3,/,' group # ',I2,' group order: ',I2,
     1       ' # of symmetry species: ',I2,/,/,
     2       ' Character table:',/)
      DO 51 I=1,KG
51    WRITE(3,3010) SSP(I),(CHT(I,J),J=1,KG)
3010  FORMAT(A3,2X,24I3)
      WRITE(3,*) ' Symmetry species of normal modes:'
      DO 50 I=N7,N
50    WRITE(3,3009)I,E(I)*CM,IY(I),SSP(IY(I))
3009  FORMAT(I4,F10.2,I4,3X,A3)
C
c     substitute frequencies if desired:
      IF(NZF.GT.0)WRITE(3,3004)
3004  FORMAT(/,
     1' Additional perturbation created, the original harmonic      ',/,
     2' frequency replaced by an arbitrary value, the perturbational',/,
     3' potential is thus                                           ',/,
     4'                     VE = (1/2)(W0*W0-Warb*Warb)* Q*Q        ',/,
     5'                        = (1/2) CE * Q * Q                   ',/,
     6'                        = (1/2)(W0*W0-Warb*Warb)/Warb * q * q',/,
     7'                        = (1/2) ce * q * q                   ',/,
     8/,
     9'       old frequency  basis forming frequency  ce [cm-1]     ')
      DO 48 I=1,NZF
      WF(I)=WF(I)/CM
C     Imaginary frequencies are given as negative, WF>0
      EIQ(I)=(ABS(E(IWF(I)))*E(IWF(I))-WF(I)*WF(I))/WF(I)
C     The E coefficient in the dimensionless coordinates
      WRITE(3,3005)I,IWF(I),E(IWF(I))*CM,WF(I)*CM,EIQ(I)*CM
3005  FORMAT(1X,2I3,3F15.2)
C     Oldies saved into the WF
      A=WF(I)
      WF(I)=E(IWF(I))
48    E(IWF(I))=A
      IAH=0
      CALL TERMO(E,N7,N,IAH)

      CALL CONTROL(S,FCAR0,N,N7,stol,E,AM)
c
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c
c     transform anharmonic constants
      IF(.not.lnm)THEN
c      if(.not.licore.and.lg98)call report('only core for g98')
       if(licore)then
        CALL DOCQI(S,N,LP3,HW,N7,tol3,NCAN,ICAN)
       else
        CALL DOCQ(S,N,LP3,HW,N7,LXS,YLIM,NCAN,ICAN,tol3)
       endif
       IF(QUARTIC)then
        if(L36.or.L37)then
         CALL DOD36I(S,N,LP4,HW,N7,tol4,lqfull,L37)
        else
         if(licore)then
          CALL DODQI(S,N,LP4,HW,N7,tol4,NCAN,ICAN)
         else
          CALL DODQ(S,N,L4,N7,HW,LP4,IP4,LXS,
     1   XLIM,NCAN,ICAN,tol4)
         endif
         CALL DOD2QI(S,N,LP4,HW,N7,tol4)
        endif
       endif
      ENDIF
      call doteni(S,N,N7)

      IF(LH40)CALL ROTCO(R,N7,N,HW,AH4L)
c
c     phase integral computations:
      IF(LPHASE)CALL PHASE(EPHA,ASL)
      IF(LPHASE)CALL PHASEEF(EPHA,ASL)
c
c     phase frequency ansatz, if requested:
      IF(LANS)THEN
       IF(.NOT.LPHASE)
     1 CALL REPORT(' Phase integrals were not requested')
       NZF=N-N7+1
       WRITE(3,3004)
       DO 481 I=1,NZF
       WF(I)=EPHA(N7+I-1)
       IWF(I)=N7+I-1
       EIQ(I)=(ABS(E(IWF(I)))*E(IWF(I))-ABS(WF(I))*WF(I))/ABS(WF(I))
     1 +EIQ(I)*E(IWF(I))/WF(I)
       WRITE(3,3005)I,IWF(I),E(IWF(I))*CM,WF(I)*CM,EIQ(I)*CM
       A=WF(I)
       WF(I)=E(IWF(I))
481    E(IWF(I))=A
      ENDIF
c
c     check positiveness of frequencies:
      DO 40 I=N7,N
      WRITE(3,3006)I,E(I)*CM,SSP(IY(I))
3006  FORMAT(I4,F12.2,3X,A3)
      IF(E(I).LT.AMACH)CALL REPORT(' The harmonic energy is negative!')
40    CONTINUE

9999  continue
      if(Iset.eq.2)call prepc(N,HW,N7)

c     second order perturbation corrections:
      IF(LENA )CALL ENA(ASL,EOLD)
      IF(LENA2)CALL ENA2(ASL,EOLD)
      IF(LENAS)CALL ENA2S(ASL,EOLD,SSP)
      IF(LENAF)CALL ENAF(ASL,EOLD)
c
c     second order property computations:
      IF(lena3)CALL ENA3(ASL)
      IF(lprot)CALL prodert(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
c
c     vscf self-consistent field:
      IF(lvscf)call evscf(GVIB_VSCF_NBASE,N-N7+1,etem,N,N7)
c
c     variational computations in the selected basis:
      IF(LVAR)then
       inquire(file='STATES.SCR.TXT',exist=lex)
       if(lex.and.RDST)then
        write(6,6767)
        write(3,6767)
6767    format(' STATES.SCR.TXT found, RDST on, states read from disk')
        call vqqvcc
       else
        if(iexc.ne.0)then
         if(LCIA)then
          call setstate2(ASL,SSP,2)
         else
          call setstate2(ASL,SSP,0)
          if(iset.eq.4)call setstate2(ASL,SSP,1)
         endif
        else
         call setstate(ASL,SSP)
        endif
c       find second set of states interaction with those found:
        if(ldstate)call setstate3(ASL,OHD,SSP)
       endif
       CALL DOHBIG(IRQR,ASL,IDC,EOLD)
      endif
c
c     combined var-pert computation:
      IF(DC)CALL CORRECT(ASL,ASK)
c
c     spectra and property computation:
9777  if(lm4)call m4

      WRITE(6,*)' PROGRAM FINISHED OK'
      CLOSE(3)
      STOP
      END

      subroutine rfilex(NT0,NAT,N,N7,LINEAR,R,AM)
      implicit none
      integer*4 NT0,NAT,N,N7,i,ia,ix,iz
      real*8 R(NT0,3),AM(*),ASS,amave
      character*2 atsym
      logical LINEAR
      open(22,file='FILE.X',status='old')
      read(22,*)
      read(22,*)NAT
      if(NAT.gt.NT0)call report('Too many atoms')
      do 1 ia=1,NAT
      read(22,*)iz,(R(ia,ix),ix=1,3)
      atsym='??'
      ASS=amave(iz,atsym)
      if(AM(3*(ia-1)+1).lt.0.0d0)then
       do 2 i=1,3
2      AM(3*ia-3+i)=ASS
      endif
1     continue
      if(NAT.EQ.2.or.LINEAR)then
       N7=6
       LINEAR=.TRUE.
      endif
      N=3*nat
      close(22)
      return
      end
