      SUBROUTINE setstate2(ASL,SSP,ico)
c
c     define vibrational states in normal mode basis
c     and an OH interaction limit
c     algorithm for unlimited excitation number
c     iset=0 define states based on the interaction to fundamentals
c          4 define states based on the interaction to previous, too
c
c     ico=0 .. to ground + fundamentals
c         1 .. to existing
c         2 .. take all according to LEXCL
c
      implicit none
      integer*4 N,I,NHBIG,iex,Nexc,NGE0,NX4,nstart,
     1iopt,icem2,ic,ICS,NCSP,NXX,nend,k,ico,nh0,icen,NQ1
      include 'dimensions.h'
      parameter (NGE0=24,
     1NXX=NT3+NT3*(NT3-1)+(NT3*(NT3-1)*(NT3-2))/6,
     1NX4=NT3*((NT3*(NT3+1))/2))
      INTEGER*4 ielist,IYX(2,NGE0),NSL
      real*8 CiIJK,CS,ASL,EI,EJ,HOFF,B
      integer*4 IT(NM0),IS(NM0),ICC(NM0,ME0),
     1IBIGSYM(NM0),IN(NM0,ME0),si(ME0)
      COMMON/DIA1/NHBIG,IT,IS,IBIGSYM,ICC,IN
      COMMON/DIA2A/CiIJK(NT3,NT3,NT3)
      COMMON/DIA2B/CS(NXX),ICS(3,NXX),NCSP
      real*8 ropt,OH,DOH
      COMMON/opt/ropt(100)
      equivalence (OH,ropt(15)),(DOH,ropt(16))
      COMMON/iop/iopt(300)
      equivalence (NQ1,iopt(1)), (icem2,iopt(10)),(iset,iopt(2))
      common/qxcc/ielist(NT3)
      real*8 A
      integer*4 STATE1(NT3),STATE(NT3),I0
      LOGICAL L4
      INTEGER*4 N7
      COMMON/SUM/A,STATE1,STATE,N7,N,L4
      real*8 E
      COMMON/CEM/E(NT3)
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      integer*4 NZF,IBR,IERM,ICAN,IER,II,ISB,iset,J,NCAN
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      real*8 CQ4,DS
      integer*4 IDS,NDSP
      COMMON/VQA/CQ4(NT3,NT3,NT3)
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      integer*4 LEXCL
      COMMON/RUNCON/LEXCL
      integer*4 IY,IG,IGG,KG,ID,CHT(NGE0,NGE0),GAMA(NGE0),GI(NGE0)
      character*3 SSTR,SSP(NGE0)
      COMMON/SYMCOM/IY(NT3),CHT,IG,IGG,KG,ID(NGE0),SSTR
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent


c
      call w36(' ')
      call w36('Setstate2')
      call w36('^^^^^^^^^')

      if(ico.eq.0)then
       call w36('constructing states interacting with ground'//
     1 ' and fundamentals')
       NHBIG=0
       nh0=0
       call statereport(N-N7+1)
      else
       if(ico.eq.1)then
        call w36('constructing states interacting with existings')
        nh0=NHBIG
       else
        call w36('constructing states all according to LEXCL')
        nh0=0
        NHBIG=0
       endif
      endif

      do 2 I=1,2
      do 2 II=1,NGE0
2     IYX(I,II)=0

22221 DO 337 I=1,N
      STATE1(I)=0
337   STATE(I)=0

c     record state for the LFF faster option:
      S1_Ncent=0
      S1_Nexc=0
      S2_Ncent=0
      S2_Nexc=0

      write(6,6001)iset,NHBIG,N7,N,LEXCL,OH,NQ1
      write(3,6001)iset,NHBIG,N7,N,LEXCL,OH,NQ1
6001  format(' Constructing basis functions in setstate2',/,
     1'iset:',i5,' NHBIG:',I8,/,
     1'  N7:',I5,' N:',i5,' LEXCL:',i5,' V-limit ',F10.6,' cm-1',/,
     1' NQ1:',I5,/,/,
     2' mode   maximal excitation')

      NSL=0
      do 1 I=N7,N
      if(ielist(I).gt.0)NSL=I
      write(3,6002)I,ielist(I)
1     write(6,6002)I,ielist(I)
6002  format(7(i5,i4))

      write(6,6003)NSL
      write(3,6003)NSL
6003  format(/,' Upper limit upper limit of excited states:',i5,/)
      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      call vqqvcc

C     Ground state-always:
      if(ico.eq.0.or.ico.eq.2)then
       NHBIG=NHBIG+1
       IS(NHBIG)=0
       IT(NHBIG)=0
       DO 5011 J=1,LEXCL
       ICC(NHBIG,J)=0
5011   IN(NHBIG,J)=0
      endif
c
c     states Nexc excited
      do 3 Nexc=1,LEXCL
      write(6,*)Nexc,NHBIG

c     distribute Nexc excitations upon centers N7..NSL:
c     initial indices - all to the first center:
      do 41 iex=1,Nexc
41    si(iex)=N7
5     DO  1966 I=N7,NSL
1966  STATE(I)=0
      if(HW)write(6,6000)(si(i),i=1,Nexc)
6000  format(20i3)
      do 4 iex=1,Nexc
4     state(si(iex))=state(si(iex))+1
c     check that the state is allowed:
      icen=0
      do 11 I=N7,NSL
      if(state(I).gt.0)icen=icen+1
11    if(state(I).gt.ielist(I))goto 12
      if(icen.gt.NQ1)goto 12
c
c     check that the state interacts with the ground and fundamentals
c     for iset=4 also with the existing ones
C     Define state j:
      EJ=0.0d0
      DO 1002 II=N7,NSL
1002  EJ=EJ+dble(state(II))*E(II)
c     record to newer coding:
      call rcstate(S2_Ncent,S2_Nexc,S2_Lcent,S2_Lexc,STATE,N7,NSL)

      if(ico.eq.0)then
       nstart=N7-1
       nend=NSL
      else
c      check, if it exists
       do 1006 I0=1,nh0
       DO 1007 II=N7,NSL
1007   STATE1(II)=0
       do 1008 K=1,IS(I0)
1008   STATE1(ICC(I0,K))=IN(I0,K)
       DO 1009 II=N7,NSL
1009   if(STATE1(II).ne.state(II))goto 1006
       goto 12
1006   continue
       nstart=1
       nend=nh0
      endif
c
c     just take it for ico=2
      if(ico.eq.2)then
       CALL REP33(state,0.0d0,IER)
       IF(IER.EQ.1)call report('too many states')
       goto 1004
      else
c      monoexcited always
       if(S2_Nexc.eq.1)then
        CALL REP33(state,0.0d0,IER)
        IF(IER.EQ.1)call report('too many states')
       else
c
c       investigate the interaction:
c       <STATE |  V  | STATE1>
c       <S2    |  V  | S1    >
c           j           i       i=ground or monoexc
        do 1000 I0=nstart,nend
C       Define state i:
        EI=0.0d0
        DO 1001 II=N7,NSL
1001    STATE1(II)=0
        if(ico.eq.0)then
         if(I0.ge.N7)then
          STATE1(I0)=1
          EI=EI+E(I0)
         endif
        else
         do 1005 K=1,IS(I0)
         EI=EI+dble(IN(I0,K))*E(ICC(I0,K))
1005     STATE1(ICC(I0,K))=IN(I0,K)
        endif
c       record to newer coding:
        call rcstate(S1_Ncent,S1_Nexc,S1_Lcent,S1_Lexc,STATE1,N7,NSL)

        A=0.0d0
C       Cubic term
        IF(LSPARSE)THEN
         CALL SUMSGHOST
        ELSE
         CALL SUMS
        ENDIF
        HOFF=A

C       Quartic
        IF(LQD)THEN
         A=0.0d0
         IF(LSPARSE)THEN
          CALL SUMSQGHOST
         ELSE
          CALL SUMSQ
         ENDIF
         HOFF=HOFF+A
        ENDIF

        B=0.0d0
        if(dabs(EI-EJ).gt.1.0d-9)B=dabs(HOFF/(EI-EJ))
        IF(B.GT.OH)THEN

c        write(6,*)' state:'
c        write(6,6009)NHBIG
c009     format(I10,' ',$)
c        do ii=N7,N
c         write(6,6019)state(ii)
c019      format(i1,$)
c        enddo
c        write(6,*)
c        write(6,*)'interacting with:'
c        write(6,6009)I0
c        do ii=N7,N
c         write(6,6019)state1(ii)
c        enddo
c        write(6,*)
c        write(6,*)' B OH :',B,OH

         CALL REP33(state,B,IER)
c        to many states, try again:
         IF(IER.EQ.1)GOTO 22221
         goto 1004
        ENDIF
1000    continue
       endif
      endif
c
1004  continue
c
c     find index to be changed
12    do 8 ic=Nexc,1,-1
8     if(si(ic).lt.NSL)goto 9
      goto 3
9     do 10 i=ic+1,Nexc
10    si(i)=si(ic)+1
      si(ic)=si(ic)+1
c
      goto 5
c
3     continue
C
C
      if(iset.lt.2.or.iset.ge.4)then
      CALL  FINDSYM(NHBIG,IS,ICC,IN,IBIGSYM,IY,N,KG,
     1CHT,N7,NGE0,NT3,GAMA,GI,NM0,LEXCL)
      WRITE(3,*)' States to be ordered according to the symmetry'
      WRITE(6,*)' States to be ordered according to the symmetry'
      CALL SYMORDER(IYX,ISB,KG,SSP,LEXCL)
      else
      ISB=1
      IYX(1,1)=1
      IYX(2,1)=NHBIG
      endif
c
      WRITE(3,*)ISB,' symmetry blocks found'
      DO 93 J=1,ISB
93    WRITE(3,*)J,' : ',IYX(1,J),' - ',IYX(2,J)
C
      WRITE(3,3005)N-N7+1,NHBIG
      WRITE(6,3005)N-N7+1,NHBIG
3005  FORMAT(I20,' FUNDAMENTALS',/,
     1       I20,' STATES IN THE HAMILTONIAN')
      CALL WS(ISB,IYX)
C
      call w36('Setstate3-ok')

      RETURN
      END
c     ============================================================
      subroutine rcstate(S_Ncent,S_Nexc,S_Lcent,S_Lexc,STATE,N7,N)
      implicit none
      integer*4 S_Ncent,S_Nexc,S_Lcent(*),S_Lexc(*),STATE(*),N7,N,I
      S_Ncent = 0
      S_Nexc  = 0
      DO 1 I = N7,N
      IF(STATE(I).GT.0)THEN
       S_Ncent =S_Ncent+1
       S_Nexc  =S_Nexc+STATE(I)
       S_Lcent(S_Ncent) =       I
       S_Lexc( S_Ncent) = STATE(I)
      ENDIF
1     CONTINUE
      return
      end
