      SUBROUTINE setstate3(ASL,OHD,SSP)
c
c     read STATES.SCR.TXT and
c     define vibrational states in normal mode basis
c     using OHD interaction limit
c     algorithm for unlimited excitation number
c
c
      implicit none
      integer*4 N,I,NHBIG,iex,Nexc,NGE0,ic,k,nh0,nme
      include 'dimensions.h'
      parameter (NGE0=24)
      INTEGER*4 ielist,IYX(2,NGE0)
      real*8 ASL,EI,EJ,HOFF,B,OHD
      integer*4 IT(NM0),IS(NM0),ICC(NM0,ME0),
     1IBIGSYM(NM0),IN(NM0,ME0),si(ME0)
      COMMON/DIA1/NHBIG,IT,IS,IBIGSYM,ICC,IN
      common/qxcc/ielist(NT3)
      real*8 A
      integer*4 STATE1(NT3),STATE(NT3),I0,NSL
      LOGICAL L4
      INTEGER*4 N7
      COMMON/SUM/A,STATE1,STATE,N7,N,L4
      real*8 E
      COMMON/CEM/E(NT3)
      LOGICAL HW,DC,QUARTIC,LBLOCK,LO,LQD,LMITIN,
     1LSPARSE,LH40
      integer*4 NZF,IBR,IERM,ICAN,IER,II,ISB,J,NCAN
      COMMON/OPTS/LBLOCK,LO,LQD,LMITIN,LSPARSE,LH40,
     1HW,DC,QUARTIC,NCAN,ICAN(NT3),NZF,IBR,IERM
      integer*4 LEXCL
      COMMON/RUNCON/LEXCL
      integer*4 IY,IG,IGG,KG,ID,CHT(NGE0,NGE0),GAMA(NGE0),GI(NGE0)
      character*3 SSTR,SSP(*)
      COMMON/SYMCOM/IY(NT3),CHT,IG,IGG,KG,ID(NGE0),SSTR
      integer*4 S1_Nexc,S1_Ncent,S1_Lexc(ME0),S1_Lcent(ME0),
     1          S2_Nexc,S2_Ncent,S2_Lexc(ME0),S2_Lcent(ME0)
      common/sumff/S1_Nexc,S1_Ncent,S1_Lexc,S1_Lcent,
     1             S2_Nexc,S2_Ncent,S2_Lexc,S2_Lcent
      integer*4 iopt,NQ1
      common/iop/iopt(300)
      equivalence (NQ1,iopt(1))


      call w36(' ')
      call w36('Setstate3')
      call w36('^^^^^^^^^')
c
c     read states:
      call readstates(nh0,N7,N,NM0,IS,IBIGSYM,IT,ICC,IN,ISB,
     1IYX,ME0,NGE0)
      NHBIG=nh0

      write(6,6001)nh0,N7,N,LEXCL,OHD
      write(3,6001)nh0,N7,N,LEXCL,OHD
6001  format(' Constructing basis functions in setstate3',/,
     1' Old NHBIG:',I7,/,
     1'N7:',I5,' N:',i5,' LEXCL:',i5,' V-limit ',F10.6,' cm-1',/,/,
     2' mode   maximal excitation')

      NSL=0
      do 1 I=N7,N
      if(ielist(I).gt.0)NSL=I
      write(3,6002)I,ielist(I)
1     write(6,6002)I,ielist(I)
6002  format(7(i5,i4))

      write(6,6003)NSL
      write(3,6003)NSL
6003  format(/,' Upper limit upper limit of excited states:',i5,/)


      call LOADCDS(N7,N,E,QUARTIC,LSPARSE,ASL,L4,LH40,HW)
      call vqqvcc

c     states Nexc excited
      do 3 Nexc=1,LEXCL
      write(6,*)Nexc,NHBIG

c     distribute Nexc excitations upon centers N7..NSL:
c     initial indices - all to the first center:
      do 41 iex=1,Nexc
41    si(iex)=N7
5     DO  1966 I=N7,NSL
1966  STATE(I)=0
      if(HW)write(6,6000)(si(i),i=1,Nexc)
6000  format(20i3)
      do 4 iex=1,Nexc
4     state(si(iex))=state(si(iex))+1

c     check that the state is allowed:
      nme=0
      do 11 I=N7,NSL
      if(state(I).gt.0)nme=nme+1
11    if(state(I).gt.ielist(I))goto 12
      if(nme.gt.NQ1)goto 12

c
c     check that the state interacts with the existing ones
C     Define state j:
      EJ=0.0d0
      DO 1002 II=N7,NSL
1002  EJ=EJ+dble(state(II))*E(II)
c     record to newer coding:
      call rcstate(S2_Ncent,S2_Nexc,S2_Lcent,S2_Lexc,STATE,N7,NSL)

c     check, if it is already in:
      do 1006 I0=1,nh0
      DO 1007 II=N7,NSL
1007  STATE1(II)=0
      do 1008 K=1,IS(I0)
1008  STATE1(ICC(I0,K))=IN(I0,K)
      DO 1009 II=N7,NSL
c     the state differs from I0:
1009  if(STATE1(II).ne.state(II))goto 1006
c     the state was same as I0,go to a next one:
      goto 12
1006  continue

c     investigate the interaction to the previous set:
      do 1000 I0=1,nh0
C     Define state i:
      EI=0.0d0
      DO 1001 II=N7,NSL
1001  STATE1(II)=0
      do 1005 K=1,IS(I0)
      EI=EI+dble(IN(I0,K))*E(ICC(I0,K))
1005  STATE1(ICC(I0,K))=IN(I0,K)
      call rcstate(S1_Ncent,S1_Nexc,S1_Lcent,S1_Lexc,STATE1,N7,NSL)

      A=0.0d0
C     Cubic term:
      IF(LSPARSE)THEN
       CALL SUMSGHOST
      ELSE
       CALL SUMS
      ENDIF
      HOFF=A

C     Quartic:
      IF(LQD)THEN
       A=0.0d0
       IF(LSPARSE)THEN
        CALL SUMSQGHOST
       ELSE
        CALL SUMSQ
       ENDIF
       HOFF=HOFF+A
      ENDIF

      B=HOFF
      if(dabs(EI-EJ).gt.1.0d-9)B=dabs(HOFF/(EI-EJ))
      IF(B.GT.OHD)THEN
c      large interaction, take this state:
       CALL REP33(state,B,IER)
       IF(IER.EQ.1)call report('too many states in setstate3')
       goto 1004
      ENDIF
1000  continue
c
1004  continue
c
c     find index to be changed
12    do 8 ic=Nexc,1,-1
8     if(si(ic).lt.NSL)goto 9
      goto 3
9     do 10 i=ic+1,Nexc
10    si(i)=si(ic)+1
      si(ic)=si(ic)+1
c
      goto 5
c
3     continue
C
      CALL  FINDSYM(NHBIG,IS,ICC,IN,IBIGSYM,IY,N,KG,
     1CHT,N7,NGE0,NT3,GAMA,GI,NM0,LEXCL)
      call w36(' States to be ordered according to the symmetry')
      CALL SYMORDER(IYX,ISB,KG,SSP,LEXCL)
c
      WRITE(3,*)ISB,' symmetry blocks found'
      DO 93 J=1,ISB
93    WRITE(3,*)J,' : ',IYX(1,J),' - ',IYX(2,J)
C
      WRITE(3,3005)N-N7+1,NHBIG
      WRITE(6,3005)N-N7+1,NHBIG
3005  FORMAT(I20,' FUNDAMENTALS',/,
     1       I20,' STATES IN THE HAMILTONIAN')
c     rewrite STATES.SCR.TXT:
      CALL WS(ISB,IYX)
C
      call w36('Setstate3-ok')
      RETURN
      END
