      SUBROUTINE SUMSQGHOSTP
C     A = (1/24) < STATE1 | SUMij  Diijj QiQiQjQj | STATE2>
C       + (1/24) < STATE1 | SUMijk "Diijk" type   | STATE2> if L4 is TRUE
C     for a sparse quartic force field
c     parallel version
      IMPLICIT none
      INTEGER*4 NX4
      include 'dimensions.h'
      PARAMETER (NX4=NT3*((NT3*(NT3+1))/2))
      INTEGER*4 STATE1(NT3),STATE2(NT3),S1,S2,PR,IDS,NDSP,NDSP2,
     1iopt,nproc,omp_get_num_procs,nd,
     2nrest,II,JJ,IC,i,j,k,IQ,N7,N,omp_get_thread_num
      LOGICAL L4
      COMMON/SUM/SUM,STATE1,STATE2,N7,N,L4
      REAL*8 DS,S11,S22,S33,S44,SUM
      COMMON/VQB/DS(NX4),IDS(3,NX4),NDSP
      COMMON/VQ2N/NDSP2
      common/iop/iopt(300)
      equivalence (nproc,iopt(14))

      if(NDSP2.ne.0)then
       call sumsq2ghost
       return
      endif
c
c     set up parallel parameters:
      if(nproc.gt.nproc0)call report('too many processors requested')
      if(nproc.gt.omp_get_num_procs())
     1call report('not enough processors')
      call omp_set_num_threads(nproc)
      call omp_set_dynamic(0)
      call omp_set_nested(0)
c
      S11=0.0d0
      S22=0.0d0
      S33=0.0d0
      S44=0.0d0
c

C$OMP PARALLEL DO
C$OMP+ DEFAULT(SHARED) REDUCTION(+:S11,S22,S33,S44)
C$OMP+ PRIVATE(IC,I,J,K,PR,IQ,S1,S2,II,JJ)

      DO 1000 IC=1,NDSP
      I=IDS(1,IC)
      J=IDS(2,IC)
      K=IDS(3,IC)
C     iijk, j<k, for terms iijj ii=<jj
C
C     Term iijk, i<>j,k>j,k<>i
C     iijk=iikj=ijki=ikji=ijik=ikij=jkii=kjii=jiki=kiji=jiik=kiij
      IF((I.NE.J.AND.K.NE.J).AND.K.NE.I)THEN
      PR=1
      DO 7 IQ=N7,N
      IF(IQ.NE.I.AND.IQ.NE.J.AND.IQ.NE.K)THEN
C      <S1|S2>(IQ)
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 7
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(IQ.EQ.I)THEN
C      <S1|Q^2|S2>(IQ),IQ I
       IF(S1.EQ.S2+2)THEN
        PR=PR*S1*(S1-1)
        GOTO 7
       ENDIF
       IF(S1.EQ.S2-2)THEN
        PR=PR*S2*(S2-1)
        GOTO 7
       ENDIF
       IF(S1.EQ.S2)THEN
        PR=PR*(2*S1+1)*(2*S1+1)
        GOTO 7
       ENDIF
       GOTO 1000
      ENDIF
C     IQ is ether J or K
C     <S1|Q|S2>(IQ),IQ=J,K
      IF(S1.EQ.S2+1)THEN
       PR=PR*S1
       GOTO 7
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*S2
       GOTO 7
      ENDIF
      GOTO 1000
7     CONTINUE
      S44=S44+DSQRT(DBLE(PR))*DS(IC)
      GOTO 1000
      ENDIF
c
c     TERMS  iiij=iiji=ijii=jiii and iiij=iiji=ijii=jiii
      IF(I.EQ.J.AND.K.GT.J)THEN
       II=I
       JJ=K
       GOTO 2000
      ENDIF
      IF(I.EQ.K.AND.K.GT.J)THEN
       II=I
       JJ=J
       GOTO 2000
      ENDIF
c
C     Term  iijj=jjii=ijij=jiji=jiij=ijji, j>i, omit j<i
      IF(J.EQ.K.AND.J.GT.I)THEN
      PR=1
      DO 3 IQ=N7,N
      IF(IQ.NE.I.AND.IQ.NE.J)THEN
C     <S1|S2>(IQ)
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 3
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
C     <S1|Q^2|S2>(IQ),IQ is either I or J
      IF(S1.EQ.S2+2)THEN
       PR=PR*S1*(S1-1)
       GOTO 3
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=PR*S2*(S2-1)
       GOTO 3
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=PR*(2*S1+1)*(2*S1+1)
       GOTO 3
      ENDIF
      GOTO 1000
3     CONTINUE
      S22=S22+DSQRT(DBLE(PR))*DS(IC)
c
      GOTO 1000
      ENDIF
C
C     Term iiii
      IF(I.EQ.J.AND.J.EQ.K)THEN
      DO 5 IQ=N7,N
      IF(IQ.NE.I)THEN
       IF(STATE1(IQ).EQ.STATE2(IQ)) GOTO 5
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(S1.EQ.S2-4)THEN
       PR=S2*(S2-1)*(S2-2)*(S2-3)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+4)THEN
       PR=S1*(S1-1)*(S1-2)*(S1-3)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2-2)THEN
       PR=(4*S2-2)*(4*S2-2)*S2*(S2-1)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2+2)THEN
       PR=(4*S1-2)*(4*S1-2)*S1*(S1-1)
       GOTO 5
      ENDIF
      IF(S1.EQ.S2)THEN
       PR=(6*S1*S1+6*S1+3)*(6*S1*S1+6*S1+3)
       GOTO 5
      ENDIF
      GOTO 1000
5     CONTINUE
C     <S1|Diiii|S2>
      S11=S11+DSQRT(DBLE(PR))*DS(IC)
c
      GOTO 1000
      ENDIF
C
2000  PR=1
C     TERM <S1|Qii^3Qj|S2>
      DO 6 IQ=N7,N
      IF(IQ.NE.II.AND.IQ.NE.JJ)THEN
C     <S1|S2>(IQ)
       IF(STATE1(IQ).EQ.STATE2(IQ))GOTO 6
       GOTO 1000
      ENDIF
      S1=STATE1(IQ)
      S2=STATE2(IQ)
      IF(IQ.EQ.II)THEN
C      <S1|Q^3|S2>(IQ),IQ II
       IF(S1.EQ.S2+3)THEN
        PR=PR*S1*(S1-1)*(S1-2)
        GOTO 6
       ENDIF
       IF(S1.EQ.S2-3)THEN
        PR=PR*S2*(S2-1)*(S2-2)
        GOTO 6
       ENDIF
       IF(S1.EQ.S2+1)THEN
        PR=PR*9*S1*S1*S1
        GOTO 6
       ENDIF
       IF(S1.EQ.S2-1)THEN
        PR=PR*9*S2*S2*S2
        GOTO 6
       ENDIF
       GOTO 1000
      ENDIF
C     <S1|Q|S2>(IQ),IQ=JJ
      IF(S1.EQ.S2+1)THEN
       PR=PR*S1
       GOTO 6
      ENDIF
      IF(S1.EQ.S2-1)THEN
       PR=PR*S2
       GOTO 6
      ENDIF
      GOTO 1000
6     CONTINUE
      S33=S33+DSQRT(DBLE(PR))*DS(IC)
1000  continue


C$OMP  END PARALLEL DO

      SUM=0.01041666666d0*(S11+6.0d0*S22+4.0d0*S33+12.0d0*S44)
C     0.0104167=(1/4)*(1/24)
      RETURN
      END
