      SUBROUTINE TERMO(W,N1,NA,IAH)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      DIMENSION W(NA)
C     Thermodynamics according to Mopac notation
C     1cm-1=1.4388 K= 2.8601 cal/mol
      CM=219470.0
      MV=0
      IF(IAH.EQ.1)THEN
       WRITE(3,16004)MV
       WRITE(6,16004)MV
16004 FORMAT(/,
     1' Thermochemistry',/,
     2' Anharmonic parameters, contribution from first ',I4,' states',/,
     1' Not implemented yet')
       RETURN
      endif
      ELIM=0.1
      E0=0.0d0
C     Zero temperature
      DO 1 I=N1,NA
      WI=W(I)*CM
      IF(WI.LE.ELIM)GOTO 1
      E0=E0+0.5*WI
1     CONTINUE
      E0=E0*2.8601
C     cal/mol
C     Room temperature
      T=298.15
      Cl=1.4388/T
      Qv=0.0d0
      E0T=0.0d0
      S=0.0d0
      SP=0.0d0
      C=0.0d0
      DO 2 I=N1,NA
      WI=W(I)*CM
      IF(WI.LE.ELIM)GOTO 2
      EWJ=0.0d0
      IF(WI*Cl.LT.200.0)EWJ=EXP(-WI*Cl)
      Qv=Qv+1.0d0/(1.0-EWJ)
      E0T=E0T+WI*EWJ/(1.0-EWJ)
      S=S+WI*EWJ/(1.0-EWJ)
      SP=SP+LOG(1.0-EWJ)
      C=C+WI**2*EWJ/(1.0-EWJ)**2
2     CONTINUE
      E0T=E0T*2.8601
      S=S*2.8601/T-SP*1.987216
C     cal/mol/K
      C=C*Cl**2*1.987216
C     cal/mol/K
      WRITE(3,16001)
16001 FORMAT(/,' Thermochemistry parameters',/,80(1H-),/,
     1' The harmonic limit')
      WRITE(3,16000)E0,E0+E0T,S,C,Qv,E0+E0T-T*S
16000 FORMAT(
     1' Vibrational contributions:',/,/,
     2' Internal energy 0K   : U0 = ',F23.5,' cal/mol',/,
     2' Internal energy 298K : U  = ',F23.5,' cal/mol',/,
     3' Entropy         298K : S  = ',F23.5,' cal/mol/K',/,
     4' Heat capacity   298K : C  = ',F23.5,' cal/mol/K',/,
     5' Partition function   : Qv = ',F23.5,/,
     6' Gibbs free energy    : G  = ',F23.5,' cal/mol/K',/,
     780(1H-),/,/)
      RETURN
      END
